<?php
/**
 * $Id: config.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
class CommerceControllerConfig extends JController
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'apply', 'save' );
		JRequest::setVar( 'view', 'config' );
	}

	function display()
	{
		JRequest::setVar( 'view', 'config' );
		parent::display();
	}

	function apply()
	{
		$this->save();
	}

	function save()
	{
		global $mainframe;

		$task = JRequest::getCmd( 'task' );

		foreach ($_POST['params'] as $var => $val) {
			if(is_array($val)) $_POST['params'][$var] = implode(";", $val);
		}

		$params = new JParameter( $_POST['params'], JPATH_COMPONENT_ADMINISTRATOR.DS.'params.xml' );
		$params->bind( $_POST['params'] );
		$ini = $params->toString();

		JFile::write( JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini',  $ini );

		$msg = JText::_( 'Successfully Saved Configuration' );
		switch ( $task ) {
			case 'apply':
				$mainframe->redirect( 'index.php?option=com_commerce&controller=config', $msg );
				break;
			case 'save':
			default:
				$mainframe->redirect( 'index.php?option=com_commerce', $msg );
				break;
		}
	}

	function cancel()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce';
		$mainframe->redirect( $link );
	}

	function set( $key, $value, $group = '_default' )
	{
		global $JS_params_obj;

		if( ! isset($JS_params_obj) ){
			JError::raiseWarning( 500, JText::_('Config controller is not initialised.') );
			return false;
		}

		$JS_params_obj->set( $key, $value, $group );

		$ini = $JS_params_obj->toString();

		JFile::write( JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini', $ini );

		return true;
	}

	function initialyze($comm_params = false, $comm_secid = false)
	{

		if($comm_params)
		{
			$comm_params->set('comm_lay_icons_dir', 'default');
			$comm_params_arr = $comm_params->toArray();
			
			foreach ($comm_params_arr as $key => $val)
			{
				if(strstr($key, 'comm_'))
				{					
					if(defined(strtoupper($key))){
						continue;
					}
					if(is_array($val)) $val = serialize($val);
					define(strtoupper($key), $val, true);
				}
			}
			if(!defined('COMM_SECTION_ID')) define('COMM_SECTION_ID', $comm_secid);
		}
		$uri = & JFactory::getURI();

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.archive');

		$ini = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_commerce'.DS.'config.ini';
		if(!file_exists($ini))
		return;
		
		$ini = JFile::read( $ini );

		$config_params = new JParameter( $ini,  JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_commerce'.DS.'params.xml' );

		$GLOBALS[ 'JS_params_obj' ] = $config_params ;

		$params_array = $config_params->toArray();
		
		foreach($params_array AS $key => $val){
			$name = strtoupper('COMM_'.$key);
			
			if(defined(strtoupper($name))){
				continue;
			}
			if(is_array($val)) $val = serialize($val);

			define(strtoupper($name), $val, true);
		}
		if(!defined('COMM_ENABLED')) define('COMM_ENABLED', COMM_OFFLINE);

	}
}
?>