<?php
/**
 * $Id: orders.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
class CommerceControllerOrders extends JController
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'confirm', 'confirm' );
	}

	function display()
	{
		JRequest::setVar( 'view', 'orders' );
		parent::display();
	}

	function cancel()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&controller=orders';
		$mainframe->redirect( $link );
	}

	function details()
	{
		global $mainframe;
		$cid = JRequest::getVar('cid');
		$link = 'index.php?option=com_commerce&controller=orders&layout=details&cid[]='.$cid[0];
		$mainframe->redirect( $link );
	}

	function deduct()
	{
		global $mainframe, $option;
		$db = JFactory::getDBO();
		$cid = JRequest::getVar('cid');
		$model = $this->getModel('Orders', 'CommerceModel');
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_commerce'.DS.'models');
		$msg = '';
		foreach($cid as $oid)
		{
			$res = $model->getSectionParams($oid);
			$section_id = $res[0];
			$CP = $res[1];
			if($CP->get('comm_enabled'))
			{
				if(!$CP->get('comm_multi_seller'))
				{
					$msg = JText::_('Some orders were made in commercial section with single seller');
					continue;
				}
				else
				{
					if($CP->get('comm_payment_method') == 'personal')
					{
						$msg = JText::_('Some orders were made with Personal payment method');
					}
					if($CP->get('comm_payment_method') == 'global')
					{
						$seller_id = JRequest::getInt('seller_id');

						$model_balance = &JModel::getInstance('balance', 'CommerceModel');

						$items = $model_balance->getOrderSellers($oid, $section_id);

						$sellers = array();

						foreach($items as $item)
						{
							$credit = 0;
							$debit = 0;
							$current_balance = 0;
							$current_balance = $model_balance->getCurrentBalance($item->seller_id, $section_id);
							$balance = round($item->balance, 2);
							if($shipping = $model_balance->getOrderShipping($oid))
							{
								$balance += $shipping->price;
							}
							$procent = $CP->get('comm_percentage');
							$transact = $CP->get('comm_transaction');
							$commission = round($balance * $CP->get('comm_percentage') / 100 , 2) + $CP->get('comm_transaction');
							if($commission < $CP->get('comm_comm_min'))
							{
								$commission = $CP->get('comm_comm_min');
								$procent = 0;
								$transact = $commission;
							}
							$balance = $balance - $commission;
							$credit = $balance;
							$balance = $current_balance + $balance;

							$sql = "INSERT INTO #__jc_users_balance VALUES
							('', '{$item->seller_id}', NOW(), 'order', '$oid', '$debit', '$credit', '$balance',
							'$procent', '$transact', '".$section_id."')";
							$db->setQuery($sql);
							$db->query();
							$sql = "UPDATE #__jc_users SET balance_id='".$db->insertid()."'
							WHERE user_id = '{$item->seller_id}' AND section_id = '".$section_id."'";
							$db->setQuery($sql);
							$db->query();
							$sellers[] = $item->seller_id;

						}
						$sql = "UPDATE #__jc_orders SET deducted='1' WHERE id = '$oid'";
						$db->setQuery($sql);
						$db->query();
						$sql = "UPDATE #__jc_orders_products SET status_id='2' WHERE order_id = '$oid' AND price + affect_sum > 0";
						$db->setQuery($sql);
						$db->query();
						if(count($sellers))
						$this->sendSellerAlert($oid, $sellers, $section_id);						
					}
				}
			}
			$sql = "SELECT invoice_id FROM #__jc_orders WHERE id = '$oid' AND pay = 'offline'";
			$db->setQuery($sql);
			if($inv = $db->loadResultArray())
			{
				JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsbill'.DS.'tables');
				JModel::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsbill'.DS.'models');
				$bill_model = JModel::getInstance('Bills', 'BillModel');
				require_once (JPATH_ADMINISTRATOR . DS . 'components'.DS. 'com_jsbill'. DS . 'controllers' . DS . 'cnf.php' );
				BillControllerCnf::initialyze ();
				$bill_model->publish($inv);
			}

		}
		$context = "$option.view_orders";
		$mainframe->setUserState( $context.'filter_offline',	1);
		$filter_offline = $mainframe->getUserStateFromRequest( $context.'filter_offline',	'filter_offline',	'');
		$mainframe->redirect( 'index.php?option=com_commerce&controller=orders' , $msg);
	}

	function sendSellerAlert($oid, $sellers, $section_id)
	{
		$db = JFactory::getDBO();
		$config = JFactory::getConfig();
		jimport('joomla.mail.mail');
		jimport('joomla.mail.helper');

		$subject = JText::_("Order has been accepted on [SITE_NAME]");
		$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);

		$body = JText::_('OFFLINE_ACCEPTED_ALERT');
		$body = str_replace('[ORDER_ID]', $oid, $body);
		$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
		$body = str_replace('[SITE_URL]', JURI::root(), $body);
		$history_link = JURI::root().'index.php?option=com_commerce&view=orders&order_id='.$oid.'&section_id='.$section_id.'&Itemid='.( (COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid'));
		$body = str_replace('[ORDER_LINK]', $history_link, $body);

		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');

		$mail = JFactory::getMailer();
		$sql = "SELECT email FROM #__users WHERE id IN (".implode(", ", $sellers).")";
		$db->setQuery($sql);
		$emails = $db->loadResultArray();


		$mail->setSender($sender);
		$mail->addBCC($emails);
			
		if ( JString::strlen($body) != JString::strlen(strip_tags($body))){
			$body = str_replace("\n", '<br>', $body);
			$mail->IsHTML(true);
		}
		$mail->setBody(JMailHelper::cleanBody($body));
		$mail->setSubject(JMailHelper::cleanSubject($subject));

		$mail->Send();
	}

	function support()
	{
		$doc = &JFactory::getDocument();
		$js = 'window.open("http://support.mightyextensions.com/en/mighty-commerce-joomla-component.html")';
		$doc->addScriptDeclaration($js);
		JRequest::setVar( 'view'  , 'orders');
		parent::display();
	}
}
?>