<?php
/**
 * $Id: status.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
class CommerceControllerStatus extends JController
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'apply', 'save' );
		$this->registerTask( 'edit', 'add' );
		JRequest::setVar( 'view', 'status' );
	}

	function display()
	{
		JRequest::setVar( 'view', 'status' );
		parent::display();
	}

	function add()
	{
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}
	function save()
	{
		global $mainframe;
		$model  = & $this->getModel('status');
		$row =& JTable::getInstance("status", 'Commerce');
		$user   =& JFactory::getUser();
		$cid 	= JRequest::getVar( 'cid', array() );
		$val = array();
		

		$task = JRequest::getVar('task');
		$val['name'] = JRequest::getVar( 'name');
		$val['ordering'] = JRequest::getVar( 'ordering');
		$val['published'] = JRequest::getVar( 'published');
		$val['description'] = JRequest::getVar( 'descr');
		$val['seller_id'] = $user->id;
		$val['user_alert'] = JRequest::getVar( 'alert');
		$val['id'] = JRequest::getInt('id', null);
		$val['isfinal'] = JRequest::getInt('isfinal');
		$val['type'] = JRequest::getVar( 'type');
		/*if($val['isfinal']) {
			$model->unsetFinal();
		}
		if($_FILES['icon']['name'] != '')
		{
			jimport('joomla.filesystem.file');
			jimport('joomla.filesystem.folder');
			$dest = JPATH_ROOT.DS.'components'.DS.'com_commerce'.DS.'images'.DS.'templates'.DS.COMM_LAY_ICONS_DIR.DS.'statuses'.DS.strtolower(str_replace(" ", "_", $val['name'])).'.png';
			JFile::upload($_FILES['icon']['tmp_name'], $dest);
		}*/
		$val['checked_out'] = $user->id;
		$val['checked_out_time'] = date("Y:m:d H:i:s");

		if (!$row->bind( $val ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}

		if($task == 'save') $row->checkin($val['id']);

		if( $task == 'apply'){
			$link = 'index.php?option=com_commerce&controller=status&task=edit&cid[]='.$row->id;
		}else{
			$link = 'index.php?option=com_commerce&controller=status';
		}
		$mainframe->redirect($link, JText::_('Status is saved successfully') );
	}

	function cancel()
	{
		global $mainframe;
		$row =& JTable::getInstance("status", 'Commerce');
		$row->checkin(JRequest::getVar('id', null));
		$link = 'index.php?option=com_commerce&controller=status';
		$mainframe->redirect( $link );
	}

	function publish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('status');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		
		$this->setRedirect( 'index.php?option=com_commerce&controller=status' );
	}


	function unpublish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('status');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_commerce&controller=status' );
	}
	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('status');
		$model->saveorder($cid, $order);
		$msg = JText::_('New ordering saved');
		$this->setRedirect( 'index.php?option=com_commerce&controller=status', $msg );
	}
	function orderup()
	{
		$model  = & $this->getModel('status');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_commerce&controller=status');
	}

	function orderdown()
	{
		$model  = & $this->getModel('status');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_commerce&controller=status');
	}

	function remove()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model  = & $this->getModel('status');
		$tmp = 0;
		$msg = 'Status is removed';
		$statuses = $model->getStatuses($cid);
		foreach($statuses as $item)
		{
			if($item->isfinal)
			$tmp ++ ;
		}
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		if($tmp > 0)
		$msg = JText::_("Final statuses couldn't be deleted");
			
		$this->setRedirect( 'index.php?option=com_commerce&controller=status', $msg);
	}


}
?>