<?php
/**
 * $Id: directories.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

class JElementDirectories extends JElement
{

	var	$_name = 'Folderlist';

	function fetchElement($name, $value, &$node, $control_name)
	{
	  jimport( 'joomla.filesystem.folder' );

		// path to images directory
		$path		= JPATH_ROOT.DS.$node->attributes('directory');
		
		$path = preg_replace("#([\\\/]*)$#", '', $path);
		
		$path = str_replace(array('\\', '/'), DS, $path );
		
		$filter		           = $node->attributes('filter');
		$exclude	           = $node->attributes('exclude');
		$levels              = $node->attributes('levels');
		$levels              = ( $levels == '' ) ? -1 : $levels;
		$relative_path       = $node->attributes('relative_path');
		$relative_path_value = $node->attributes('relative_path_value');
		$invite_label        = $node->attributes('invite_label');
		$folders             = $this->JS_folders($path, $path, $filter, $levels, $relative_path);
 
		$options = array ();

		foreach ($folders as $folder){
		  if ($relative_path == 1) {
		    $folder_label = str_replace($path.DS, '', $folder);
			} else {
				$folder_label = str_replace(JPATH_ROOT.DS, '', $folder);
			}
			if( $relative_path_value == 1 ){
			  $folder = str_replace($path.DS, '', $folder);
			} else {
			  $folder = str_replace(JPATH_ROOT.DS, '', $folder);
			}
			
			if ($exclude){
				if (preg_match( chr( 1 ) . $exclude . chr( 1 ), $folder_label )) {
					continue;
				}
			}
			
			$options[] = JHTML::_('select.option', $folder, $folder_label);
		}
    
		if (!$node->attributes('hide_none')) {
		  if(!$invite_label){
		    $invite_label = 'Do not use';
		  }
			array_unshift($options, JHTML::_('select.option', '-1', '- '.JText::_($invite_label).' -'));
		}

		if (!$node->attributes('hide_default')) {
			array_unshift($options, JHTML::_('select.option', '', '- '.JText::_('Use default').' -'));
		}

		return JHTML::_('select.genericlist',  $options, ''.$control_name.'['.$name.']', 'class="inputbox"', 'value', 'text', $value, "param$name");
	}
	
	function JS_folders($path, $init_path, $filter = '.', $levels = -1, $relative_path = '0', $exclude = array('.svn', 'CVS'))
	{
	  
		$arr = array ();

		// Check to make sure the path valid and clean
		$path = JPath::clean($path);

		// Is the path a folder?
		if (!is_dir($path)) {
		  JError::raiseWarning(21, 'JS_folder: '.JText::_('Path is not a folder').' '.$path);
			return false;
		}

		// read the source directory
		$handle = opendir($path);
		while (($file = readdir($handle)) !== false) 
		{
			$dir = $path.DS.$file;
			$isDir = is_dir($dir);
			if (($file != '.') && ($file != '..') && (!in_array($file, $exclude)) && $isDir) {
				// removes SVN directores from list
				if (preg_match("/$filter/", $file)) {
				  $arr[] = $dir;
					/*if ($relative_path == 0) {
						$arr[] = str_replace(JPATH_ROOT.DS, '', $dir);
					} else {
						$arr[] = str_replace($init_path.DS, '', $dir);
					}*/
				}
				if ( $levels == -1 || $levels > 0) {
					if (is_integer($levels*1) && $levels > 0) {
						$down_levels = $levels - 1;
					} else {
					  $down_levels = $levels;
					}
					
					$arr2 = $this->JS_folders($dir, $init_path, $filter, $down_levels, $relative_path);
					$arr = array_merge($arr, $arr2);
				}
			}
		}
		closedir($handle);

		asort($arr);
		return $arr;
	}
	
}