<?php
/**
 * $Id: orders.php 7783 2012-02-09 09:43:49Z alfiya $
 * $LastChangedDate: 2012-02-09 15:43:49 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('dead');

jimport('joomla.application.component.model');

class CommerceModelOrders extends JModel
{

	function __construct()
	{
		parent::__construct();
	}

	function getOrders($with_limit = false)
	{
		global $mainframe;
		$option = 'com_commerce';
		$section_id = JRequest::getInt('section_id') ? JRequest::getInt('section_id') : COMM_GLOBAL_SECTION;
		$context          = "$option.view_orders";
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'ord.id');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'DESC');
		$filter_gateway		= $mainframe->getUserStateFromRequest( $context.'filter_gateway',	'filter_gateway',	'');
		$filter_offline		= $mainframe->getUserStateFromRequest( $context.'filter_offline',	'filter_offline',	'');
		$filter_section		= $mainframe->getUserStateFromRequest( $context.'filter_section',	'section_id',	$section_id);
		$filter_state		= $mainframe->getUserStateFromRequest( $context.'filter_state',	'filter_state',	'');
		$limit      		= $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart			= JRequest::getVar('limitstart', 0, '', 'int');
		$search				= $mainframe->getUserStateFromRequest( $context.'search_order', 'search_order', '',	'string' );
		$search				= JString::strtolower( $search );

		$search_oid				= $mainframe->getUserStateFromRequest( $context.'search_oid', 'search_oid', '');


		$sql = "SELECT ord.*, IF(ord.user_id > 0, (SELECT email FROM #__users WHERE id = ord.user_id), ord.email) as email, st.name as status
		FROM #__jc_orders ord
		JOIN #__jc_orders_products pr ON pr.order_id = ord.id
		JOIN #__jc_orders_statuses st ON st.id = ord.status_id";

		$where = array();
		if($search !='')
		{
			if(intval($search))
			$where[]= "(ord.gateway_id = '$search' OR ord.user_id = '$search')";
			else
			$where[] = "(ord.email LIKE '%$search%' OR ord.gateway LIKE '%$search%')";

			if($search_oid != '')
			{
				$where[] = " AND ord.id = '$search_oid'";
			}
		}
		if($search_oid != '')
		{
			$where[] = "ord.id = '$search_oid'";
		}

		if($filter_offline != "")
		$where[] = " ord.pay = 'offline' AND ord.deducted = '".($filter_offline -1 )."'";

		if($filter_gateway != '')
		$where[] = ($filter_offline > 0 ? ' AND' : '')." ord.gateway = '".$filter_gateway."'";

		if($filter_section)
		$where[] = " ord.section_id = '".$filter_section."'";

		if($filter_state != '')
		$where[] = " ord.status_id = '".$filter_state."'";

		if(count($where))
		$sql .= ' WHERE '.implode(" AND ", $where);

		$sql .= " GROUP BY ord.id
		ORDER BY $filter_order $filter_order_Dir";
		if($with_limit && $limit)
		{
			$sql .= " LIMIT $limitstart, $limit";
		}
		$this->_db->setQuery($sql);

		return $this->_db->loadObjectList();
	}

	function getProducts($oid)
	{
		$sql = "SELECT r.title, u.id, u.username, pr.product_link as link
		FROM #__jc_orders_products pr
		JOIN #__js_res_record r ON r.id = pr.product_id
		JOIN #__users u ON u.id = r.user_id
		WHERE pr.order_id = '$oid'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getOrderInfo($oid)
	{
		$sql = "SELECT ord.*, st.name as status FROM #__jc_orders ord
		JOIN #__jc_orders_statuses st ON st.id = ord.status_id
		WHERE ord.id = '$oid' ";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getOrderDetails($oid, $uid)
	{
		$sql = "SELECT pr.*, u.name, u.username, u.id as seller, st.name as status, st.ordering, st.isfinal
		FROM #__jc_orders_products pr
		JOIN #__users u ON u.id = pr.seller_id
		JOIN #__jc_orders_statuses st ON st.id = pr.status_id
		WHERE pr.order_id = '$oid'
		ORDER BY seller_id, product_id DESC ";
		$this->_db->setQuery($sql);// echo $this->_db->_sql;
		return $this->_db->loadObjectList();
	}

	function getOrderProductProperty($id)
	{
		$sql = "SELECT pp.property as value, pp.price_affect as price, rf.type, pp.prop_id, pr.product_id
		FROM #__jc_orders_products_property pp
		JOIN #__js_res_fields rf ON pp.prop_id = rf.id
		JOIN #__jc_orders_products pr ON pp.order_product_id = pr.id
		WHERE pp.order_product_id = '$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getOrderShipping($oid)
	{
		$sql = "SELECT pr.*, st.name as status
		FROM #__jc_orders_products pr
		JOIN #__jc_orders_statuses st ON st.id = pr.status_id
		WHERE pr.order_id = '$oid' AND pr.product_id = '0' AND pr.extra != '' AND pr.extra != ''";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getCore($id)
	{
		$db =& JFactory::getDBO();
		$query = "
           SELECT c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
             FROM #__jc_currency AS c
            WHERE c.id = '$id'";
		$db->setQuery( $query);
		return $db->loadObject();
	}

	function getSectionName($sid)
	{
		$sql = "SELECT name FROM #__js_res_category WHERE id = '$sid'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getOrdersGateways($default)
	{
		$sql = "SELECT DISTINCT(gateway) FROM #__jc_orders WHERE gateway != '' ORDER BY gateway";
		$this->_db->setQuery($sql);
		$res = $this->_db->loadResultArray();
		$opt = array();
		$opt[] = JHTML::_('select.option', '', '- '.JText::_('Select gateway').' -');
		if(count($res) > 0)
		{
			foreach ($res as $val)
			{
				$opt[] = JHTML::_('select.option', $val, $val);
			}
		}
		return  JHTML::_('select.genericlist',  $opt, "filter_gateway", 'onchange="this.form.submit();"', 'value', 'text', $default);
			

	}

	function getSectionParams($oid)
	{
		$sql = "SELECT section_id FROM #__jc_orders WHERE id = '$oid'";
		$this->_db->setQuery($sql);
		$section_id = $this->_db->loadResult();

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
		$comm_params = ResHelper::getSectionParams($section_id);
		return array($section_id, $comm_params);
	}

	function getInvoiceNumber($client, $user_id, $order_id)
	{
		if($client)
		{
			$sql = "SELECT COUNT(*) FROM #__jc_orders ord
		JOIN #__jc_orders_products pr ON pr.order_id = ord.id
		WHERE ".((COMM_PAYMENT_METHOD == 'personal' && COMM_MULTI_SELLER) ? "pr.seller_id = '$user_id' AND": '')." ord.id <= $order_id";
		}
		else
		$sql = "SELECT COUNT(*) FROM #__jc_orders
		WHERE ".((COMM_PAYMENT_METHOD == 'personal' && COMM_MULTI_SELLER) ? "user_id = '$user_id' AND": '')." id <= $order_id";
		$this->_db->setQuery($sql); 
		return $this->_db->loadResult();
	}

	function getOrderStatuses()
	{
		$sql = "SELECT id, name FROM #__jc_orders_statuses WHERE type = 'order' ORDER BY id";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}
	function getStatusList()
	{
		$sql = "SELECT id, name, ordering, isfinal FROM #__jc_orders_statuses WHERE published = '1' AND type = 'product' ORDER BY ordering ";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getArticleInfo($id)
	{
		$sql = "SELECT * FROM #__js_res_record WHERE id='$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

}

?>