<?php
/**
 * $Id: view.html.php 7873 2012-02-28 05:08:36Z alfiya $
 * $LastChangedDate: 2012-02-28 11:08:36 +0600 (Tue, 28 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('restricted');

jimport('joomla.application.component.view');

class CommerceViewOrders extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $option;
		if ($this->getLayout() == 'details')
		{
			
			$this->displayDetails($tpl);
			return;
		}
		// Set toolbar items for the page
		JToolBarHelper::title(JText::_("Orders"), 'generic.png');
		JToolBarHelper::custom('details', 'preview', '', 'Details');
		
		$db = & JFactory::getDBO();
		$uri = & JFactory::getURI();
		$model = & $this->getModel('orders');
		$user = & JFactory::getUser();
		$section_id = JRequest::getInt('section_id') ? JRequest::getInt('section_id') : COMM_GLOBAL_SECTION;
		
		$context = "$option.view_orders";
		$filter_order = $mainframe->getUserStateFromRequest($context . 'filter_order', 'filter_order', 'ord.id');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($context . 'filter_order_Dir', 'filter_order_Dir', 'Desc');
		$filter_gateway = $mainframe->getUserStateFromRequest($context . 'filter_gateway', 'filter_gateway', '');
		$filter_offline = $mainframe->getUserStateFromRequest($context . 'filter_offline', 'filter_offline', '');
		$filter_section = $mainframe->getUserStateFromRequest($option . 'filter_section', 'section_id', $section_id);
		$filter_state = $mainframe->getUserStateFromRequest($context . 'filter_state', 'filter_state', '');
		$limit = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		$search = $mainframe->getUserStateFromRequest($context . 'search_order', 'search_order', '');
		$search = JString::strtolower($search);
		$search_oid = $mainframe->getUserStateFromRequest($context . 'search_oid', 'search_oid', '');
		
		if (COMM_PAYMENT_METHOD == 'global' && $filter_offline == 1)
			JToolBarHelper::custom('deduct', 'forward', '', 'Set paid');
		
		// Get data from the model
		$orders = $model->getOrders(true);
		$total = $model->getOrders();
		
		if ($orders)
		{
			foreach($orders as $k => $order)
			{
				if ($order->user_id)
				{
					$cust = JFactory::getUser($order->user_id);
					$orders[$k]->user = $cust->name;
					$orders[$k]->email = $cust->email;
				}
				else
				{
					$orders[$k]->user = JText::_('Unregistered');
				}
				$items = $model->getProducts($order->id);
				$prod = array();
				foreach($items as $item)
				{
					$prod[] = JHTML::link((strstr($item->link, 'http://') ? $item->link : JURI::root() . $item->link), $item->title, 'target="_blank"'); //.' ('.$item->username.'['.$item->id.'])';
				}
				$orders[$k]->items = implode("; ", $prod);
				$orders[$k]->section = $model->getSectionName($order->section_id);
			}
		}
		jimport('joomla.html.pagination');
		$pagination = new JPagination(count($total), $limitstart, $limit);
		
		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		
		//search filter
		$lists['search'] = $search;
		
		//search filter
		$lists['search_oid'] = $search_oid;
		
		$lists['filter_gateway'] = $model->getOrdersGateways($filter_gateway);
		
		$opt = array();
		$opt[] = JHTML::_('select.option', '', '- ' . JText::_('Select offline') . ' -');
		$opt[] = JHTML::_('select.option', '2', JText::_('offline deducted'));
		$opt[] = JHTML::_('select.option', '1', JText::_('offline non-deducted'));
		$lists['filter_offline'] = JHTML::_('select.genericlist', $opt, "filter_offline", 'onchange="this.form.submit();"', 'value', 'text', $filter_offline);
		
		$opt = array();
		$opt[] = JHTML::_('select.option', '', '- ' . JText::_('Select state') . ' -');
		$sql = "SELECT DISTINCT(ord.status_id) as id, st.name FROM #__jc_orders ord
		JOIN #__jc_orders_statuses st ON st.id = ord.status_id
		ORDER BY st.name";
		$db->setQuery($sql);
		if ($res = $db->loadObjectList())
		{
			foreach($res as $val)
				$opt[] = JHTML::_('select.option', $val->id, JText::_($val->name));
		}
		$lists['filter_state'] = JHTML::_('select.genericlist', $opt, "filter_state", 'onchange="this.form.submit();"', 'value', 'text', $filter_state);
		
		$lists['secid'] = getComSectionList($filter_section);
		
		$this->assignRef('orders', $orders);
		$this->assignRef('lists', $lists);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('request_url', $uri->toString());
		
		parent::display($tpl);
	}

	function displayDetails($tpl)
	{
		$uri = & JFactory::getURI();
		$model = & $this->getModel('orders');
		$document = &JFactory::getDocument();
		$dispatcher = JDispatcher::getInstance();
		$oid = JRequest::getVar('cid');
		$oid = $oid[0];
		
		$document->addScript(JURI::root() . 'components/com_commerce/js/felix_js/library.js');
		$document->addScript(JURI::root() . 'components/com_commerce/js/felix_js/pop_up.js');
		$document->addScriptDeclaration("var commerce_popUp = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );");
		
		JRequest::setVar('hidemainmenu', '1');
		
		$info = $model->getOrderInfo($oid);
		$CP_admin = ResHelper::getSectionParams($info->section_id);
		//CommerceControllerConfig::initialyze($CP_admin, $info->section_id);
		

		$details = $model->getOrderDetails($oid, $info->user_id);
		$core = $model->getCore($CP_admin->get('comm_core_currency'));
		$ship = $model->getOrderShipping($oid);
		$statuses = $model->getOrderStatuses();
		$user_id = (COMM_PAYMENT_METHOD == 'personal' && COMM_MULTI_SELLER) ? $details[0]->seller_id : false;
		$info->invoice_id = $model->getInvoiceNumber(1, $user_id, $oid);
		
		$info->user = JText::_('Unregistered') . ' [' . $info->email . ']';
		if ($info->user_id)
		{
			$client = JFactory::getUser($info->user_id);
			$info->user = $client->name . ' [' . $client->email . ']';
		}
		$list = array();
		$shipping = array();
		$i = 0;
		
		foreach($details as $k => $item)
		{
			if ($item->product_id)
			{
				$record = $model->getArticleInfo($item->product_id);
				$item->title = $record->title;
				$props = $model->getOrderProductProperty($item->id);
				if ($props)
				{
					$property = array();
					foreach($props as $prop)
					{
						JPluginHelper::importPlugin('joomsuite_content_fields', $prop->type);
						$dispatcher->trigger('onRenderPropertyValue', array(&$prop->type, &$prop->value));
						if (floatval($prop->price) > 0)
						{
							if (!strstr($prop->price, '+'))
								$prop->price = '+' . $prop->price;
						}
						$property[] = $prop->value . ' (' . $prop->price . ')';
					}
					$item->property = implode(", ", $property);
				}
				$list[$item->seller_id][$i] = $item;
				$i++;
			}
			else 
			{
				if($item->extra != '')
				{
					$item_ship = new JParameter($item->extra);
					if($item_ship = $item_ship->get('shipping'))
					{
						$item_ship = unserialize($item_ship);
						$seller = JFactory::getUser($item->seller_id);
						$ship = explode('::', $item_ship['info']);
						$shipping[$item->seller_id]->info = JText::_('Products delivery from vendor').' '.$seller->name.' ('.$ship[0].', '.$ship[1].'; '.JText::_('weight').': '.$item_ship['weight'].' '.JText::_('kg').')';
						$shipping[$item->seller_id]->sum = $item_ship['sum'];
						//$shipping[$item->seller_id]->sum_mark = $item_ship['sum_mark'];
					}
				}
			}
		}
		$pr_statuses = $model->getStatusList();
		
		JToolBarHelper::title(JText::_("Order details"), 'generic.png');
		JToolBarHelper::cancel('cancel', 'Close');
		
		$this->assignRef('info', $info);
		$this->assignRef('core', $core);
		$this->assignRef('details', $list);
		$this->assignRef('shipping', $shipping);
		$this->assignRef('cp', $CP_admin);
		$this->assignRef('statuses', $statuses);
		$this->assignRef('pr_statuses', $pr_statuses);
		$this->assignRef('request_url', $uri->toString());
		
		parent::display($tpl);
	}

}


?>