<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('restricted');

jimport( 'joomla.application.component.view');

class CommerceViewStatus extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();
		$model  = & $this->getModel('status');
		$user =& JFactory::getUser();

		// Set toolbar items for the page
		if($this->getLayout() == 'form') {			
			$this->_displayForm($tpl);
			return;
		}
		JToolBarHelper::title(   JText::_( "Orders Statuses" ), 'generic.png' );
		JToolBarHelper::editListX();		

		$option = 'com_commerce';
		$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',		'',				'word' );
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'filter_catid',		'filter_catid',		0,				'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		's.type',		'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		
		$filter_type		= $mainframe->getUserStateFromRequest( $option.'filter_type',		'filter_type',		'' );
		
		
		// Get data from the model
		$items		= $model->getStatuses();

		$context          = "$option.view_status";
		$limit      = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		jimport('joomla.html.pagination');
		$pagination = new JPagination( 0, $limitstart, $limit );

		// build list of categories
		$javascript 	= 'onchange="document.adminForm.submit();"';
		$lists['catid'] = JHTML::_('list.category',  'filter_catid', 'com_commerce', intval( $filter_catid ), $javascript );

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		
		$opt = array();
		$opt[] = JHTML::_('select.option', '', '- '.JText::_('Select type').' -');
		$opt[] = JHTML::_('select.option', 'product', JText::_('Product'));
		$opt[] = JHTML::_('select.option', 'order', JText::_('Order'));
		$lists['filter_type'] = JHTML::_('select.genericlist',  $opt, "filter_type", 'onchange="this.form.submit();"', 'value', 'text', $filter_type);

		$editor =& JFactory::getEditor();

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('editor', $editor);
		$this->assignRef('pagination',	$pagination);
		$this->assignRef('request_url',	$uri->toString());

		parent::display($tpl);
	}
	function _displayForm($tpl)
	{
		global $mainframe, $option;

		$db     =& JFactory::getDBO();
		$uri    =& JFactory::getURI();
		$user   =& JFactory::getUser();
		$model  = & $this->getModel('status');
		$id = 0;
		$cid 	= JRequest::getVar( 'cid', array() );
		if(count($cid) > 0 && $id = $cid[0])
		$status	= $model->getStatusInfo($id);

		$isNew = ($id < 1);
		if (isset($status) && $model->isCheckedOut( $status->id, $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The Status' ), $status->name );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}
		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'Status' ).': <small><small>[ ' . $text.' ]</small></small>' );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}

		if (!$isNew)
		{
			$model->checkout($status->id, $user->get('id'));
			$status->icon = '';
			$icon = 'components'.DS.'com_commerce'.DS.'images'.DS.'templates'.DS.COMM_LAY_ICONS_DIR.DS.'statuses'.DS.strtolower(str_replace(" ", "_", $status->name)).'.png';
			$icon = str_replace("\\", "/", $icon);
			if(file_exists(JPATH_ROOT.DS.$icon)) $status->icon = ' <img src="'.JURI::root().$icon.'" align="absmiddle" width="21px">';
		}
		else
		{
			$status->ordering = 0;
			$status->name = '';
			$status->published = 1;
			$status->isfinal = 0;
			$status->descr = '';
			$status->user_alert = '';
			$status->icon = '';
				
		}
		
		$editor =& JFactory::getEditor();

		$this->assignRef('lists',	 $lists);
		$this->assignRef('status',   $status);
		$this->assignRef('editor', $editor);
		$this->assignRef('request_url',	$uri->toString());

		parent::display($tpl);

	}
}
?>