<?php
/**
 * $Id: balance.php 7782 2012-02-09 09:43:38Z alfiya $
 * $LastChangedDate: 2012-02-09 15:43:38 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerBalance extends CommerceController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('certificate', 'apply_certificate');
	}

	function display()
	{
		global $mainframe;

		$user =& JFactory::getUser();

		if(!$user->get('id'))
		{
			$link = 'index.php?option=com_commerce&view=balance';
			if(JRequest::getVar('layout') == 'customer')
			$link .= '&layout=customer';
			$link .= '&section_id='.COMM_SECTION_ID.'&Itemid='.JRequest::getInt('Itemid');
			$cpanel = JRoute::_($link, false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($cpanel), false),
			JText::_('You are not authorized to see that page'), 'Error');
		}

		if(JRequest::getVar('layout') == '')
		{
			if(!$user->get('is_seller') && !$user->is_silver && !$user->is_gold)
			{
				CommerceController::checkConfirmBySubscription();
				JError::raiseWarning(500, JText::_('ERROR You are not allowed to see this page') );
				return;
			}

			$model = & $this->getModel('userconfig');
			if(!$model->getConfId($user->id))
			{
				$link = "index.php?option=com_commerce&view=userconfig&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_USERCONFIG_ITEMID != '') ? COMM_USERCONFIG_ITEMID : JRequest::getInt("Itemid"));
				$mainframe->redirect(JRoute::_($link, false), JText::_("You have not saved your configuration. Please fill the fields to continue."), 'Notice');
			}
		}

		JRequest::setVar('view', 'balance');
		parent::display();

	}

	function pileup()
	{
		global $mainframe;
		$return = "index.php?option=com_commerce&view=balance";
		if($layout = JRequest::getString('layout'))$return .= "&layout=$layout";
		$return .= "&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_BALANCE_ITEMID != '') ? COMM_BALANCE_ITEMID : JRequest::getInt('Itemid') );
		$return = JRoute::_( $return, false);
		$link = 'index.php?option=com_jsbill&view=bill&bill='.($layout == 'customer' ? COMM_CUSTOMER_PILEUP : COMM_PAYOUTBILL).'&Itemid='.( (COMM_BILL_ITEMID != '') ? COMM_BILL_ITEMID : JRequest::getInt('Itemid') )
		.'&return_success='.base64_encode($return).'&return_fail='.base64_encode($return);
		$mainframe->redirect(JRoute::_($link, false));
	}

	function change_section()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&view=balance';
		if($layout = JRequest::getString('layout') ) $link .= "&layout=$layout";
		$link .= '&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_BALANCE_ITEMID != '') ? COMM_BALANCE_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect( JRoute::_($link, false) );
	}

	function apply_certificate()
	{
		global $mainframe;
		$db  =& JFactory::getDBO();
		$model  = & $this->getModel('balance');
		$user =& JFactory::getUser();

		$cert = JRequest::getVar('certificate');

		$msg = '';
		$link = 'index.php?option=com_commerce&view=balance';
		if($layout = JRequest::getString('layout') ) $link .= "&layout=$layout";
		$link .= '&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_BALANCE_ITEMID != '') ? COMM_BALANCE_ITEMID : JRequest::getInt('Itemid'));

		$sql = "SELECT *,  IF( extime > NOW() or YEAR(extime) =  0 , 0, 1)  as expired
		FROM #__jc_coupons 
		WHERE value = '".addslashes($cert)."' AND discount_type = 'sum' AND published = '1' AND ctime < NOW() AND section_id = '".COMM_SECTION_ID."'";
		$db->setQuery($sql);
		if($row = $db->loadObject())
		{
			if(($row->use_num > 0) && ($row->used_num >= $row->use_num))
			{
				$msg = JText::_('Gift Certificate is used out');
			}

			if($row->discount <= 0)
			{
				$msg = JText::_('Gift Certificate is used out');
			}

			if($row->expired)
			{
				$msg = JText::_('Gift Certificate is expired');
			}

			if($row->user_ids != '' && strtolower($row->user_ids) != 'any')
			{
				$user = JFactory::getUser();
				$ids = explode(",", $row->user_ids);
				if(!in_array($user->get('id'), $ids))
				{
					$msg = JText::_('You are not allowed to use this Gift Certificate');
				}
			}
			if($row->product_ids != '' && $row->product_ids != 'Any')
			{
				$ids = explode(",", $row->product_ids);
				foreach($cart as $item)
				{
					$sid[] = $item->article;
				}
				$intersect = array_intersect($sid, $ids);
				if(count($intersect) == 0)
				{
					$msg = JText::_('This Gift Certificate is not valid to products');
				}
			}
			if($row->usercategory_ids && $row->usercategory_ids != '')
			{
				$pt_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'community.php';
				if(file_exists($pt_file))
				{
					$gids = explode(",", $row->usercategory_ids);
					
					$sql = " ( SELECT cc.id FROM #__community_user_mapping um
					JOIN #__community_communities cc ON um.group_id = cc.id
					WHERE um.user_id = '{$user->id}' )
					UNION
					( SELECT id FROM #__community_communities WHERE user_id = '{$user->id}')";
					$db->setQuery($sql);
					$ugid = $db->loadResultArray();
					$intersect = array_intersect($ugid, $gids);
					if(count($intersect) == 0)
					{
						$msg = JText::_('This Gift Certificate is not valid to the group');
					}

				}
			}

			if($row->use_user > 0)
			{
				$sql = "SELECT count(*)
				FROM #__jc_orders ord
				JOIN #__jc_orders_products pr ON pr.order_id = ord.id
				JOIN #__jc_coupons cp ON cp.id = pr.coupon_id
				WHERE pr.coupon_id = '{$row->id}' AND ord.ctime >= cp.ctime AND ord.user_id = '{$user->id}'";

				$db->setQuery($sql);
				$num = $db->loadResult();

				if($num >= $row->use_user)
				{
					$msg = JText::_('You have used this Gift Certificate amount of times allowed');
				}
			}
			if($msg == '')
			{
				$customer = $model->getCustomerBalance($user->id);

				if(!$customer)
				$balance = $row->discount;
				else
				$balance = $customer->balance + $row->discount;

				$rows =& JTable::getInstance("CustomersBalance", 'Commerce');

				$vals = array();
				$vals['user_id'] = $user->id;
				$vals['type'] = 'gift certificate';
				$vals['order_id'] = $row->id;
				$vals['balance'] = $balance;
				$vals['section_id'] = COMM_SECTION_ID;

				if (!$rows->bind( $vals ))
				{
					JError::raiseWarning(500, $rows->getError());
				}
				if (!$rows->check())
				{
					JError::raiseWarning(500, $rows->getError());
				}

				if (!$rows->store())
				{
					JError::raiseWarning(500, $rows->getError());
					$this->setRedirect($link);
				}
				$sql = "UPDATE #__jc_coupons SET discount = '0', used_num = used_num + 1 WHERE id = '{$row->id}'";
				$db->setQuery($sql);
				$db->query();
				$this->setRedirect($link, JText::_('Your balance was successfullly piled up'));
			}
			else
			$this->setRedirect($link, $msg, 'Notice');

		}
		else
		$this->setRedirect($link, JText::_('Gift Certificate is not found'), 'Notice');
	}



}
?>