<?php
/**
 * $Id: cart.php 7997 2012-04-02 03:20:00Z alfiya $
 * $LastChangedDate: 2012-04-02 09:20:00 +0600 (Mon, 02 Apr 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerCart extends CommerceController
{

	function __construct()
	{
		global $mainframe;
		
		if (!JRequest::getVar('view'))
		{
			JRequest::setVar('view', 'cart');
		}
		parent::__construct();
		$this->registerTask('inquire', 'buy');
		$this->registerTask('recalculate', 'recalculate');
		$this->registerTask('apply_coupon', 'apply_coupon');
		$this->registerTask('save_billinfo', 'save_shipinfo');
		$this->registerTask('copybillto', 'copybillto');
		$this->registerTask('changeShipAddress', 'changeBillAddress');
	
	}

	function buy()
	{
		global $mainframe;
		$model = $this->getModel('cart');
		$model_order =  $this->getModel('orders');
		$user =  JFactory::getUser();
		$db =  JFactory::getDBO();
		$row =  JTable::getInstance("Cart", 'Commerce');
		$dispatcher =  JDispatcher::getInstance();
		
		$session =  JFactory::getSession();
		$address = $session->get('address');
		$unreg = $session->get('unreg_address');
		
		if ($address || $unreg)
		{
			$bill_info = $user->id ? $model->getAddresses('bill', $address['bill']) : $unreg['bill'];
			$bill_country = (is_object($bill_info)) ? $bill_info->country : $bill_info['country'];
		}
		$back = JRoute::_("index.php?option=com_commerce&view=cart&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt("Itemid")), false);
		$login = JURI::root() . "index.php?option=com_user&view=login&Itemid=" . JRequest::getInt("Itemid") . "&return=" . base64_encode($back);
		
		$cart = $session->get('my_cart-' . COMM_SECTION_ID);
		$cart_coupon = $session->get('my_cart_coupon-' . COMM_SECTION_ID);
		
		$shipping = $session->get('shipping-' . COMM_SECTION_ID);
		
		if (count($cart) == 0)
		{
			$mainframe->redirect($back, JText::_("Your cart is empty"), 'Error');
		}
		
		$coupon_id = 0;
		$total_sum = 0;
		$sellers = array();
		
		if ($cart_coupon)
		{
			$this->initCoupon($cart_coupon['value']);
			if (!$this->couponExists)
			{
				JError::raiseNotice(100, JText::_('Coupon or Gift Certificate number do not exists'));
				parent::display();
				return;
			}
			else
			{
				if (!$this->couponValid)
				{
					JError::raiseNotice(100, JText::_('Coupon or Gift Certificate is not valid'));
					JError::raiseNotice(100, $this->couponError);
					parent::display();
					return;
				}
			}
			$coupon = $model->getCouponDiscount($cart_coupon);
		}
		
		if (!$user->id)
		{
			$cemail = JRequest::getString('cemail', '', 'post');
			if (!$cemail)
				$mainframe->redirect($back, JText::_("You have not entered the *Email to continue"), 'Error');
		
		}
		if (COMM_CART == 'cart' || COMM_CART == 'balance')
		{
			if (!defined('COMM_FIELDS_SHOW') || (defined('COMM_FIELDS_SHOW') && COMM_FIELDS_SHOW))
			{
				
				if ((!$address && $user->id) || (!$unreg && !$user->id))
					$mainframe->redirect($back, JText::_("You haven't added Bill To / Ship To address"), 'Notice');
				
				if (((!$address['bill'] && $user->id) || (!$unreg['bill'] && !$user->id)))
					$mainframe->redirect($back, JText::_("You haven't added Bill To address"), 'Notice');
			}
		}
		
		$fields = JRequest::getVar('fields');
		
		$tmpl = 0;
		foreach($cart as $seller_id => $items)
		{
			foreach($items as $k => $item)
			{
				if ($tangible = $model->isTangible($item->article))
				{
					$tangible = $tangible[0];
					$tang_params = new JParameter($tangible->value);
					if ($tang_params->get('weight'))
					{
						if (!$tang_params->get('storage', 0))
						{
							$cart[$k]->items_num = 0;
							$session->set('my_cart' . '-' . COMM_SECTION_ID, $cart);
							$mainframe->redirect($back, JText::_("There are no some items on storage. Please delete it from your cart"), 'Error');
						}
					}
				}
				
				if ($tmpl == 0)
					$first = $item;
				$prop = array();
				if ($fields[$seller_id][$k])
				{
					foreach($fields[$seller_id][$k] as $field)
					{
						$tmp = 0;
						foreach($field as $val)
						{
							if ($val['require_before_order'] && !$val['property'])
								$mainframe->redirect($back, JText::_("You didn't select required product properties. Please select the property and click Recalculate or ") . ((COMM_CART == 'cart' || COMM_CART == 'balance') ? JText::_('Checkout') : ucfirst(JText::_(COMM_CART))) . ' ' . JText::_("button"), 'Error');
							
							$ptype = $model->getPropertyType($val['prop_id']);
							JPluginHelper::importPlugin('joomsuite_content_fields', $ptype); //'product_property');
							$props = $val['property'];
							$dispatcher->trigger('onCommerceCartRecalculate', array(&$props, $val['prop_id'], $item->article)); // 'product_property'
							

							if (isset($props))
							{
								if (is_array($props))
								{
									$n = 0;
									foreach($props as $pr_prop)
									{
										$val_prop = explode("__PROD_PROP__", $pr_prop);
										$prop[$tmp][$n] = array('value' => $val_prop[0], 'price' => $val_prop[1], 'prop_id' => $val['prop_id']);
										if (isset($val_prop[2]))
											$prop[$tmp][$n] = array_merge($prop[$tmp][$n], array('with_discount' => $val_prop[2]));
										$n ++;
									}
								}
								else
								{
									$val_prop = explode("__PROD_PROP__", $props);
									$prop[$tmp][0] = array('value' => $val_prop[0], 'price' => $val_prop[1], 'prop_id' => $val['prop_id'], 'with_discount' => $val_prop[2]);
									if ($val_prop[2])
										$prop[$tmp][0] = array_merge($prop[$tmp][0], array('with_discount' => $val_prop[2]));
								}
							}
							$tmp ++;
						}
					}
				}
				if (count($prop) > 0)
					$cart[$k]->property = $prop;
				
				if (COMM_CART == 'cart' || COMM_CART == 'balance')
				{
					if ($tangible && ((!$address['ship'] && $user->id) || (!$unreg['ship'] && !$user->id)))
						$mainframe->redirect($back, JText::_("You haven't added Ship To address"), 'Notice');
					
					if ($tangible && !isset($shipping[$seller_id]['sum']))
					{
						$mainframe->redirect($back, JText::_("You haven't selected the Shipping scheme"), 'Notice');
					}
				}
			
			}
		}
		$session->set('my_cart' . '-' . COMM_SECTION_ID, $cart);
		
		$vals = array();
		if (!$user->id)
			$vals['email'] = $cemail;
		$vals['failed'] = 1;
		$vals['gateway_id'] = time();
		$vals['section_id'] = COMM_SECTION_ID;
		
		if (!$row->bind($vals))
		{
			JError::raiseWarning(500, $row->getError());
			return;
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
			return;
		}
		
		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
			return;
		}
		
		$core = getCore();
		$update_discount = 0;
		$balance = 0;
		$discount_sum = 0;
		
		$prow = & JTable::getInstance("Products", 'Commerce');
		foreach($cart as $seller_id => $items)
		{
			foreach($items as $i => $item)
			{
				$coupon_id = 0;
				$discount = 0;
				$netprice = 0;
				$sellers[$seller_id] ++;
				$field = $model->getFieldValue($item->article);
				if ($field)
				{
					$price = $field->field_value;
					$price_ext = $model->getPriceExtra($field->field_id, $item->article);
					
					JPluginHelper::importPlugin('joomsuite_content_fields', 'price');
					$price = 0;
					$dispatcher->trigger('onGetItemPrice', array(&$price, $item->article, $item->items_num, 'user', false));
				}
				else
					$price = 0;
				
				$affect[$seller_id][$i] = 0;
				$itax[$seller_id][$i] = 0;
				
				if (isset($item->property))
				{
					foreach($item->property as $property)
					{
						foreach($property as $prop)
						{
							if (isset($prop['price']))
							{
								$affect[$seller_id][$i] += isset($prop['with_discount']) ? floatval($prop['with_discount']) : floatval($prop['price']);
							}
						}
					}
				}
				$currency = (isset($price_ext->currency)) ? $price_ext->currency : false;
				$tax[$seller_id][$i] = (isset($price_ext->tax)) ? $price_ext->tax : false;
				
				if ($tax[$seller_id][$i])
				{
					if ($tax[$seller_id][$i]->country != '')
					{
						$tax_countries = explode("|", $tax[$seller_id][$i]->country);
						if (!in_array($bill_country, $tax_countries))
							$tax[$seller_id][$i] = false;
					}
				}
				$art_info[$seller_id][$i] = $model->getArticleInfo($item->article);
				
				$price_core[$seller_id][$i] = ($currency) ? round($price / $currency->rate, 2) : $price;
				$affect[$seller_id][$i] = ($currency) ? round($affect[$seller_id][$i] / $currency->rate, 2) : $affect[$seller_id][$i];
				$price_core[$seller_id][$i] += $affect[$seller_id][$i];
				
				$netprice = $price_core[$seller_id][$i];
				$netprice *= $item->items_num;
				
				if ($field)
				{
					$tparams = new JParameter($field->params);
					if ($tparams->get('use_tax'))
					{
						$netprice += round(($netprice * ($tax[$seller_id][$i] ? $tax[$seller_id][$i]->rate : 0) / 100), 2);
						$itax[$seller_id][$i] = round(($price_core[$seller_id][$i] * ($tax[$seller_id][$i] ? $tax[$seller_id][$i]->rate : 0) * $item->items_num / 100), 2);
					}
					else
					{
						$tax[$seller_id][$i]->rate = 0;
						$tax[$seller_id][$i]->name = '';
					}
					$total_sum += $netprice;
				}
				if (isset($item->suite_discount))
				{
					$discount = round($netprice * $item->suite_discount / 100, 2);
					$netprice -= $discount;
					$discount_sum += $discount;
				}
				
				if ($cart_coupon && (COMM_CART == 'cart' || COMM_CART == 'balance'))
				{
					
					if (COMM_MULTI_SELLER && COMM_MULTI_VENDOR)
					{
						if ($seller_id == $cart_coupon['seller_id'] || $cart_coupon['core'])
						{
							if ($coupon->type == 'procent')
							{
								$discount = $netprice * $coupon->discount / 100;
							}
							else
							{
								if ($netprice > $coupon->discount)
								{
									$discount = $coupon->discount;
								}
								else
								{
									$discount = $netprice;
								}
								$coupon->discount -= $discount;
							}
							$discount_sum += $discount;
							$update_discount += $discount;
							$netprice -= $discount;
							$coupon_id = $coupon->id;
						}
					}
					else
					{
						if ($coupon->type == 'procent')
						{
							$discount = $netprice * $coupon->discount / 100;
						}
						else
						{
							if ($netprice > $coupon->discount)
							{
								$discount = $coupon->discount;
							}
							else
							{
								$discount = $netprice;
							}
							$coupon->discount -= $discount;
						}
						$discount_sum += $discount;
						$update_discount += $discount;
						$netprice -= $discount;
						$coupon_id = $coupon->id;
					}
				
				}
				
				/*	if(isset($item->shipping['sum']) && (COMM_CART == 'cart' || COMM_CART == 'balance'))
				{
					$total_sum += $item->shipping['sum'];
					$balance += $item->shipping['sum'];
				}*/
				
				$total_sum -= $discount; //_sum;
				

				// checking customer's balance -------------------------------------------------------------------------------------------------
				if (COMM_CART == 'balance')
				{
					
					$model_balance = & $this->getModel('balance');
					$customer = $model_balance->getCustomerBalance($user->id);
					
					if ((!COMM_ALLOW_NEGATIVE_CUSTOMER && (!$customer || $customer->balance < $total_sum)) || (COMM_ALLOW_NEGATIVE_CUSTOMER && ($customer->balance - $total_sum) < COMM_NEGATIVE_LIMIT_CUSTOMER))
					{
						if (!COMM_CUSTOMER_PILEUP)
							$link = JRoute::_('index.php?option=com_commerce&view=balance&layout=customer&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_BALANCE_ITEMID != '') ? COMM_BALANCE_ITEMID : JRequest::getInt('Itemid')), false);
						else
						{
							$return = JRoute::_("index.php?option=com_commerce&view=balance&layout=customer&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_BALANCE_ITEMID != '') ? COMM_BALANCE_ITEMID : JRequest::getInt('Itemid')), false);
							$return .= '&return=' . base64_encode($back);
							$link = 'index.php?option=com_jsbill&view=bill&bill=' . COMM_CUSTOMER_PILEUP . '&Itemid=' . ((COMM_BILL_ITEMID != '') ? COMM_BILL_ITEMID : JRequest::getInt('Itemid')) . '&return_success=' . base64_encode($return) . '&return_fail=' . base64_encode($return);
						}
						$msg = JText::_('CART_BALANCE_ALERT');
						$msg = str_replace('[LINK]', JHTML::link($link, JText::_('here')), $msg);
						JError::raiseNotice(100, $msg);
						if (defined('COMM_GIFT_CERT') && COMM_GIFT_CERT)
						{
							$link = JRoute::_('index.php?option=com_commerce&view=balance&layout=customer&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_BALANCE_ITEMID != '') ? COMM_BALANCE_ITEMID : JRequest::getInt('Itemid')), false);
							$msg = JText::_('CART_GIFTCERT_BALANCE_ALERT');
							$msg = str_replace('[LINK]', JHTML::link($link, JText::_('here')), $msg);
							JError::raiseNotice(100, $msg);
						}
						$mainframe->redirect($back);
					
					}
				}
				// checking customer's balance end -----------------------------------------------------------------------------------------------
				

				$sql = "SELECT id FROM #__jc_orders_statuses WHERE name REGEXP '" . (COMM_CART_MODE == 'inquire' ? 'inquire' : 'pending') . "' AND type = 'product'";
				$db->setQuery($sql);
				$st_id = $db->loadResult();
				
				$prow = & JTable::getInstance("Products", 'Commerce');
				$vals = array();
				$vals['order_id'] = $row->id;
				$vals['product_id'] = $item->article;
				$vals['price'] = $price_core[$seller_id][$i];
				$vals['amount'] = $item->items_num;
				$vals['tax'] = $itax[$seller_id][$i];
				$vals['tax_rate'] = $tax[$seller_id][$i]->rate;
				$vals['tax_name'] = $tax[$seller_id][$i]->name;
				$vals['status_id'] = $st_id;
				$vals['status_change'] = ($st_id != 3 && $st_id != 5) ? 1 : 0;
				$vals['discount'] = $discount;
				$vals['coupon_id'] = $coupon_id;
				$vals['affect_sum'] = $affect[$seller_id][$i];
				$vals['product_link'] = $item->link;
				$vals['section_id'] = COMM_SECTION_ID;
				$vals['seller_id'] = $seller_id;
				
				/*if(isset($item->shipping))
				{
					$ext = new JParameter();
					$ext->set('shipping', serialize($item->shipping) );
					$vals['extra'] = $ext->toString();
				}*/
				
				if (!$prow->bind($vals))
				{
					JError::raiseWarning(500, $prow->getError());
					return;
				}
				if (!$prow->check())
				{
					JError::raiseWarning(500, $prow->getError());
					return;
				}
				
				if (!$prow->store())
				{
					JError::raiseWarning(500, $prow->getError());
					return;
				}
				
				$order_product_id = $db->insertid();
				if (isset($item->property))
				{
					foreach($item->property as $property)
					{
						foreach($property as $prop)
						{
							if (isset($prop))
							{
								$sql = "INSERT INTO #__jc_orders_products_property
								(`id`, `order_product_id`, `prop_id`, `property`, `price_affect`, `section_id`)
								VALUES
								('', '{$order_product_id}', '{$prop['prop_id']}', '{$prop['value']}', '" . (isset($prop['with_discount']) ? $prop['with_discount'] : $prop['price']) . "', '" . COMM_SECTION_ID . "')";
								$db->setQuery($sql);
								$db->query();
							}
						}
					}
				}
				$balance += $netprice;
			}
			if (isset($shipping[$seller_id]))
			{
				$prow = & JTable::getInstance("Products", 'Commerce');
				$vals = array();
				$vals['order_id'] = $row->id;
				$vals['product_id'] = 0;
				$vals['product_link'] = '';
				$vals['price'] = 0;
				$vals['amount'] = 0;
				$vals['status_id'] = 1;
				$vals['section_id'] = COMM_SECTION_ID;
				$vals['seller_id'] = $seller_id;
				$ext = new JParameter('');
				$shipping[$seller_id]['sum'] = round($shipping[$seller_id]['sum'], 2);
				$ext->set('shipping', serialize($shipping[$seller_id]));
				$vals['extra'] = $ext->toString();
				
				if (!$prow->bind($vals))
				{
					JError::raiseWarning(500, $prow->getError());
					return;
				}
				if (!$prow->check())
				{
					JError::raiseWarning(500, $prow->getError());
					return;
				}
				
				if (!$prow->store())
				{
					JError::raiseWarning(500, $prow->getError());
					return;
				}
			}
		
		}
		
		// calculating seller's balance
		$balance = (COMM_PAYMENT_METHOD == 'personal') ? round($balance * COMM_PERCENTAGE / 100, 2) + COMM_TRANSACTION : $balance - round($balance * COMM_PERCENTAGE / 100, 2) - COMM_TRANSACTION;
		
		if ($cart_coupon && (COMM_CART == 'cart' || COMM_CART == 'balance'))
		{
			$sql = "UPDATE #__jc_coupons SET used_num = used_num + 1";
			if ($coupon->type == 'sum')
			{
				$sql .= ", discount = discount - " . $update_discount;
			}
			$sql .= " WHERE value = '" . $cart_coupon['value'] . "'
				  AND seller_id = '" . $cart_coupon['seller_id'] . "' AND section_id = '" . COMM_SECTION_ID . "'";
			$db->setQuery($sql);
			$db->query();
		}
		if ($save = JRequest::getString('task'))
		{
			$link = '';
			if ($save == 'inquire')
			{
				$order_link = urlencode(JURI::root() . "index.php?option=com_commerce&view=orders&order_id={$row->id}&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt("Itemid")));
				$link = JURI::root() . "index.php?option=com_jsinbox&view=compose" . ((COMM_INQUIRE_TYPE > 0) ? "&type_id=" . COMM_INQUIRE_TYPE : "") . "&Itemid=" . ((COMM_INBOX_ITEMID != '') ? COMM_INBOX_ITEMID : JRequest::getInt("Itemid"));
				$link .= "&subject=" . JText::_('Inquire') . ' ' . JText::_('Order Num.') . ' ' . $row->id;
				$link .= "&additions[0][title]=" . JText::_("Order num.") . " {$row->id}&additions[0][url]=" . $order_link;
				$tmp = 0;
				
				if (COMM_MULTI_SELLER)
				{
					$names = $model->getSellerInfo(array_keys($cart), 'username');
				}
				else
				{
					$names = str_replace(', ', ',', COMM_INQUIRE_SELLERS);
					$names = explode(',', $names);
				}
				foreach($names as $name)
				{
					$link .= "&sto[$tmp][to]=$name";
					$tmp ++;
				}
				$link .= "&body=" . ((JRequest::getVar("comment") != '') ? $_POST['comment'] : JText::_('Inquire') . ' ' . JText::_('Order Num.') . ' ' . $row->id);
				$return = JURI::root() . "index.php?option=com_commerce&view=cart&clear=1&order_id={$row->id}";
				$return .= "&balance=" . $balance . '&section_id=' . COMM_SECTION_ID;
				$return .= "&Itemid=" . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt("Itemid"));
				$link .= "&return=" . base64_encode($return);
				$url = $link;
			}
			
			if ($save == 'buy')
			{
				
				if (COMM_MULTI_SELLER && COMM_PAYMENT_METHOD == 'personal')
				{
					$seller_id = array_keys($cart);
					$seller_id = $seller_id[0];
				}
				else
				{
					$seller_id = defined('COMM_OWNER') ? COMM_OWNER : 62;
				}
				
				if ($total_sum > 0)
				{
					$link = JURI::root() . "index.php?option=com_jsbill&view=bill&bill=1&Itemid=" . ((COMM_BILL_ITEMID != '') ? COMM_BILL_ITEMID : JRequest::getInt("Itemid"));
					$url = '';
					$link = '';
					$url_base = JURI::root() . "index.php?option=com_jsbill&view=bill";
					$tmp = 1;
					$sql = "SELECT element FROM #__plugins WHERE folder='bill_gateways' AND published = '1' ORDER BY ordering";
					$db->setQuery($sql);
					$billgw = $db->loadResultArray();
					foreach($cart as $seller => $items)
					{
						foreach($items as $i => $item)
						{
							$url .= "&item_title" . $tmp . "=" . urlencode($art_info[$seller][$i]->title);
							$url .= "&item_amount" . $tmp . "=" . $price_core[$seller][$i];
							$url .= "&item_amount_change" . $tmp . "=0";
							$url .= "&item_qnt" . $tmp . "=" . $item->items_num;
							$url .= "&item_qnt_change" . $tmp . "=0";
							$url .= "&item_tax" . $tmp . "=" . (isset($tax[$seller][$i]->rate) ? $tax[$seller][$i]->rate : 0);
							$url .= "&item_tax_name" . $tmp . "=" . $tax[$seller][$i]->name;
							$url .= "&item_tax_change" . $tmp . "=0";
							
							$tmp ++;
						
						}
						if (isset($shipping[$seller]['sum']))
						{
							$seller_info = JFactory::getUser($seller);
							$ship = explode('::', $shipping[$seller]['info']);
							$title = urlencode(JText::_('Products delivery from vendor') . ' ' . $seller_info->name . ' (' . $ship[0] . ', ' . $ship[1] . '; ' . JText::_('weight') . ': ' . $shipping[$seller]['weight'] . ' ' . JText::_('kg') . ')');
							$url .= "&item_title" . $tmp . "=" . $title;
							$url .= "&item_amount" . $tmp . "=" . $shipping[$seller]['sum'];
							$url .= "&item_amount_change" . $tmp . "=0";
							$url .= "&item_qnt" . $tmp . "=1";
							$url .= "&item_qnt_change" . $tmp . "=0";
							$url .= "&item_tax" . $tmp . "=0";
							$url .= "&item_tax_name" . $tmp . "=";
							$url .= "&item_tax_change" . $tmp . "=0";
							$tmp ++;
						}
					}
					if ($cart_coupon || $discount_sum > 0)
					{
						$url .= "&item_title" . $tmp . "=" . JText::_('Discount');
						$url .= "&item_amount" . $tmp . "=-" . round($discount_sum, 2);
						$url .= "&item_amount_change" . $tmp . "=0";
						$url .= "&item_qnt" . $tmp . "=1";
						$url .= "&item_qnt_change" . $tmp . "=0";
						$url .= "&item_tax" . $tmp . "=0";
						$url .= "&item_tax_name" . $tmp . "=";
						$url .= "&item_tax_change" . $tmp . "=0";
						$tmp ++;
					}
					
					$core = getCore();
					
					$url .= "&tax=0";
					$url .= "&tax_chose=0";
					$url .= "&order_number=" . $row->id;
					$url .= "&client=Mighty Commerce";
					$url .= "&coption=com_commerce";
					if ($user->id)
					{
						$url .= "&access=1";
					}
					else
					{
						$url .= "&access=0";
						$url .= "&userEmail=$cemail";
						$url .= "&userEmail_as_text=1";
					
		///******************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					}
					
					$url .= "&currency=" . $core->mark;
					$url .= "&price_formats=" . COMM_LAYOUT_PRICE;
					$url .= "&to_user=" . $user->id;
					$url .= "&extime=never";
					$url .= "&client_id={$row->id}";
					$url .= "&show_personal_taxid=1";
					
					if (COMM_MULTI_SELLER && COMM_PAYMENT_METHOD == 'personal')
					{
						$model_userconf = & $this->getModel('userconfig');
						$userconf = $model_userconf->getConfId($seller_id);
						$user_params = new JParameter($userconf);
						$available = (strstr(COMM_PAY_GATEWAYS, ":")) ? unserialize(COMM_PAY_GATEWAYS) : array(COMM_PAY_GATEWAYS);
						$disable = array_diff($billgw, $available);
						
						foreach($available as $pk => $pay)
						{
							JPluginHelper::importPlugin('bill_gateways', $pay);
							$pluginParams[$pk] = new JParameter($userconf, JPATH_ROOT . DS . 'plugins' . DS . 'bill_gateways' . DS . $pay . '.xml');
							$pl_prop = $pluginParams[$pk]->getParams('params', 'User');
							if ($pl_prop)
							{
								if ($user_params->get($pay . '_enable'))
								{
									foreach($pl_prop as $value)
									{
										$upval = $user_params->get("$value[5]");
										$upval = str_replace('[ORDER_ID]', $row->id, $upval);
										$upval = str_replace("\n", '\n', $upval);
										//$ulink = 'index.php?option=com_commerce&view=orders&layout=purchase&order_id='.$row->id.'&Itemid='.(COMM_PRODUCTLIST_ITEMID ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid'));
										$ulink = '';
										$upval = str_replace('[LINK]', urlencode($ulink), $upval);
										//$upval = str_replace('[LINK]', JURI::root(), $upval);
										$url .= "&processors[" . $value[5] . "]=" . $upval; //;$user_params->get("$value[5]");
									}
								}
								else
									$url .= "&processors[" . $pay . "_enable]=0";
							}
						}
						foreach($disable as $pay)
						{
							$url .= "&processors[" . $pay . "_enable]=0";
						}
						
						$seller = & JFactory::getUser($seller_id);
						$url .= "&seller[inv_person]=" . $seller->name . "; " . $user_params->get('usr_shop_email');
						$url .= "&seller[inv_logo]=-1";
						$url .= "&seller[inv_name]=" . $user_params->get('usr_shop_name');
						$url .= "&seller[inv_address]=" . $user_params->get('usr_shop_street');
						$url .= "&seller[inv_city]=" . $user_params->get('usr_shop_town');
						$url .= "&seller[inv_country]=" . $user_params->get('usr_shop_country');
						$url .= "&seller[inv_state]=" . $user_params->get('usr_shop_state');
						$url .= "&seller[inv_zip]=" . $user_params->get('usr_shop_zip');
						$url .= "&seller[inv_tel]=" . $user_params->get('usr_shop_tel');
						$url .= "&seller[inv_fax]=" . $user_params->get('usr_shop_fax');
						$url .= "&seller[inv_number]=";
						$url .= "&seller[inv_tax_id]=" . $user_params->get('usr_tax_id');
						$url .= "&seller[inv_add]=" . $user_params->get('usr_shop_misc');
						$url .= "&seller_id=" . $seller_id;
					}
					else
						$url .= "&seller_id=" . (defined('COMM_OWNER') ? COMM_OWNER : 62);
					
					$order_page = JURI::root() . "index.php?option=com_commerce&view=orders&layout=purchase&order_id={$row->id}&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt("Itemid"));
					if (COMM_MULTI_SELLER && COMM_PAYMENT_METHOD == 'personal')
					{
						$order_page .= "&balance=" . $balance . "&seller_id=" . $seller_id;
					}
					else
					{
						if (count($cart) == 1) //isset($shipping))
						{
							$seller_id = array_keys($cart);
							$seller_id = $seller_id[0];
							$order_page .= "&balance=" . $balance . "&seller_id=" . $seller_id;
						}
					}
					
					$url .= "&return_success=" . base64_encode($order_page);
					$url .= "&return_fail=" . base64_encode($order_page);
					$url .= "&show_district=1";
					
					if ($user->id && $address)
					{
						$billAddr = $model->getAddresses('bill', $address['bill']);
						$link .= '&billto_name=1&billto_address=1&billto_city=1&billto_state=1' . '&billto_zip=1&billto_country=1&billto_tel=1' . '&address_bill[as_text]=1' . '&address_bill[bill_name]=' . $billAddr->name . "&address_bill[bill_address]=" . $billAddr->address . '&address_bill[bill_city]=' . $billAddr->city . '&address_bill[bill_state]=' . $billAddr->state . '&address_bill[bill_zip]=' . $billAddr->zip . '&address_bill[bill_country]=' . $billAddr->country . '&address_bill[bill_tel]=' . $billAddr->tel;
						if (isset($address['ship']))
						{
							$shipAddr = $model->getAddresses('ship', $address['ship']);
							$link .= '&shipto_name=req' . '&shipto_address=req&shipto_city=req&shipto_state=req&shipto_zip=req' . '&shipto_country=req&shipto_tel=req' . '&address_ship[as_text]=1' . '&address_ship[ship_name]=' . $shipAddr->name . "&address_ship[ship_address]=" . $shipAddr->address . '&address_ship[ship_city]=' . $shipAddr->city . '&address_ship[ship_state]=' . $shipAddr->state . '&address_ship[ship_zip]=' . $shipAddr->zip . '&address_ship[ship_country]=' . $shipAddr->country . '&address_ship[ship_tel]=' . $shipAddr->tel;
						}
					}
					if (!$user->id && $unreg)
					{
						$unreg_bill = $unreg['bill'];
						$link .= '&billto_name=1&billto_address=1&billto_city=1&billto_state=1' . '&billto_zip=1&billto_country=1&billto_tel=1' . '&address_bill[as_text]=1' . '&address_bill[bill_name]=' . $unreg_bill['name'] . "&address_bill[bill_address]=" . $unreg_bill['address'] . '&address_bill[bill_city]=' . $unreg_bill['city'] . '&address_bill[bill_state]=' . $unreg_bill['state'] . '&address_bill[bill_zip]=' . $unreg_bill['zip'] . '&address_bill[bill_country]=' . $unreg_bill['country'] . '&address_bill[bill_tel]=' . $unreg_bill['tel'];
						if ($unreg_ship = $unreg['ship'])
						{
							$link .= '&shipto_name=req' . '&shipto_address=req&shipto_city=req&shipto_state=req&shipto_zip=req' . '&shipto_country=req&shipto_tel=req' . '&address_ship[as_text]=1' . '&address_ship[ship_name]=' . $unreg_ship['name'] . "&address_ship[ship_address]=" . $unreg_ship['address'] . '&address_ship[ship_city]=' . $unreg_ship['city'] . '&address_ship[ship_state]=' . $unreg_ship['state'] . '&address_ship[ship_zip]=' . $unreg_ship['zip'] . '&address_ship[ship_country]=' . $unreg_ship['country'] . '&address_ship[ship_tel]=' . $unreg_ship['tel'];
						}
					}
					$url .= $link;
					$url .= '&Itemid=' . (COMM_BILL_ITEMID != '' ? COMM_BILL_ITEMID : JRequest::getInt('Itemid'));
				}
				else
				{
					$sql = "UPDATE #__jc_orders SET pay = 'free', gateway = '.zero-price' WHERE id = '{$row->id}'";
					$db->setQuery($sql);
					$db->query();
					$order_page = "index.php?option=com_commerce&view=orders&layout=purchase&order_id={$row->id}&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt("Itemid"));
					if (COMM_MULTI_SELLER && COMM_PAYMENT_METHOD == 'personal')
					{
						$order_page .= "&balance=" . $balance . "&seller_id=" . $seller_id;
					}
					else
					{
						if ($shipping)
						{
							$seller_id = array_keys($cart);
							$seller_id = $seller_id[0];
							$order_page .= "&balance=" . $balance . "&seller_id=" . $seller_id;
						}
					}
					$order_page .= '&result_pay=success&result_user_id=' . $user->id . '&result_gateway=.zero-price&result_gateway_id=' . $row->gateway_id;
					$url = $order_page;
				}
			}
			$url = str_replace("\n", "", $url);
			if ($save == 'buy')
			{
				$url_base .= $url;
				$url = $url_base;
				if (strstr($_SERVER["HTTP_USER_AGENT"], 'MSIE'))
				{
					$url_parsed = parse_url($url);
					$params = explode('&', $url_parsed['query']);
					$txt = '';
					$txt .= '<dl id="system-message">
					<dt class="notice">Message</dt>
					<dd class="notice">
						<ul>
							<li>
							' . JText::_("This page will redirect you to the payment gateway in") . ' <span id="countDown">5 ' . JText::_('seconds') . '</span>
							</li>
						</ul>
					</dd>
	  			</dl>';
					$txt .= '<form action="' . JURI::root() . '/index.php" method="post" name="formPayBill">';
					foreach($params as $param)
					{
						$val = explode('=', $param);
						$txt .= '<input type="hidden" name="' . $val[0] . '" value="' . (isset($val[1]) ? urldecode($val[1]) : '') . '">';
					}
					$txt .= '<script type="text/javascript">
						countdown(5);
						function countdown(i)
						{				
							document.getElementById("countDown").innerHTML = i + (i == 1 ? " second": " seconds");
							i = i - 1;
							if(i >= 0)
							setTimeout("countdown(" + i + ")", 1000);
							else
							document.formPayBill.submit();
						}
						</script>
						<noscript>
						<p>' . JText::_('If you are not redirected automatically please click the button Send') . '
						<input type="submit" value="' . JText::_('Send') . '" class="button">
						</p>
						</noscript>';
					$txt .= '</form>';
					echo $txt;
					return;
				
				}
			}
			if ($url != '')
			{
				$mainframe->redirect(JRoute::_($url, false));
			}
		}
	}

	function recalculate()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$session = JFactory::getSession();
		$session_id = $session->getId();
		$amount = JRequest::getVar('amount');
		$fields = JRequest::getVar('fields');
		$model =  $this->getModel('cart');
		$dispatcher =  JDispatcher::getInstance();
		
		$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
		
		$cart = $session->get('my_cart' . '-' . COMM_SECTION_ID);
		$msg = '';
		$clear_discount_simple = 0;
		foreach($cart as $seller_id => $items)
		{
			foreach($items as $k => $item)
			{
				if ($item->items_num != $amount[$seller_id][$k])
					$clear_discount_simple ++;
				$cart[$seller_id][$k]->items_num = $amount[$seller_id][$k];
				
				if ($tangible = $model->isTangible($item->article))
				{
					$tangible = $tangible[0];
					$tang_params = new JParameter($tangible->value);
					if ($tang_params->get('weight'))
					{
						if (!$tang_params->get('storage', 0))
						{
							$cart[$seller_id][$k]->items_num = 0;
							$mainframe->redirect(JRoute::_($link, false), JText::_("There are no some items on storage. Please delete it from your cart"), 'Error');
						}
					}
				}
				$prop = array();
				if (isset($fields[$seller_id][$k]) && count($fields[$seller_id][$k]) > 0)
				{
					$tmp = 0;
					foreach($fields[$seller_id][$k] as $val)
					{
						if ($val['require_before_order'] && !isset($val['property']))
							$msg = JText::_("You did not select required products properties");
						
						$ptype = $model->getPropertyType($val['prop_id']);
						JPluginHelper::importPlugin('joomsuite_content_fields', $ptype);
						if (isset($val['property']))
						{
							$props = $val['property'];
							$dispatcher->trigger('onCommerceCartRecalculate', array(&$props, $val['prop_id'], $item->article));
						}
						
						if (isset($props))
						{
							if (is_array($props))
							{
								$n = 0;
								foreach($props as $pr_prop)
								{
									$val_prop = explode("__PROD_PROP__", $pr_prop);
									$prop[$tmp][$n] = array('value' => $val_prop[0], 'price' => $val_prop[1], 'prop_id' => $val['prop_id']);
									if (isset($val_prop[2]) && $val_prop[2])
										$prop[$tmp][$n] = array_merge($prop[$tmp][$n], array('with_discount' => $val_prop[2]));
									$n ++;
								}
							}
							else
							{
								$val_prop = explode("__PROD_PROP__", $props);
								$prop[$tmp][0] = array('value' => $val_prop[0], 'price' => $val_prop[1], 'prop_id' => $val['prop_id'], 'with_discount' => $val_prop[2]);
								if ($val_prop[2])
									$prop[$tmp][0] = array_merge($prop[$tmp][0], array('with_discount' => $val_prop[2]));
							
							}
						}
						$tmp ++;
					}
				}
				if (isset($item->property))
				{
					unset($cart[$seller_id][$k]->property);
				}
				if (count($prop) > 0)
					$cart[$seller_id][$k]->property = $prop;
				if ($clear_discount_simple)
					unset($cart[$seller_id][$k]->suite_discount);
			}
		}
		$session->set('my_cart' . '-' . COMM_SECTION_ID, $cart);
		$session->clear('shipping' . '-' . COMM_SECTION_ID);
		
		$mainframe->redirect(JRoute::_($link, false), $msg, 'Notice');
	
	}

	function apply_coupon()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$db =  JFactory::getDBO();
		$session =  JFactory::getSession();
		$model =  $this->getModel('cart');
		
		$coupon = JRequest::getVar('coupon');
		$session->clear('my_cart_coupon' . '-' . COMM_SECTION_ID);
		$this->initCoupon($coupon);
		
		if (!$this->couponExists)
		{
			JError::raiseNotice(100, JText::_('Coupon or Gift Certificate number do not exists'));
			parent::display();
			return;
		}
		else
		{
			if (!$this->couponValid)
			{
				JError::raiseNotice(100, JText::_('Coupon or Gift Certificate is not valid'));
				JError::raiseNotice(100, $this->couponError);
				parent::display();
				return;
			}
			else
			{
				if (COMM_MULTI_SELLER && !$this->couponCore)
				{
					$cart = $session->get('my_cart' . '-' . COMM_SECTION_ID);
					if (!in_array($this->seller_id, array_keys($cart)))
					{
						JError::raiseNotice(100, JText::_('Coupon or Gift Certificate is not valid'));
						JError::raiseNotice(100, JText::_('This coupon could not be applied to the products '));
						parent::display();
						return;
					}
				}
				$cart_coupon = array("value" => $coupon, "seller_id" => $this->seller_id, 'id' => $this->coupon_id, 'core' => $this->couponCore);
				$session->set('my_cart_coupon' . '-' . COMM_SECTION_ID, $cart_coupon);
				
				$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
				$mainframe->redirect(JRoute::_($link, false), JText::_('Coupon is applied successfully'));
			}
		}
	
	}

	function initCoupon($coupon)
	{
		$db =  JFactory::getDBO();
		$session =  JFactory::getSession();
		//$session_id = $session->getId();
		$cart = $session->get('my_cart' . '-' . COMM_SECTION_ID);
		$user =  JFactory::getUser();
		
		$sql = "SELECT *,  IF( extime > NOW() or YEAR(extime) =  0 , 0, 1)  as expired
		FROM #__jc_coupons WHERE `value` = '" . addslashes($coupon) . "' AND `published` = 1 AND `ctime` <= NOW() AND section_id = '" . COMM_SECTION_ID . "'";
		$db->setQuery($sql);
		$row = $db->loadObject();
		
		if ($row)
		{
			$this->discount = $row->discount;
			$this->discount_type = $row->discount_type;
			$this->seller_id = $row->seller_id;
			$this->coupon_id = $row->id;
			$this->couponValid = true;
			$this->couponCore = $row->core;
			
			if ($row->value)
			{
				$this->couponExists = true;
			}
			else
			{
				$this->couponExists = false;
			}
			
			if (($row->use_num > 0) && ($row->used_num >= $row->use_num))
			{
				$this->couponValid = false;
				$this->couponError = JText::_('Coupon used out');
			}
			
			if (($row->discount_type == 'sum') && ($row->discount <= 0))
			{
				$this->couponValid = false;
				$this->couponError = JText::_('Coupon used out');
			}
			
			if ($row->expired)
			{
				$this->couponValid = false;
				$this->couponError = JText::_('Coupon expired');
			}
			
			if ($row->user_ids != '' && strtolower($row->user_ids) != 'any')
			{
				$user = JFactory::getUser();
				$ids = explode(",", $row->user_ids);
				if (!in_array($user->get('id'), $ids))
				{
					$this->couponValid = false;
					$this->couponError = JText::_('You are not allowed to use this coupon');
				}
			}
			if ($row->product_ids != '' && $row->product_ids != 'Any')
			{
				$ids = explode(",", $row->product_ids);
				foreach($cart as $i => $seller)
				{
					foreach($seller as $item)
					{
						$sid[] = $item->article;
					}
				}
				$intersect = array_intersect($sid, $ids);
				if (count($intersect) == 0)
				{
					$this->couponValid = false;
					$this->couponError = JText::_('This coupon is not valid to products');
				}
			}
			if ($row->usercategory_ids && $row->usercategory_ids != '')
			{
				$pt_file = JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'community.php';
				if (file_exists($pt_file))
				{
					$gids = explode(",", $row->usercategory_ids);
					foreach($cart as $i => $seller)
					{
						foreach($seller as $item)
						{
							$sid[] = $item->article;
						}
					}
					$intersect = array_intersect($sid, $gids);
					$sql = " ( SELECT cc.id FROM #__community_user_mapping um
					JOIN #__community_communities cc ON um.group_id = cc.id
					JOIN #__js_res_record r ON cc.user_id = r.user_id
					WHERE r.id IN (" . implode(", ", $sid) . ") AND um.user_id = '{$user->id}' )
					UNION
					( SELECT id FROM #__community_communities WHERE user_id = '{$user->id}')";
					$db->setQuery($sql);
					$ugid = $db->loadResultArray();
					$intersect = array_intersect($ugid, $gids);
					if (count($intersect) == 0)
					{
						$this->couponValid = false;
						$this->couponError = JText::_('This coupon is not valid to the group');
					}
				
				}
			}
			
			if ($row->use_user > 0)
			{
				$sql = "SELECT count(*)
				FROM #__jc_orders ord
				JOIN #__jc_orders_products pr ON pr.order_id = ord.id
				JOIN #__jc_coupons cp ON cp.id = pr.coupon_id
				WHERE pr.coupon_id = '{$row->id}' AND ord.ctime >= cp.ctime AND ord.user_id = '{$user->id}'";
				
				$db->setQuery($sql);
				$num = $db->loadResult();
				
				if ($num >= $row->use_user)
				{
					$this->couponValid = false;
					$this->couponError = JText::_('You have used this coupon amount of times allowed');
				}
			}
			
			if ($this->couponCore)
			{
				$session = & JFactory::getSession();
				$order_sum = $session->get('order_sum');
				if ($row->order_sum > $order_sum)
				{
					$this->couponValid = false;
					$this->couponError = JText::_('Your order amount is less than allowed sum for this coupon');
				}
			}
		}
		else
			$this->couponExists = false;
	}

	function save_shipinfo()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$user =  JFactory::getUser();
		$model =  $this->getModel('cart');
		$task = JRequest::getString('task');
		
		if ($task == 'save_billinfo')
		{
			$info = array('name' => JRequest::getString('name'), 'address' => JRequest::getString('address'), 'city' => JRequest::getString('city'), 'state' => JRequest::getString('district'), 'zip' => JRequest::getString('zip'), 'country' => JRequest::getString('country'), 'tel' => JRequest::getString('tel'));
			$type = 'bill';
		}
		else
		{
			$info = array('name' => JRequest::getString('ship_name'), 'address' => JRequest::getString('ship_address'), 'city' => JRequest::getString('ship_city'), 'state' => JRequest::getString('ship_district'), 'zip' => JRequest::getString('ship_zip'), 'country' => JRequest::getString('ship_country'), 'tel' => JRequest::getString('ship_tel'));
			$type = 'ship';
		}
		if ($user->id)
			$model->saveAddresses($type, $info);
		else
		{
			$session =  JFactory::getSession();
			$save = $session->get('unreg_address');
			$save[$type] = $info;
			$session->set("unreg_address", $save);
		}
		$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function copybillto()
	{
		global $mainframe;
		$session =  JFactory::getSession();
		$uri = JFactory::getURI();
		$user =  JFactory::getUser();
		$model =  $this->getModel('cart');
		if ($user->id)
		{
			$address = $session->get('address');
			$db =  JFactory::getDBO();
			$sql = "INSERT INTO #__jc_users_addresses
			(name, type, user_type, published, user_id, address, zip, state, country, city, tel, section_id) 
			(SELECT 
			name, 'ship', user_type, published, user_id, address, zip, state, country, city, tel, '" . COMM_SECTION_ID . "'
			FROM #__jc_users_addresses WHERE id='" . $address['bill'] . "')";
			$sql = "SELECT
			name, 'ship', user_type, published, user_id, address, zip, state, country, city, tel, '" . COMM_SECTION_ID . "' 
			FROM #__jc_users_addresses WHERE id='" . $address['bill'] . "'";
			$db->setQuery($sql);
			$info = $db->loadAssoc();
			$model->saveAddresses('ship', $info);
		}
		else
		{
			$address = $session->get('unreg_address');
			$session->set('unreg_address', array('ship', $address['bill']));
		}
		$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function changeBillAddress()
	{
		global $mainframe;
		$session =  JFactory::getSession();
		$uri = JFactory::getURI();
		$task = JRequest::getString('task');
		$type = ($task == 'changeBillAddress') ? 'bill' : 'ship';
		$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
		$address = $session->get('address');
		$address[$type] = JRequest::getInt('change' . ucfirst($type) . 'Addr');
		$session->set('address', $address);
		$mainframe->redirect(JRoute::_($link, false));
	}

	function change_section()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function save_as_template()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&view=carttemplate&layout=form&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CARTTEMPLATE_ITEMID != '') ? COMM_CARTTEMPLATE_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect(JRoute::_($link, false));
	}

}
?>
