<?php
/**
 * $Id: carttemplate.php 7811 2012-02-15 08:02:07Z alfiya $
 * $LastChangedDate: 2012-02-15 14:02:07 +0600 (Wed, 15 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerCartTemplate extends CommerceController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('cancel', 'cancel');
		$this->registerTask('apply_template', 'save_template');
	}

	function display()
	{
		global $mainframe;
		JRequest::setVar('view', 'carttemplate');
		parent::display();
	}

	function edit_carttemplate()
	{
		JRequest::setVar('view', 'carttemplate');
		JRequest::setVar('layout', 'form');
		parent::display();
	}

	function save_template()
	{
		global $mainframe, $ICONS;
		$db  =& JFactory::getDBO();
		$row =& JTable::getInstance("Carttemplate", 'Commerce');
		$session = & JFactory::getSession();
		$user = JFactory::getUser();

		$vals = array();
		$vals['share'] = JRequest::getInt('share');
		$vals['name'] = JRequest::getVar('name');
		$vals['description'] = JRequest::getVar('descr');
		$vals['id'] = JRequest::getInt('id');
		$vals['section_id'] = COMM_SECTION_ID;
		$register = false;
		if($vals['id'])
		{
			$data = $row;
			$data->load($vals['id']);
			$cart = unserialize($data->details);
		}
		else
		{
			$cart = $session->get('my_cart'.'-'.COMM_SECTION_ID);
			$register = true;
		}
		$link = 'index.php?option=com_commerce&view=carttemplate&layout=form'.($vals['id'] ? '&user_id='.$user_id.'&cid[]='.$vals['id'] : '').'&section_id='.COMM_SECTION_ID.
				'&Itemid='.(COMM_CARTTEMPLATE_ITEMID ? COMM_CARTTEMPLATE_ITEMID : JRequest::getInt('Itemid'));
			

		$items_remove = JRequest::getVar('items_remove');

		$amount = JRequest::getVar('amount');
		$new_cart = array();
		foreach ($cart as $seller_id => $items)
		{
			foreach ($items as $k => $item)
			{
				$ind = $seller_id.'::'.$k;
				if( (count($items_remove) && !in_array($ind, $items_remove) ) || !count($items_remove) )
				{
					if(!$amount[$ind])
					{
						$this->setRedirect(JRoute::_($link, false), JText::_('There are no some items on storage. Please delete it from template.'), 'Notice' );
						return;
					}
					$new_cart[$seller_id][$k] = $item;
					$new_cart[$seller_id][$k]->items_num = $amount[$ind];
				}
			}
		}

		if(!count($new_cart))
		{
			$this->setRedirect(JRoute::_($link, false), JText::_('There are could not be no items in a template.'), 'Notice' );
			return;
		}
		$vals['details'] = serialize($new_cart);

		if (!$row->bind( $vals ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}

		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}
		$row->checkin();
		$msg = JText::_("Cart template was successfully saved");

		//$session->clear('my_cart'.'-'.COMM_SECTION_ID);

		$itemid = ( (COMM_CARTTEMPLATE_ITEMID != '') ? COMM_CARTTEMPLATE_ITEMID : JRequest::getInt("Itemid"));

		$API = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
		if($register && file_exists($API) && $vals['share'] && COMM_REG_ACTIVITY)
		{

			$link = 'index.php?option=com_commerce&view=carttemplate';
			if($user_id)
			$link .= '&user_id='.$user_id;
			$link .= '&layout=details&id='.$row->id;
			$link .= '&section_id='.COMM_SECTION_ID.'&Itemid='.$itemid;
			$act_msg = JText::_('created new cart template "[NAME]"');
			$act_msg = str_replace('[NAME]', JHTML::link($link, $vals['name']), $act_msg);
			$icon = 'components/com_commerce/'.$ICONS.'/sidebar/carttemplate.png';
			require_once $API;
			if(class_exists('JSCommunityApi')) $capi = new JSCommunityApi(); else $capi = new stdClass();
			if(method_exists($capi, 'registerActivity'))
			$capi->registerActivity($row->user_id, $act_msg, $row->user_id, $icon, 'user', null,  0, 'com_commerce');

		}
			
		if(JRequest::getVar('task') == 'apply_template')
		{
			$link = 'index.php?option=com_commerce&view=carttemplate&layout=form';
			if($user_id)
			$link .= '&user_id='.$user_id;
			$link .= '&cid[]='.$row->id.'&section_id='.COMM_SECTION_ID.'&Itemid='.$itemid;
		}
		else
		{
			$link = 'index.php?option=com_commerce&view=carttemplate&';
			if($user_id)
			$link .= '&user_id='.$user_id;
			$link .= '&section_id='.COMM_SECTION_ID.'&Itemid='.$itemid;
		}

		$mainframe->redirect(JRoute::_($link, false), $msg);

	}

	function cancel()
	{
		global $mainframe;
		$user_id = JRequest::getInt('user_id');
		$link = 'index.php?option=com_commerce&view=carttemplate';
		if($user_id)
		$link .= '&user_id='.$user_id;
		$link .= '&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_CARTTEMPLATE_ITEMID != '') ? COMM_CARTTEMPLATE_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function save_as_cart()
	{
		global $mainframe;
		$row =& JTable::getInstance("Carttemplate", 'Commerce');
		$id = JRequest::getInt('id');
		$row->load($id);
		$session = & JFactory::getSession();
		$model_cart  = JModel::getInstance('Cart', 'CommerceModel');
		$cart = unserialize($row->details);
		foreach ($cart as $k => $item)
		{
			if($tangible = $model_cart->isTangible($item->article))
			{
				$tangible = $tangible[0];
				$tang_params = new JParameter($tangible->value);
				if($tang_params->get('weight'))
				{
					if(!$tang_params->get('storage', 0))
					{
						$cart[$k]->items_num = 0;
					}
				}
			}
		}
		$session->set('my_cart'.'-'.COMM_SECTION_ID, $cart);
		$link = 'index.php?option=com_commerce&view=cart&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function change_section()
	{
		global $mainframe;
		$user_id = JRequest::getInt('user_id');
		$link = 'index.php?option=com_commerce&view=carttemplate';
		if($user_id)
		$link .= '&user_id='.$user_id;
		$link .= '&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_CARTTEMPLATE_ITEMID != '') ? COMM_CARTTEMPLATE_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect( JRoute::_($link, false) );
	}

	function show_my()
	{
		$user   = & JFactory::getUser();
		$link = 'index.php?option=com_commerce&view=carttemplate&user_id='.$user->id.'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_CARTTEMPLATE_ITEMID != '') ? COMM_CARTTEMPLATE_ITEMID : JRequest::getInt("Itemid"));
		$this->setRedirect(JRoute::_($link, false));
	}

}
?>
