<?php
/**
 * $Id: coupon.php 7782 2012-02-09 09:43:38Z alfiya $
 * $LastChangedDate: 2012-02-09 15:43:38 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerCoupon extends CommerceController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('edit_coupon', 'add_coupon');
		$this->registerTask('apply_coupon', 'save_coupon');
		$this->registerTask('cancel', 'cancel');
	}

	function display()
	{
		global $mainframe;
			
		$user =& JFactory::getUser();
		if(!$user->id)
		{
			$cpanel = JRoute::_('index.php?option=com_commerce&view=coupon&section_id='.COMM_SECTION_ID.'&Itemid='.JRequest::getInt('Itemid'), false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($cpanel), false), 
				JText::_('You are not authorized to see that page'), 'Error');
		}
		if(!$user->get('is_seller') && !$user->is_silver && !$user->is_gold)
		{
			CommerceController::checkConfirmBySubscription(); 
			JError::raiseWarning(500, JText::_('ERROR You are not allowed to see this page') );
			return;
		}
		$model = & $this->getModel('userconfig');
		if(!$model->getConfId($user->id))
		{
			$link = "index.php?option=com_commerce&view=userconfig&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_USERCONFIG_ITEMID != '') ? COMM_USERCONFIG_ITEMID : JRequest::getInt("Itemid"));
			$mainframe->redirect(JRoute::_($link, false), JText::_("You have not saved your configuration. Please fill the fields to continue."), 'Notice');
		}
		JRequest::setVar('view', 'coupon');
		parent::display();
	}

	function add_coupon()
	{
		JRequest::setVar('view', 'coupon');
		JRequest::setVar('layout', 'form');
		parent::display();
	}

	function save_coupon()
	{
		global $mainframe;
		$db  =& JFactory::getDBO();
		$row = JTable::getInstance("Coupon", 'Commerce');
		$vals = array();

		$vals['value'] = JRequest::getVar('value');
		$vals['published'] = JRequest::getVar('published');
		$vals['core'] = JRequest::getVar('iscore');
		$vals['order_sum'] = JRequest::getVar('sum');
		$vals['discount'] = JRequest::getVar('discount');
		$vals['discount_type'] = JRequest::getVar('discount_type');
		$vals['user_ids'] = JRequest::getVar('user_ids');
		$vals['product_ids'] = JRequest::getVar('product_ids');
		$vals['usercategory_ids'] = JRequest::getVar('usercategory_ids');
		$vals['category_ids'] = JRequest::getVar('category_ids');
		$vals['use_num'] = JRequest::getInt('use_num');
		$vals['ctime'] = JRequest::getVar('ctime');
		$vals['extime'] = JRequest::getVar('extime');
		$vals['used_num'] = JRequest::getInt('used_num');
		$vals['id'] = JRequest::getInt('id');
		if(is_array($vals['usercategory_ids']))
		$vals['usercategory_ids'] = implode(",", $vals['usercategory_ids']);
		$vals['section_id'] = COMM_SECTION_ID;
		$vals['invisible'] = JRequest::getInt('invisible');
		$vals['use_user'] = JRequest::getInt('use_user');
 
		if (!$row->bind( $vals ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}

		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}
		$row->checkin();
		$msg = JText::_("Coupon was successfully saved");
		if(JRequest::getVar('task') == 'apply_coupon')
		$link = 'index.php?option=com_commerce&view=coupon&task=edit_coupon&cid[]='.$row->id.'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_COUPON_ITEMID != '') ? COMM_COUPON_ITEMID : JRequest::getInt("Itemid"));
		else
		$link = 'index.php?option=com_commerce&view=coupon&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_COUPON_ITEMID != '') ? COMM_COUPON_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false), $msg);
	}

	function cancel()
	{
		global $mainframe;
		$row =& JTable::getInstance('coupon', 'commerce');
		$row->checkin(JRequest::getInt('id'));
		
		$link = 'index.php?option=com_commerce&view=coupon&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_COUPON_ITEMID != '') ? COMM_COUPON_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false));
	}
	
	function core_coupon()
	{
		global $mainframe;
		$db = JFactory::getDBO();
		$id = JRequest::getVar('cid');
				
		$sql = "UPDATE #__jc_coupons SET core = '1' WHERE id IN ( ".implode(', ', $id)." )";
		$db->setQuery($sql);
		$db->query();
		$link = 'index.php?option=com_commerce&view=coupon&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_COUPON_ITEMID != '') ? COMM_COUPON_ITEMID : JRequest::getInt('Itemid'));		
		$mainframe->redirect(JRoute::_($link, false));
	}
	function change_section()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&view=coupon&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_COUPON_ITEMID != '') ? COMM_COUPON_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect( JRoute::_($link, false) );
	}

}
?>
