<?php
/**
 * $Id: currency.php 7782 2012-02-09 09:43:38Z alfiya $
 * $LastChangedDate: 2012-02-09 15:43:38 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerCurrency extends CommerceController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('edit_currency', 'add_currency');
		$this->registerTask('save_currency', 'apply_currency');
		$this->registerTask('cancel', 'cancel');
	}

	function display()
	{
		global $mainframe;

		$user =& JFactory::getUser();
		if(!$user->id)
		{
			$cpanel = JRoute::_('index.php?option=com_commerce&view=currency&section_id='.COMM_SECTION_ID.'&Itemid='.JRequest::getInt('Itemid'), false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($cpanel), false), 
				JText::_('You are not authorized to see that page'), 'Error');
		}
		if(!$user->get('is_seller') && !$user->is_silver && !$user->is_gold)
		{
			CommerceController::checkConfirmBySubscription(); 
			JError::raiseWarning(500, JText::_('ERROR You are not allowed to see this page') );
			return;
		}
		$model = & $this->getModel('userconfig');
		if(!$model->getConfId($user->id))
		{
			$link = "index.php?option=com_commerce&view=userconfig&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_USERCONFIG_ITEMID != '') ? COMM_USERCONFIG_ITEMID : JRequest::getInt("Itemid"));
			$mainframe->redirect(JRoute::_($link, false), JText::_("You have not saved your configuration. Please fill the fields to continue."), 'Notice');
		}
		JRequest::setVar('view', 'currency');
		parent::display();
	}

	function add_currency()
	{
		JRequest::setVar('view', 'currency');
		JRequest::setVar('layout', 'form');
		parent::display();
	}

	function apply_currency()
	{
		global $mainframe, $comm_secid;
		$db  =& JFactory::getDBO();
		$row =& JTable::getInstance("Currency", 'Commerce');
		$vals = array();
		$vals['currency_id'] = JRequest::getVar('currency_id');
		$vals['published'] = JRequest::getVar('published');
		$vals['mark'] = JRequest::getVar('mark');
		$vals['format'] = JRequest::getVar('format');
		$vals['rate'] = JRequest::getVar('rate');
		$vals['rate1'] = JRequest::getVar('rate1');
		$vals['id'] = JRequest::getVar('id');
		$vals['section_id'] = COMM_SECTION_ID;

		if (!$row->bind( $vals ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}

		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}
		$core = getCore();
		$curr = $this->getCurrent( $vals['id']);
		if($curr->mark == '')
		{
			$this->updateMark($vals['mark'], $vals['currency_id']);			
		}
		
		$row->checkin();
		$msg = JText::_("Currency was successfully saved");
		if(JRequest::getVar('task') == 'apply_currency')
		$link = 'index.php?option=com_commerce&view=currency&task=edit_currency&cid[]='.$row->id.'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_CURRENCY_ITEMID != '') ? COMM_CURRENCY_ITEMID : JRequest::getInt("Itemid"));
		else
		$link = 'index.php?option=com_commerce&view=currency&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_CURRENCY_ITEMID != '') ? COMM_CURRENCY_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false), $msg);
	}
	
	function cancel()
	{
		global $mainframe;
		$row =& JTable::getInstance('currency', 'commerce');
		$row->checkin(JRequest::getInt('id'));
		$link = 'index.php?option=com_commerce&view=currency&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_CURRENCY_ITEMID != '') ? COMM_CURRENCY_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false));
	}

	

	function getCurrent($cid)
	{
		$db =& JFactory::getDBO();

		if($cid)
		{
			$query = "
			SELECT c.*, u.format
			FROM #__jc_users_currencies AS u
			LEFT JOIN #__jc_currency AS c ON u.currency_id = c.id
			WHERE u.id = '$cid' ";
			$db->setQuery( $query);
			$row = $db->loadObjectList();
			return $row[0];
		}
		return '';
	}

	function updateMark($mark, $id)
	{
		$db =& JFactory::getDBO();
		$query = "UPDATE #__jc_currency SET `mark` = '$mark' WHERE id = '$id'";
		$db->setQuery( $query);
		$db->query();
	}
	function getUsedIds($seller, $id)
	{
		$db =& JFactory::getDBO();
		$user   =& JFactory::getUser();

		if(!$seller) $seller = $user->get('id');

		$query = "SELECT u.currency_id
		FROM #__jc_users_currencies AS u
		WHERE u.seller_id = $seller AND u.section_id = ".COMM_SECTION_ID;
		$db->setQuery( $query);

		$array = $db->loadResultArray();
		if($id)
		{
			$array = array_flip($array);
			unset($array[$id]);
			$array = array_flip($array);
		}
		return $array;
	}
	
	function select($default, $uid = false)
	{
		$db =& JFactory::getDBO();
		$user   =& JFactory::getUser();
		if(!$uid) $uid = $user->get('id');
		$query = "
		SELECT c.id,
		c.name,
		c.code,
		IF(c.mark, c.mark, c.code) as mark
		FROM #__jc_currency  AS c
		LEFT JOIN #__jc_users_currencies AS u ON c.id = u.currency_id
		WHERE c.id = '".COMM_CORE_CURRENCY."'
		OR u.seller_id = $uid
		AND u.section_id = '".COMM_SECTION_ID."'
		ORDER BY c.id DESC,
		c.name ASC";

		$db->setQuery( $query);
		$rows = $db->loadObjectList();
		foreach($rows as $row)
		{
			$c[] = JHTML::_('select.option', $row->id, "($row->code) ".$row->name);
		}
		return JHTML::_('select.genericlist', $c, 'currency_id', 'class="inputbox"', 'value', 'text', $default );
	}

	function select_all($default, $exclude =  array(0))
	{
		$db =& JFactory::getDBO();
		$exclude = implode(',', $exclude);
		$sql = "SELECT id, name, code FROM #__jc_currency WHERE id != '".COMM_CORE_CURRENCY."'  ORDER BY name ASC";// and id NOT IN (1,2)";

		$db->setQuery( $sql);
		$curs = $db->loadObjectList();

		foreach($curs AS $cur)
		{
			$clist[] = JHTML::_('select.option', $cur->id, $cur->name);
		}
		return JHTML::_('select.genericlist', $clist, 'currency_id', 'class="inputbox" size="9" onchange="chCode();"', 'value', 'text', $default);
	}

	function change_section()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&view=currency&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_CURRENCY_ITEMID != '') ? COMM_CURRENCY_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect( JRoute::_($link, false) );
	}
}
?>
