<?php
/**
 * $Id: orders.php 7992 2012-03-29 05:04:29Z alfiya $
 * $LastChangedDate: 2012-03-29 11:04:29 +0600 (Thu, 29 Mar 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerOrders extends CommerceController
{
	function __construct()
	{
		parent::__construct();
	}

	function display()
	{
		global $mainframe;

		$user =& JFactory::getUser();

		if(!$user->get('is_seller') && !$user->is_silver && !$user->is_gold && !JRequest::getVar('layout'))
		{
			JError::raiseWarning(500, JText::_('ERROR You are not allowed to see Sales history page') );
			CommerceController::checkConfirmBySubscription( true );
			$link = "index.php?option=com_commerce&view=orders&layout=purchase&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_PURCHASEHIST_ITEMID != '') ? COMM_PURCHASEHIST_ITEMID : $Itemid);
			$mainframe->redirect( JRoute::_($link, false) );
			return;
		}
		JRequest::setVar('view', 'orders');
		parent::display();
	}
	function apply()
	{
		global $mainframe;
		$uri    = &JFactory::getURI();
		$session = &JFactory::getSession();
		$save['order_id'] = JRequest::getInt('order_num');
		$save['cemail'] = JRequest::getString('email');
		$session->set('customer', $save);
		$uri->setVar('order_id', $save['order_id']);
		$url = $uri->toString();
		$uri->delVar('order_id');
		$mainframe->redirect(JRoute::_($url, false));
	}

	function reset()
	{
		global $mainframe;
		$session = &JFactory::getSession();
		$session->clear('customer');
		$link = "index.php?option=com_commerce&view=orders&layout=details&section_id=".COMM_SECTION_ID."&Itemid=".JRequest::getInt('Itemid');
		$mainframe->redirect(JRoute::_($link, false));
	}

	function invoices()
	{
		global $mainframe;
		$session = &JFactory::getSession();
		$customer = $session->get('customer');
		$url = 'index.php?option=com_jsbill&view=bill&layout=history&userEmail='.$customer['cemail'].'&Itemid='.JRequest::getInt('Itemid');
		$mainframe->redirect(JRoute::_($url, false));
	}

	function cancel()
	{
		global $mainframe;
		$db = & Jfactory::getDBO();
		$order = JRequest::getInt('order_num');
		$sql = "UPDATE #__jc_orders SET status_id = '14' WHERE id = '$order'";
		$db->setQuery($sql);
		$db->query();
		$link = 'index.php?option=com_commerce&view=orders&layout=purchase&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_PURCHASEHIST_ITEMID != '') ? COMM_PURCHASEHIST_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function change_section()
	{
		global $mainframe;
		$layout = JRequest::getVar('layout');
		$link = 'index.php?option=com_commerce&view=orders&section_id='.COMM_SECTION_ID.
		($layout != '' ? '&layout='.$layout : '')
		.'&Itemid='.((COMM_COUPON_ITEMID != '') ? COMM_COUPON_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect( JRoute::_($link, false) );
	}

	function send_alert()
	{
		global $mainframe;
		$db = JFactory::getDBO();
		$order = JRequest::getInt('order_id');
		$sql = "SELECT deducted FROM #__jc_orders WHERE id = '$order'";
		$db->setQuery($sql);
		$sent = $db->loadResult();
		if(!$sent)
		{
			$user = JFactory::getUser();
			$model  = & $this->getModel('orders');
			$customer = JRequest::getString('sender');
			$mt_name = JRequest::getString('mt_name');
			$cnumber = JRequest::getVar('cnumber');
			$details = JRequest::getVar('details');
			$emails = $model->getOrderSellers($order);

			$config = JFactory::getConfig();

			jimport('joomla.mail.mail');
			jimport('joomla.mail.helper');

			$mail = JFactory::getMailer();
			$sender[0] = $config->getValue('config.mailfrom');
			$sender[1] = $config->getValue('config.fromname');

			$txt = "\n";
			$txt .= JText::_('Sender name').": ".$customer."\n";
			$txt .= JText::_('Money Transfer Service name').": ".$mt_name."\n";
			$txt .= JText::_('Money Transfer Control Number').": ".$cnumber."\n\n";
			$txt .= JText::_('Money Transfer details').": \n".$details."\n\n";


			$subject = JText::_("Money transfer has been made");
			$link = JURI::root().'index.php?option=com_commerce&view=orders&order_id='.$order.'&section_id='.COMM_SECTION_ID.'&Itemid='.(COMM_PRODUCTLIST_ITEMID ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid'));
			$body = JText::_('TRANSFER_ALERT');
			$body = str_replace('[USER]', ($user->id ? str_replace("\n", ' ', $user->name) : $customer), $body);
			$body = str_replace('[ORDER_ID]', $order, $body);
			$body = str_replace('[DETAILS]', $txt, $body);
			$body = str_replace('[ORDER_LINK]', JHTML::link($link, $link), $body);
			$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
			$body = str_replace('[SITE_URL]', JHTML::link(JURI::root(), JURI::root()), $body);

			$mail->setSender($sender);
			$mail->addRecipient($sender[0]);
			$mail->AddBCC($emails);
			$body = str_replace("\n", '<br>', $body);
			$mail->IsHTML(true);
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));

			if($mail->Send())
			{
				// calculate balance
				$model_balance = &JModel::getInstance('balance', 'CommerceModel');
				$sellers = $model_balance->getOrderSellers($order, COMM_SECTION_ID);

				foreach($sellers as $item)
				{
					$credit = 0;
					$debit = 0;
					$current_balance = 0;
					$current_balance = $model_balance->getCurrentBalance($item->seller_id);
					//$balance = ($item->price * $item->amount) + $item->tax - $item->discount;
					$balance = round($item->balance, 2);
					
					$procent = COMM_PERCENTAGE;
					$transact = COMM_TRANSACTION;
					if(COMM_PAYMENT_METHOD == 'personal'){
						$balance = round($balance * $procent / 100 , 2) + $transact;
						if($balance < COMM_COMM_MIN)
						{
							$balance = COMM_COMM_MIN;
							$procent = 0;
							$transact = COMM_COMM_MIN;
						}
						$debit = $balance;
						$balance = $current_balance - $balance;
					} else {
						$commission = round($balance * $procent / 100 , 2) + $transact;
						if($commission < COMM_COMM_MIN)
						{
							$commission = COMM_COMM_MIN;
							$procent = 0;
							$transact = COMM_COMM_MIN;
						}
						$balance = $balance - $commission;
						$credit = $balance;
						$balance = $current_balance + $balance;
					}
					if(COMM_PAYMENT_METHOD == 'global' && $shipping = $model_balance->getOrderShipping($order))
					{
						$ship = new JParameter($shipping->extra);
						$ship = unserialize($ship->get('shipping'));
						$balance += $ship['sum'];
					}
					
					$sql = "INSERT INTO #__jc_users_balance VALUES
					('', '{$item->seller_id}', NOW(), 'order', '$order', '$debit', '$credit', '$balance', '$procent', '$transact', '".COMM_SECTION_ID."')";
					$db->setQuery($sql);
					if($db->query())
					$sql = "UPDATE #__jc_users SET balance_id='".$db->insertid()."' WHERE user_id = '{$item->seller_id}' AND section_id = ".COMM_SECTION_ID;
					$db->setQuery($sql);
					$db->query();

					$sql = "UPDATE #__jc_orders SET deducted='1' WHERE id = '$order'";
					$db->setQuery($sql);
					$db->query();
					$sql = "UPDATE #__jc_orders_products SET status_id = (SELECT id FROM #__jc_orders_statuses WHERE name REGEXP 'pending' AND type= 'product')
					WHERE order_id = '$order'";
					$db->setQuery($sql);
					$db->query();
				}
			}
		}
		$link = 'index.php?option=com_commerce&view=orders&layout=purchase&section_id='.COMM_SECTION_ID.'&Itemid='.(COMM_PURCHASEHIST_ITEMID ? COMM_PURCHASEHIST_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function export()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$db   =& JFactory::getDBO();
		$layout = JRequest::getString('layout');
		$user = JFactory::getUser();
		$model  = & $this->getModel('orders');
		$model_cart  = &JModel::getInstance('cart', 'CommerceModel');
		$cid = JRequest::getVar('cid', array());
		$filename = 'orders'.time().'.xls';

		if($layout == 'purchase')
		{
			$sql = "SELECT ord.status_id as ord_st, ord.ctime as ordctime, pr.*
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			
			WHERE ord.section_id = '".COMM_SECTION_ID."' AND ord.user_id = '".$user->id."'";
			if(count($cid))
			$sql .= " AND ord.id IN (".implode(', ', $cid).")";
			$sql .= " ORDER BY ord.ctime, pr.id";
		}
		else
		{
			$sql = "SELECT ord.status_id as ord_st, ord.ctime as ordctime, pr.*
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			WHERE ord.section_id = '".COMM_SECTION_ID."' AND (pr.seller_id = '".$user->id."' OR (pr.seller_id = '0' AND pr.product_id = '0') )";
			if(count($cid))
			$sql .= " AND ord.id IN (".implode(', ', $cid).")";
			$sql .= " ORDER BY ord.ctime desc, pr.id";
		}
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		
		if(count($rows) <= 0)
		{
			JError::raiseNotice(500, JText::_("There is no data to export"));
			$mainframe->redirect($uri->toString());
		}
		else
		{
			$core = getCore();
			header('Content-Type: application/vnd.ms-excel;');
			header("Content-type: application/x-msexcel");
			header('Content-Disposition: attachment; filename="' . $filename . '"');
			echo '<table border="1">
				<tr>
					<th>'.JText::_('Num').'</th>
					<th>'.JText::_('Order Num.').'</th>
					<th>'.JText::_('Order status').'</th>
					<th>'.JText::_('Date').'</th>
					<th>'.( ($layout == 'purchase' || $layout == 'details') ? JText::_('Seller') : JText::_('Customer')).'</th>
					<th>'.JText::_('Item').'</th>
					<th>'.JText::_('Price').', '.$core->mark.'</th>
					<th>'.JText::_('Affect').', '.$core->mark.'</th>
					<th>'.JText::_('Amount').'</th>
					<th>'.JText::_('Tax').', '.$core->mark.'</th>
					<th>'.JText::_('Tax rate').', %</th>
					<th>'.JText::_('Tax name').'</th>
					<th>'.JText::_('Discount').', '.$core->mark.'</th>
					<th>'.JText::_('Refund').', '.$core->mark.'</th>
					<th>'.JText::_('Total').', '.$core->mark.'</th>
					<th>'.JText::_('Product status').'</th>
				</tr>		
			';
			$i = 1;
			foreach($rows as $row)
			{
				$row->total = ($row->price * $row->amount);
				$row->total += $row->tax;
				$row->total -= $row->discount;
				$row->totals = $row->total;
				$row->total -= $row->refund;

				$ord_st = $model->getStatusInfo($row->ord_st);
				$pr_st = $model->getStatusInfo($row->status_id);
				if($row->seller_id)
				{
					$seller = JFactory::getUser($row->seller_id);
					$row->uname = $seller->name;
				}
				else
				$row->uname = '&nbsp';


				if($row->product_id)
				{
					$rec = $model_cart->getArticleInfo($row->product_id);
				}
				else
				{
					$item_ship = new JParameter($row->extra);
					if($item_ship = $item_ship->get('shipping'))
					{
						$item_ship = unserialize($item_ship);
						$seller = JFactory::getUser($item->seller_id);
						$ship = explode('::', $item_ship['info']);
						$rec->title = JText::_('Products delivery from vendor').' '.$seller->name.' ('.$ship[0].', '.$ship[1].'; '.JText::_('weight').': '.$item_ship['weight'].' '.JText::_('kg').')';
						$row->total = $item_ship['sum'];
					}
				}
				echo '
				<tr valign="top">
					<td>'.$i.'</td>
					<td>'.$row->order_id.'</td>
					<td>'.$ord_st->name.'</td>
					<td>'.$row->ordctime.'</td>
					<td>'.$row->uname.'</td>
					<td>'.$rec->title.'</td>
					<td>'.($row->price - $row->affect_sum).'</td>
					<td>'.$row->affect_sum.'</td>
					<td>'.$row->amount.'</td>
					<td>'.$row->tax.'</td>
					<td>'.$row->tax_rate.'</td>
					<td>'.$row->tax_name.'</td>
					<td>'.$row->discount.'</td>
					<td>'.$row->refund.'</td>
					<td>'.$row->total.'</td>
					<td>'.$pr_st->name.'</td>
				</tr>';
				$i++;
			}
			echo '
			</table>';
			exit;
		}
	}



}
?>
