<?php
/**
 * $Id: shipping.php 7782 2012-02-09 09:43:38Z alfiya $
 * $LastChangedDate: 2012-02-09 15:43:38 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerShipping extends CommerceController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('edit_shipping', 'add_shipping');
		$this->registerTask('save_shipping', 'apply_shipping');
		$this->registerTask('set_shipping', 'set_shipping');
	}

	function display()
	{
		global $mainframe;

		$user =& JFactory::getUser();
		if(!$user->id)
		{
			$cpanel = JRoute::_('index.php?option=com_commerce&view=shipping&section_id='.COMM_SECTION_ID.'&Itemid='.JRequest::getInt('Itemid'), false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($cpanel), false), 
				JText::_('You are not authorized to see that page'), 'Error');
		}
		if(!$user->get('is_seller') && !$user->is_silver && !$user->is_gold)
		{
			CommerceController::checkConfirmBySubscription(); 
			JError::raiseWarning(500, JText::_('ERROR You are not allowed to see this page') );
			return;
		}

		$model = & $this->getModel('userconfig');
		if(!$model->getConfId($user->id))
		{
			$link = "index.php?option=com_commerce&view=userconfig&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_USERCONFIG_ITEMID != '') ? COMM_USERCONFIG_ITEMID : JRequest::getInt("Itemid"));
			$mainframe->redirect(JRoute::_($link, false), JText::_("You have not saved your configuration. Please fill the fields to continue."), 'Notice');
		}
		JRequest::setVar('view', 'shipping');
		parent::display();

	}

	function add_shipping()
	{
		JRequest::setVar('view', 'shipping');
		JRequest::setVar('layout', 'form');
		parent::display();
	}

	function apply_shipping()
	{
		global $mainframe;
		$db  =& JFactory::getDBO();
		$row =& JTable::getInstance("Shipping", 'Commerce');
		$vals = array();

		$vals['name'] = JRequest::getVar('name');
		$vals['published'] = JRequest::getVar('published');
		$vals['is_core'] = JRequest::getVar('is_core');
		$vals['id'] = JRequest::getVar('id');
		$vals['section_id'] = COMM_SECTION_ID;

		if (!$row->bind( $vals ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}

		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}
		$row->checkin();
		$msg = JText::_("Shipping method was successfully saved");
		if(JRequest::getVar('task') == 'apply_shipping')
		$link = 'index.php?option=com_commerce&view=shipping&task=edit_shipping&cid[]='.$row->id.'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt("Itemid"));
		else
		$link = 'index.php?option=com_commerce&view=shipping&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false), $msg);
	}

	function set_shipping()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$model = & $this->getModel('shipping');
		$model->setCore(JRequest::getVar('cid'));
		$mainframe->redirect($uri->toString());
	}
	function cancel()
	{
		global $mainframe;
		$row =& JTable::getInstance('shipping', 'commerce');
		$row->checkin(JRequest::getInt('id'));
		
		$link = 'index.php?option=com_commerce&view=shipping&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function import()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$user =& JFactory::getUser();
		$db   =& JFactory::getDBO();
		
		if(!($_FILES['import_file']['name']))
		{
			JError::raiseWarning(500, JText::_("You haven't selected the Import file"));
			$mainframe->redirect($uri->toString());
		}
		$fname = $_FILES['import_file']['tmp_name'];
		
		if(substr($_FILES['import_file']['name'], -4) != '.csv')
		{
			JError::raiseWarning(500, JText::_('File format is not valid. Please import CSV file'));
			$mainframe->redirect(JRoute::_($uri->toString(), false));
		}
		$fd =fopen($fname, 'r');
		$contents = file ($fname);
		fclose ($fd);
		$tmp = 0;
		foreach($contents as $i => $rows)
		{
			$row = explode(",", $rows);
			if($i == 0 &&  !is_numeric ($row[6])) {
				continue;
			}		
			else 
			{
				/*if($tmp == 0)
				{
					$sql = "INSERT INTO #__jc_ship_forwarder SET seller_id = '{$user->id}',
					name = '{$row[0]}', published = '1', section_id = '".COMM_SECTION_ID."'";
					$db->setQuery($sql);
					$tmp ++;				
					$db->query();
					$frwrd_id = $db->insertid();
				}
				else
				{*/
					$sql = "SELECT id FROM  #__jc_ship_forwarder 
					WHERE seller_id = '{$user->id}' AND section_id = '".COMM_SECTION_ID."' 
					AND	name = '{$row[0]}' AND published = '1' ORDER BY id DESC";
					$db->setQuery($sql);
					$frwrd_id = $db->loadResult();
					if(!$frwrd_id)
					{
						$sql = "INSERT INTO #__jc_ship_forwarder SET seller_id = '{$user->id}',
						name = '{$row[0]}', published = '1', section_id = '".COMM_SECTION_ID."'";
						$db->setQuery($sql);
						$db->query();
						$frwrd_id = $db->insertid();
					}
				//}
				if(is_string($row[8]))
				{
					$type = (trim(strtolower($row[8])) == 'fixed') ? 0 : 1;
				}
				
				$from = explode("\n", $row[3]);
				if(!is_array($from))
					settype($from, 'array');
				foreach ($from as $k => $line)
				{
					$from[$k] = str_replace("/", "::", $line);
				}
				$from = serialize($from); 
				
				$to = explode("\n", $row[4]);
				if(!is_array($to))
					settype($to, 'array');
				foreach ($to as $k => $line)
				{
					$to[$k] = str_replace("/", "::", $line);
				}
				$to = serialize($to); 
				
				$row[4] = str_replace("; ", "|", $row[4]);
				$row[4] = str_replace(";", "|", $row[4]);
				$row[4] = str_replace(",", "|", $row[4]);
				$row[4] = str_replace(", ", "|", $row[4]);
				$sql = "INSERT INTO #__jc_ship_forwarder_shema VALUES
				('', '$frwrd_id', '{$row[1]}', '{$row[2]}', '', '',  '1', '', '{$user->id}', '{$from}', '{$to}', '{$row[5]}', '{$row[6]}',
				'{$row[7]}', '$type', '".COMM_CORE_CURRENCY."', '0', '".COMM_SECTION_ID."')";
				$db->setQuery($sql); echo $db->_sql;// die;
				$db->query();
			}
		}
		unlink($fname);
		$link = 'index.php?option=com_commerce&view=shipping&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect(JRoute::_($link, false));

	}

	function change_section()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&view=shipping&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect( JRoute::_($link, false) );
	}
	

	function export()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$db   =& JFactory::getDBO();
		$cid = JRequest::getVar('cid');

		if(!$cid)
		{
			$mainframe->redirect($uri->toString(), JText::_("You haven't selected the Shipping Methods"), 'Notice');
		}

		$filename = 'shipping'.time().'.xls';

		$sql = "SELECT
		f.name as method, s.name, s.description,s.fromlocation, s.tolocation, s.weightfrom, s.weightto, s.price, 
		IF(s.pricetype = 1, '".JText::_('per KG')."', '".JText::_('fixed')."') as pricetype, 
		IF(cur.mark = '', cur.name, cur.mark) as currency
		FROM #__jc_ship_forwarder f
		JOIN #__jc_ship_forwarder_shema s ON s.frwrd_id = f.id
		JOIN #__jc_currency cur ON cur.id = s.currency_id
		WHERE f.id IN (".implode(', ', $cid).") AND f.section_id = '".COMM_SECTION_ID."'";
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		if(count($rows) <= 0)
		{
			JError::raiseNotice(500, JText::_("There is no data to export"));
			$mainframe->redirect($uri->toString());
		}

		else
		{
			header('Content-Type: application/vnd.ms-excel;');
			header("Content-type: application/x-msexcel");
			header('Content-Disposition: attachment; filename="' . $filename . '"');
			echo '<table border="1">
				<tr>
					<th>'.JText::_('Shipping method name').'</th>
					<th>'.JText::_('Shipping scheme name').'</th>
					<th>'.JText::_('Scheme description').'</th>
					<th>'.JText::_('Country From').'</th>
					<th>'.JText::_('Countries To').'</th>
					<th>'.JText::_('Weight From') . '</th>
					<th>' . JText::_('Weight To') . '</th>
					<th>'.JText::_('Price').'</th>
					<th>'.JText::_('Price Type').'</th>
					<th>'.JText::_('Currency').'</th>
				</tr>		
			';
			foreach($rows as $row)
			{
				$from = unserialize($row->fromlocation);
				$to = unserialize($row->tolocation);
				foreach ($from as $vals)
				{
					$res = array();
					$vals = explode('::', $vals);
					foreach($vals as $val)
					{
						if ($val != '')
							$res[] = $val;
					}
					$from_val[] = implode(', ', $res);
				}
				foreach ($to as $vals)
				{
					$res = array();
					$vals = explode('::', $vals);
					foreach($vals as $val)
					{
						if ($val != '')
							$res[] = $val;
					}
					$to_val[] = implode(', ', $res); 
				}
				$from = implode("<br>", $from_val);
				$to = implode("<br>", $to_val);
				echo '
				<tr valign="top">
					<td>'.$row->method.'</td>
					<td>'.$row->name.'</td>
					<td>'.$row->description.'</td>
					<td>'.$from.'</td>
					<td>'.$to.'</td>
					<td>'.$row->weightfrom.'</td>
					<td>'.$row->weightto.'</td>
					<td>'.$row->price.'</td>
					<td>'.$row->pricetype.'</td>
					<td>'.$row->currency.'</td>
				</tr>';
			}
			echo '
			</table>';
			exit;
		}
	}

}
?>