<?php
/**
 * $Id: shippingitem.php 7782 2012-02-09 09:43:38Z alfiya $
 * $LastChangedDate: 2012-02-09 15:43:38 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerShippingItem extends CommerceController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('edit_shippingitem', 'add_shippingitem');
		$this->registerTask('save_shippingitem', 'apply_shippingitem');
		$this->registerTask('set_shippingitem', 'set_shippingitem');
	}

	function display()
	{
		global $mainframe;

		$user =& JFactory::getUser();
		if(!$user->id)
		{
			$cpanel = JRoute::_('index.php?option=com_commerce&view=shippingitem&section_id='.COMM_SECTION_ID.'&Itemid='.JRequest::getInt('Itemid'), false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($cpanel), false),
			JText::_('You are not authorized to see that page'), 'Error');
		}
		if(!$user->get('is_seller') && !$user->is_silver && !$user->is_gold)
		{
			CommerceController::checkConfirmBySubscription();
			JError::raiseWarning(500, JText::_('ERROR You are not allowed to see this page') );
			return;
		}

		$model = & $this->getModel('userconfig');
		if(!$model->getConfId($user->id))
		{
			$link = "index.php?option=com_commerce&view=userconfig&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_USERCONFIG_ITEMID != '') ? COMM_USERCONFIG_ITEMID : JRequest::getInt("Itemid"));
			$mainframe->redirect(JRoute::_($link, false), JText::_("You have not saved your configuration. Please fill the fields to continue."), 'Notice');
		}
		JRequest::setVar('view', 'shippingitem');
		parent::display();

	}

	function add_shippingitem()
	{
		JRequest::setVar('view', 'shippingitem');
		JRequest::setVar('layout', 'form');
		parent::display();
	}

	function apply_shippingitem()
	{
		global $mainframe;
		$db  =& JFactory::getDBO();
		$row =& JTable::getInstance("ShippingItem", 'Commerce');
		$model = & $this->getModel('shippingitem');

		$vals = array();
		$post = JRequest::get('post');
		$vals['name'] = JRequest::getVar('name');
		$vals['description'] = JRequest::getVar('description');
		$vals['weightfrom'] = JRequest::getVar('weightfrom');
		$vals['weightto'] = JRequest::getVar('weightto');
		$vals['price'] = JRequest::getVar('price');
		$vals['currency_id'] = JRequest::getVar('currency_id');
		$vals['pricetype'] = JRequest::getVar('pricetype');
		$vals['frwrd_id'] = JRequest::getVar('frwrd_id');
		$vals['published'] = JRequest::getVar('published');
		$vals['is_core'] = JRequest::getVar('is_core');
		$vals['id'] = JRequest::getVar('id');
		$vals['section_id'] = COMM_SECTION_ID;
		/*$count_from = count($post['fromcountry']);
		 $count_to = count($post['tocountry']);*/
		$loc_from = array();
		foreach ($post['fromcountry'] as $k => $val)
		{
			$val = $model->getLocationData('country', $val);
			$city = $post['fromcity'][$k] ? $model->getLocationData('city', $post['fromcity'][$k]) : '';
			$district = $post['fromdistrict'][$k] ? $model->getLocationData('district', $post['fromdistrict'][$k]) : '';
			$loc_from[] = $val.'::'.$city.'::'.$district;
		}
		$loc_to = array();
		if(isset($post['tocountry']))
		{
			foreach ($post['tocountry'] as $k => $val)
			{
				$val = $model->getLocationData('country', $val);
				$city = $post['tocity'][$k] ? $model->getLocationData('city', $post['tocity'][$k]) : '';
				$district = $post['todistrict'][$k] ? $model->getLocationData('district', $post['todistrict'][$k]) : '';
				$loc_to[] = $val.'::'.$city.'::'.$district;
			}
		}

		$vals['fromlocation'] = serialize($loc_from);
		$vals['tolocation'] = serialize($loc_to);
		
		if (!$row->bind( $vals ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}

		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}
		$row->checkin();
		$msg = JText::_("Shipping item was successfully saved");
		if(JRequest::getVar('task') == 'apply_shippingitem')
		$link = 'index.php?option=com_commerce&view=shippingitem&task=edit_shippingitem&cid[]='.$row->id.'&frwrd_id='.JRequest::getVar('frwrd_id').'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt("Itemid"));
		else
		$link = 'index.php?option=com_commerce&view=shippingitem&frwrd_id='.JRequest::getVar('frwrd_id').'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false), $msg);
	}

	function set_shippingitem()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$model = & $this->getModel('shippingitem');
		$model->setCore(JRequest::getVar('cid'));
		$mainframe->redirect(JRoute::_($uri->toString(), false));
	}
	function cancel()
	{
		global $mainframe;
		$row =& JTable::getInstance('shippingitem', 'commerce');
		$row->checkin(JRequest::getInt('id'));

		$link = 'index.php?option=com_commerce&view=shippingitem&frwrd_id='.JRequest::getInt('frwrd_id').'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_SHIP_ITEMID != '') ? COMM_SHIP_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false));
	}

}
?>