<?php
/**
 * $Id: tax.php 7782 2012-02-09 09:43:38Z alfiya $
 * $LastChangedDate: 2012-02-09 15:43:38 +0600 (Thu, 09 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommerceControllerTax extends CommerceController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('edit_tax', 'add_tax');
		$this->registerTask('save_tax', 'apply_tax');
		$this->registerTask('cancel', 'cancel');
		$this->registerTask('trash_tax', 'trash_tax');
	}

	function display()
	{
		global $mainframe;
		$user =& JFactory::getUser();
		if(!$user->id)
		{
			$cpanel = JRoute::_('index.php?option=com_commerce&view=tax&section_id='.COMM_SECTION_ID.'&Itemid='.JRequest::getInt('Itemid'), false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($cpanel), false),
				JText::_('You are not authorized to see that page'), 'Error');
		}
		if(!$user->get('is_seller') && !$user->is_silver && !$user->is_gold)
		{
			CommerceController::checkConfirmBySubscription(); 
			JError::raiseWarning(500, JText::_('ERROR You are not allowed to see this page') );
			return;
		}
		$model = & $this->getModel('userconfig');
		if(!$model->getConfId($user->id))
		{
			$link = "index.php?option=com_commerce&view=userconfig&section_id=".COMM_SECTION_ID."&Itemid=".( (COMM_USERCONFIG_ITEMID != '') ? COMM_USERCONFIG_ITEMID : JRequest::getInt("Itemid"));
			$mainframe->redirect(JRoute::_($link, false), JText::_("You have not saved your configuration. Please fill the fields to continue."), 'Notice');
		}
		JRequest::setVar('view', 'tax');
		parent::display();
	}

	function add_tax()
	{
		JRequest::setVar('view', 'tax');
		JRequest::setVar('layout', 'form');
		parent::display();
	}
	function apply_tax()
	{
		global $mainframe;
		$db  =& JFactory::getDBO();
		$row =& JTable::getInstance("Tax", 'Commerce');
		$vals = array();
		$vals['published'] = JRequest::getVar('published');
		$vals['name'] = JRequest::getVar('name');
		$vals['rate'] = JRequest::getVar('rate');
		$vals['country'] = JRequest::getVar('country');
		$vals['id'] = JRequest::getVar('id');
		$vals['section_id'] = COMM_SECTION_ID;
		$vals['country'] = implode('|', $vals['country']);

		if (!$row->bind( $vals ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}

		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}
		$row->checkin();
		$msg = JText::_("Tax was successfully saved");
		if(JRequest::getVar('task') == 'apply_tax')
		$link = 'index.php?option=com_commerce&view=tax&task=edit_tax&cid[]='.$row->id.'&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_TAX_ITEMID != '') ? COMM_TAX_ITEMID : JRequest::getInt("Itemid"));
		else
		$link = 'index.php?option=com_commerce&view=tax&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_TAX_ITEMID != '') ? COMM_TAX_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false), $msg);

	}

	function cancel()
	{
		global $mainframe;
		$row =& JTable::getInstance('tax', 'commerce');
		$row->checkin(JRequest::getInt('id'));
		
		$link = 'index.php?option=com_commerce&view=tax&section_id='.COMM_SECTION_ID.'&Itemid='.( (COMM_TAX_ITEMID != '') ? COMM_TAX_ITEMID : JRequest::getInt("Itemid"));
		$mainframe->redirect(JRoute::_($link, false));
	}

	function change_section()
	{
		global $mainframe;
		$link = 'index.php?option=com_commerce&view=tax&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_TAX_ITEMID != '') ? COMM_TAX_ITEMID : JRequest::getInt('Itemid'));
		$mainframe->redirect( JRoute::_($link, false) );
	}

	function getCurrent($cid)
	{
		$db =& JFactory::getDBO();

		if($cid[0])
		{
			$query = " SELECT c.*
			FROM #__jc_users_currencies AS u
			LEFT JOIN #__jc_currency AS c ON u.currency_id = c.id
			WHERE u.id = '$cid[0]'";
			$db->setQuery( $query);
			$row = $db->loadObjectList();
			return $row[0];
		}
		return '';
	}


	function updateMark($mark, $id)
	{
		$db =& JFactory::getDBO();
		$id = jcCurrencyController::getCurrent($id);
		$query = "UPDATE #__jc_currency SET `mark` = '$mark' WHERE id = '$id->id'";
		$db->setQuery( $query);
		$db->query();
	}

	function select($default, $uid = false)
	{
		$db =& JFactory::getDBO();
		$user   =& JFactory::getUser();
		if(!$uid) $uid = $user->get('id');
		$query = "SELECT c.id, c.name, c.rate FROM #__jc_taxes  AS c
		WHERE c.published = 1
		AND c.trash = 0
		AND (c.seller_id = $uid OR c.iscore = 1)
		AND c.section_id = '".COMM_SECTION_ID."'
		ORDER BY c.name ASC,
		c.rate ASC";

		$db->setQuery( $query);
		$rows = $db->loadObjectList();
		$c[] = JHTML::_('select.option', '', JText::_('-None-'));
		foreach($rows as $row)
		{
			$c[] = JHTML::_('select.option', $row->id, "($row->rate%) ".$row->name);
		}
		return JHTML::_('select.genericlist', $c, 'tax_id', 'class="inputbox"', 'value', 'text', $default );
	}
}
?>
