<?php
/**
 * $Id: helper.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
define('_NL',"\n");

//require_once(JPATH_ROOT.DS.'components'.DS.'com_commerce'.DS.'helpers'.DS.'bproduct.php');



function jcGeshiHighlite( &$matches )
{
  $params =& $GLOBALS['_MAMBOT_GESHI_PARAMS'];

  jimport('geshi.geshi');
  jimport('domit.xml_saxy_shared');

  $args = explode("|", $matches[1]);
  $text = $matches[2];

  $lang	= JArrayHelper::getValue( $args, 0, 'php' );
  $lines	= JArrayHelper::getValue( $args, 1, 'false' );

  $html_entities_match = array( "|\<br \/\>|", "#<#", "#>#", "|&#39;|", '#&quot;#', '#&nbsp;#' );
  $html_entities_replace = array( "\n", '&lt;', '&gt;', "'", '"', ' ' );

  $text = preg_replace( $html_entities_match, $html_entities_replace, $text );

  $text = str_replace('&lt;', '<', $text);
  $text = str_replace('&gt;', '>', $text);

  /*
  // Replace 2 spaces with "&nbsp; " so non-tabbed code indents without making huge long lines.
  $text = str_replace("  ", "&nbsp; ", $text);
  // now Replace 2 spaces with " &nbsp;" to catch odd #s of spaces.
  $text = str_replace("  ", " &nbsp;", $text);
  */
  // Replace tabs with "&nbsp; &nbsp;" so tabbed code indents sorta right without making huge long lines.
  //$text = str_replace("\t", "&nbsp; &nbsp;", $text);
  $text = str_replace( "\t", '  ', $text );

  $geshi = new GeSHi( $text, $lang );
  if ($lines == 'true') {
    $geshi->enable_line_numbers( GESHI_NORMAL_LINE_NUMBERS );
  }
  $text = $geshi->parse_code();

  return $text;
}

class jcGeneral{
  function easyEncoder( $str, $key ){
    for ( $i=0; $i < strlen( $str ); $i++ ){
      for ( $j  = 0; $j < strlen($key); $j++ ){
        $str[$i] = $str[$i] ^ $key[$j];
      }
      $key = substr($key, 1).substr($key, 0, 1);
    }
    return $str;
  }
  
  function getButtonSRC( $button )
  {
    $path = JURI::root()."components/com_commerce/images/templates/".JC_LAY_ICONS_DIR."/buttons/".$button;
    switch( $button ) {
      case 'button_cart_delete' :
        if( defined( 'JC_BUTTON_CART_DELETE' ) ) {
          $img = JC_BUTTON_CART_DELETE;
        }
        break;
      case 'button_cart_recalc' :
        if( defined( 'JC_BUTTON_CART_RECALC' ) ) {
          $img = JC_BUTTON_CART_RECALC;
        }
        break;
      case 'button_cart_continue_shoping' :
        if( defined( 'JC_BUTTON_CART_CONTINUE_SHOPING' ) ) {
          $img = JC_BUTTON_CART_CONTINUE_SHOPING;
        }
        break;
      case 'button_cart_checkout' :
        if( defined( 'JC_BUTTON_CART_CHECKOUT' ) ) {
          $img = JC_BUTTON_CART_CHECKOUT;
        }
        break;
      case 'button_product_addtocart' :
        if( defined( 'JC_BUTTON_PRODUCT_ADDTOCART' ) ) {
          $img = JC_BUTTON_PRODUCT_ADDTOCART;
        }
        break;
      case 'button_product_buynow' :
        if( defined( 'JC_BUTTON_PRODUCT_BUYNOW' ) ) {
          $img = JC_BUTTON_PRODUCT_BUYNOW;
        }
        break;
    }

    if( $img ) {
      $img = unserialize( $img );
      $img = $img['imglist'];
    } else {
      $img = 'default';
    }
    
    return $src = $path.'/'.$img;
  }
}

class jcElements {

  function makeProductFilters( $types )
  {
    $filters = array();

    $type_options = array();

    $type_options[] = JHTML::_( 'select.option', '', '- '.JText::sprintf('Select %s', 'product type').' -' );
    foreach ( $types as $type ) {
      $type_options[] = JHTML::_( 'select.option', $type->group->id, $type->group->name );
    }

    $onchange = "onchange='submitfilter(this);'";

    $filters[0]['type'] = JHTML::_('select.genericlist',  $type_options, 'filters_type', $onchange, 'value', 'text','');


    foreach ( $types as $key => $type ) {
      $filters[ $key ] = jcElements::makeProductTypeFilters( $type->properties );
    }

    return $filters;
  }

  function makeProductTypeFilters( $properties )
  {
    $filters = array();
    $onchange = "onchange='submitfilter(this);'";

    foreach( $properties as $property){
      $filter = new stdClass();

      $filter->name   = 'filters_'.$property->id;

      switch( $property->type ) {
        case 'Element Select' :
        case 'Element Checkbox' :
        case 'Checkbox' :
        case 'Radio' :
          $filter_vals = array( JHTML::_( 'select.option', '', '- '.JText::sprintf('Select %s', $property->label).' -' ) );
          $filter_vals = array_merge( $filter_vals, jcElements::getOptionsFromStr( $property->value ) );

          $filters[ $property->id ] = JHTML::_('select.genericlist',  $filter_vals, 'filters_'.$property->id, $onchange, 'value', 'text','');
          break;
      }
    }

    return $filters;
  }

  function getOptionsFromStr( $str )
  {
    $result = array();

    $values = explode( "\n", str_replace( "\r", '', $str ) );

    foreach( $values as $value ){
      $result[] = JHTML::_( 'select.option', $value, $value );
    }

    return $result;
  }

  function initProductCategoryIcon( & $cat_obj )
  {
    $icon_path  = str_replace( '\\', '/', JC_CATEGORY_ICONS_DIR );

    $cat_obj->icon_pos_top    = '';
    $cat_obj->icon_pos_bottom = '';

    $parameters = new JParameter($cat_obj->params);
    if( $parameters->get( 'icon' ) ){

      $icon = unserialize( stripslashes( trim( $parameters->get( 'icon' ) ) ) );
      $img_src = JURI::root().'/'.$icon_path.'/'.$icon['imglist'];
      $icon['img'] = JHTML::image( $img_src, '', array( 'align' => $icon['positionlist'] ) );

      switch( $icon['positionlist'] ){
        default:
          case'left':
          case'right':
          case'absmiddle':
          $cat_obj->icon_pos_top    = $icon['img'];
          break;
          case'left-over':
          $cat_obj->icon_pos_top    = '<div align="left">'.$icon['img'].'</div>';
          break;
          case'center-over':
          $cat_obj->icon_pos_top    = '<center>'.$icon['img'].'</center>';
          break;
          case'right-over':
          $cat_obj->icon_pos_top    = '<div align="right">'.$icon['img'].'</div>';
          break;
          case'left-under':
          $cat_obj->icon_pos_bottom = '<div align="left">'.$icon['img'].'</div>';
          break;
          case'center-under':
          $cat_obj->icon_pos_bottom = '<center>'.$icon['img'].'</center>';
          break;
          case'right-under':
          $cat_obj->icon_pos_bottom = '<div align="right">'.$icon['img'].'</div>';
          break;
      }

    }
  }

  function user_currensies($default, $uid = false)
  {
    $db   =& JFactory::getDBO();
    $user   =& JFactory::getUser();

    if(!$uid) $uid = $user->get('id');

    $query = "
    SELECT c.id,
       c.name,
       c.code,
       c.mark
    FROM #__jc_currency  AS c
  LEFT JOIN #__jc_users_currencies AS u ON c.id = u.currency_id
     WHERE c.iscore = 1
      OR u.seller_id = $uid
  ORDER BY c.iscore DESC,
       c.name ASC
  ";

    $db->setQuery( $query);
    $rows = $db->loadObjectList();
    foreach($rows as $row)
    {
      $c[] = JHTML::_('select.option', $row->id, "($row->code) ".$row->name);
    }
    return JHTML::_('select.genericlist', $c, 'currency_id', 'class="inputbox"', 'value', 'text', $default );
  }

  function user_taxes($default, $uid = false)
  {
    $db =& JFactory::getDBO();
    $user   =& JFactory::getUser();
    if(!$uid) $uid = $user->get('id');
    $query = "
      SELECT c.id,
         c.name,
         c.rate
      FROM #__jc_taxes  AS c
       WHERE c.published = 1
       AND c.trash = 0
       AND (c.seller_id = $uid OR c.iscore = 1)
    ORDER BY c.name ASC,
         c.rate ASC
    ";

    $db->setQuery( $query);
    //echo $db->_sql;
    $rows = $db->loadObjectList();
    $c[] = JHTMLSelect::option( '', JText::_('-None-'));
    foreach($rows as $row)
    {
      $c[] = JHTMLSelect::option( $row->id, "($row->rate%) ".$row->name);
    }
    return JHTMLSelect::genericList( $c, 'tax_id', 'class="inputbox"', 'value', 'text', $default );
  }

  function user_categories($default, $uid = false)
  {
    $db =& JFactory::getDBO();
    $user   =& JFactory::getUser();
    if(!$uid) $uid = $user->get('id');
    $query = "
      SELECT c.id,
         c.name
      FROM #__jc_users_categories  AS c
       WHERE c.published = 1
       AND c.trash = 0
       AND c.seller_id = $uid
    ORDER BY c.ordering ASC
    ";

    $db->setQuery( $query);
    //echo $db->_sql;
    $rows = $db->loadObjectList();
    $c[] = JHTMLSelect::option( '', JText::_('-None-'));
    foreach($rows as $row)
    {
      $c[] = JHTMLSelect::option( $row->id, $row->name);
    }
    return JHTMLSelect::genericList( $c, 'category_id',
    'class="inputbox"', 'value', 'text', $default );
  }

  function category_list($parent = 0, $level = 0)
  {
    $db =& JFactory::getDBO();

    $sql = "SELECT id, name FROM #__jc_products_categories WHERE parent = $parent";
    //echo $sql;
    $db->setQuery($sql);
    $rows = $db->loadObjectList();
    if(count($rows) == 0) return false;
    foreach($rows AS $row)
    {
      $level == 0 ? $ind = '- ' : $ind = str_repeat("&nbsp;&nbsp;&nbsp;", $level).'- ';

      $clientlis[] = JHTMLSelect::option( $row->id, $ind.$row->name, 'id', 'name' );
      $new = jcElements::category_list($row->id, ($level + 1));
      if($new && is_array($new)) $clientlis = array_merge($clientlis, $new);
    }

    return $clientlis;
  }

  function product_type($type, $default = NULL)
  {
    $out = '';
    switch($type)
    {
      case 'tangible':
        $out = '';
        break;

      case 'downloadable':
        $out = '<INPUT type="file" name="type_info" />';
        if($default)
        {
          $out .= '<BR><span class="small">'.JText::_('Please, attach file to replase Existing .').' <B>'.$default.'</B></span>';
        }
        break;

      case 'visible':
        $out = '<span class="small">'.JText::_('Please, enter text to display.').'</span><BR>';
      case 'pin':
        if(!$out) $out = '<span class="small">'.JText::_('Please, enter PINs separated by newline. Soled PINs will be deleted from the list.').'</span><BR>';
        $out .= '<textarea cols="35" rows="5" name="type_info">'.$default.'</textarea>';
        break;
    }
    return $out;
  }

  function element($row, $prod)
  {
    $db = & JFactory::getDBO();
    $sql = "SELECT p.* FROM #__jc_products_properties_assign AS p
      WHERE p.product_id = $prod->id
        AND p.property_id = $row->id";
    $db->setQuery($sql);
    //echo $sql;
    $items = $db->loadObjectList();
    //print_r($items);
    is_array($items) ? $item = @$items[0] : $item = new stdClass();
    $out = '';
    $params = new JParameter($row->params);
    switch (strtolower($row->type))
    {
      case 'element select':
        if ($params->get('default')!='')
        {
          $l = $params->get('default');
        }
        else
        {
          $l = JText::_('');
        }
        $text = $item->property_value == '' ? $l."\n".$params->get('value') : $item->property_value;
        $out = "<textarea name=\"extended_field_{$row->id}\" cols=\"20\" rows=\"4\">{$text}</textarea>";
        $out.= "\n<br>".$params->get('description');
        break;


      case 'element checkbox':
        $text = $item->property_value == '' ? $params->get('value') : $item->property_value;
        $out = "<textarea name=\"extended_field_{$row->id}\" cols=\"20\" rows=\"4\">{$text}</textarea>";
        $out.= "\n<br>".$params->get('description');
        break;

      case 'element textarea':
      case 'element text':
        $out = '<input type="radio" name="extended_field_'.$row->id.'" value="1"> '.JText::_("Show");
        $out.= '<input type="radio" name="extended_field_'.$row->id.'" value="0"> '.JText::_("Hide");
        break;


        case 'select':
        if ($params->get('default')!='')
        {
          $l[] = JHTMLSelect::option($params->get('default'),$params->get('default'));
        }
        else
        {
          $l[] = JHTMLSelect::option(JText::_('--Select One--'));
        }
        $options = explode("\n", $params->get('value'));
        foreach ($options as $opt) {
          $l[] = JHTMLSelect::option( $opt, $opt);
        }
        $out = JHTMLSelect::genericList( $l, "extended_field_".$row->id, 'class="inputbox"', 'value', 'text', $item->property_value );
        break;
      case "checkbox":
        $options = explode("\n", $params->get('value'));
        $ll = array();
        foreach ($options as $opt) {
          $ll[] = sprintf('<input type="checkbox" name="%s[]" value="%s" %s/> %s',
          "extended_field_".$row->id, $opt,
          (preg_match("/".preg_quote($opt)."/iU", $item->property_value) ? ' checked="checked"' : NULL),
          ucfirst($opt));

        }
        $out = implode('<br>', $ll);
        break;

      case 'radio':
        $options = explode("\n", $params->get('value'));
        $ll = array();
        foreach ($options as $opt) {
          $ll[] = sprintf('<input type="radio" name="%s" value="%s" %s/> %s',
          "extended_field_".$row->id, $opt,
          (preg_match("/".preg_quote($opt)."/iU", $item->property_value) ? ' CHECKED="CHECKED"' : NULL),
          ucfirst($opt));

        }
        $out = implode('<br>', $ll);
        break;

      case 'text';
        $out = '<input type="text" name="extended_field_'.$row->id.'">';
        break;

      case 'textarea';
        $out = '<textarea name="extended_field_'.$row->id.'" cols="20" rows="3"></textarea>';
      break;
      case 'image':
      case 'file':
        $out = sprintf('<input type="text" size="40" name="label_%s" value="%s" />'.
        '<input type="file" name="%s" /><br /> %s%s',
        "extended_field_".$row->id, $item->property_value2, "extended_field_".$row->id,
        $item->property_value ? sprintf('<input type="checkbox" value="1" name="rm_%s" />', "extended_field_".$row->id).' '.JText::_('Remove File') : NULL,
        $item->property_value ? sprintf('<input type="hidden" name="%s_%s" value="%s" />', $row->type, "extended_field_".$row->id, $item->property_value) : NULL
        );
        break;
      case 'page':
        $sql = "SELECT id, title FROM #__content WHERE catid = '".intval($row->value)."'";
        $db->setQuery($sql);
        $rows = $db->loadObjectList();
        if(count($rows) <= 0)
        {
          return JText::_('No pages Selected');
        }
        foreach($rows AS $page)
        {
          $p[] = JHTMLSelect::option( $page->id, $page->title);
        }
        $out = JHTMLSelect::genericList( $p, "extended_field_".$row->id , 'class="inputbox" size="5"', 'value', 'text', $item->property_value);
        break;

      case 'link':
        $value = $item->property_value == ''?"http://" : $item->property_value;
        $out = "<input type='text' name='extended_field_{$row->id}' value='{$value}'>";
        break;


    }
    return $out;
  }
}


class jcImageHelper
{
  function getImageList( $path, $filter = '.') //made by Vova
  {
    jimport( 'joomla.filesystem.folder' );
    jimport( 'joomla.filesystem.file' );



    return $files;
  }


  function rethumbnail( )  //powered by Vova!!!
  {
    global $mainframe;

    jimport( 'joomla.filesystem.folder' );
    jimport( 'joomla.filesystem.file' );

    $dir_images     = JPATH_ROOT.DS.JC_PROD_IMAGES_DIR.DS.'jcommerce_images';
    $dir_thumbnails = JPATH_ROOT.DS.JC_PROD_IMAGES_DIR.DS.'jcommerce_thumbnail';

    $width   = JC_PROD_WIDTH;
    $height  = JC_PROD_HEIGHT;
    $quality = JC_PROD_QUALITY;

    if(!is_dir($dir_images)) {
      if(!mkdir($dir_images, 0777)) {
        JError::raiseWarning(213, JText::_('Rethumbnail: Cannot create Directory for images'));
        return false;
      }
    }

    if(!is_dir($dir_thumbnails)) {
      if(!mkdir($dir_thumbnails, 0777)) {
        JError::raiseWarning(213, JText::_('Rethumbnail: Cannot create Directory for thumbnails'));
        return false;
      }
    }

    $folders = JFolder::folders( $dir_images, '^[0-9]+$' );

    if( !is_array( $folders ) ){ $folders = Array(); }

    foreach( $folders as $folder){
      $files = JFolder::files( $dir_images.DS.$folder, "\\.jpg" );

      if( !is_array( $files ) ){ $files = Array(); }

      foreach($files as $file){

        $size   = getimagesize ( $dir_images.DS.$folder.DS.$file );
        if(($size[0] > $width) || ($size[1] > $height)){

          if(!is_dir($dir_thumbnails.DS.$folder)) {
            if(!mkdir($dir_thumbnails.DS.$folder, 0777)) {
              JError::raiseWarning(213, JText::_('Rethumbnail: Cannot create Directory for user thumbnails'));
              return false;
            }
          }

          jcImageHelper::makeThumbnail( $dir_images.DS.$folder.DS.$file, $dir_thumbnails.DS.$folder.DS.$file, $width, $height, $quality );
        }
      }
    }
    return true;
  }

  function makeThumbnail($img_from, $img_to, $max_width, $max_height, $quality ) //powered by Vova!!!
  {
    global $mainframe;

    $size = getimagesize ( $img_from );

    if(($size[0] > $max_width) && ($size[0] > $size[1])) {

      $width  = $max_width;
      $k = $size[0] / $max_width;
      $height = ($size[1] / $k);

    } else {

      $width  = $size[0];
      $height = $size[1];

    }

    if($height > $max_height) {

      $k = $height / $max_height;
      $height = $max_height;
      $width = ($width / $k);

    }

    $width  = round($width);
    $height = round($height);

    switch( strtolower( strrchr( $img_from, '.' ) ) ) {
      case ".gif":
        $img = imagecreatefromgif($img_from);
        break;
      case ".png":
        $img = imagecreatefrompng($img_from);
        break;
      case ".pjpeg":
      case ".jpeg":
      case ".jpg":
        $img = imagecreatefromjpeg($img_from);
        break;
    }

    if( !$img ) {
      JError::raiseWarning(240, JText::_('Cannot create Image'));
    }

    $mini  = imagecreatetruecolor( $width, $height );

    $white = imagecolorallocate( $mini, 255, 255, 255 );

    imagefilledrectangle( $mini, 0, 0, $width, $height, $white );

    imagecopyresampled( $mini, $img, 0, 0, 0, 0, $width, $height, $size[0], $size[1] );

    $bf = JPATH_SITE.DS.'administrator'.DS.
    'components'.DS.'com_commerce'.DS.
    'images'.DS.'thumb_borders'.DS.JC_PROD_BORDER;

    if( file_exists( $bf ) ) {

      $brd = imagecreatefrompng( $bf );
      imagecopyresampled( $mini, $brd, 0, 0, 0, 0, $width, $height, imagesx( $brd ), imagesx( $brd ) );
      imagedestroy( $brd );
    }

    imagejpeg($mini, $img_to, $quality);

    imagedestroy($mini);
    imagedestroy($img);
  }

  function create_image($file, $row, $type='images')
  {
    global $mainframe;

    $user = & JFactory::getUser();
    $dst  = JC_PROD_IMAGES_DIR.DS.'jcommerce_'.$type;

    if(!is_dir($dst))
    {
      if(!mkdir($dst, 0777))
      {
        JError::raiseWarning(213, JText::_('Cannot create Directory'));
        return;
      }
    }
    $dst = $dst.DS.$row->seller_id;
    if(!is_dir($dst))
    {
      if(!mkdir($dst, 0777))
      {
        JError::raiseWarning(213, JText::_('Cannot create Directory'));
        return;
      }
    }

    $ext    = strrchr($file['name'],'.');
    $newfile  = md5($row->seller_id.$row->name).$ext;

    //jimport('joomla.filesystem.file');
    $size   = getimagesize ($file['tmp_name']);
    //print_r($size); exit;
    if(!$size[0] || !$size[1])
    {
      JError::raiseWarning(213, JText::_('Cannot get Image Size'. print_r($size, true)));
      return;
    }

    if($type == 'images')
    {
      $width   = JC_PROD_IMG_IWIDTH;
      $height  = JC_PROD_IMG_IHEIGHT;
      $quality = 100;
    }
    else
    {
      $width   = JC_PROD_WIDTH;
      $height  = JC_PROD_HEIGHT;
      $quality = JC_PROD_QUALITY;
    }
    if(!copy($file['tmp_name'], $dst.DS.$newfile))
    {
      JError::raiseWarning(240, JText::_('Cannot Upload File'));
      return;
    }

    if(($size[0] > $width) || ($size[1] > $height))
    {
      jcImageHelper::resize($dst.DS.$newfile, $type, $width, $height, $quality, $file, $size);
    }
    else
    {
      if(($type == 'images') && JC_PROD_WATERMARK)
      {
        jcImageHelper::apply_mark($dst.DS.$newfile);
      }

    }

    return $newfile;
  }

  function apply_mark($img)
  {
    JError::raiseNotice(240, JText::_('Watermark Applied'));
  }

  function apply_border($img)
  {
    JError::raiseNotice(244, JText::_('Border Applied'));
  }

  function resize($image, $type, $max_width, $max_height, $quality, $file, $size)
  {
    global $mainframe;
    //echo $image; exit;
    if(($size[0] > $max_width) && ($size[0] > $size[1]))
    {
      $width  = $max_width;
      $k = $size[0] / $max_width;
      $height = ($size[1] / $k);
    }
    else
    {
      $width  = $size[0];
      $height = $size[1];
    }

    if($height > $max_height)
    {
      $k = $height / $max_height;
      $height = $max_height;
      $width = ($width / $k);
    }

    $width  = round($width);
    $height = round($height);

    switch(strtolower($file['type']))
    {
      case "image/gif":
        $img = imagecreatefromgif($image);
        break;
      case "image/png":
        $img = imagecreatefrompng($image);
        break;
      case "image/pjpeg":
      case "image/jpeg":
        $img = imagecreatefromjpeg($image);
        break;
    }
    if(!$img)
    {
      JError::raiseWarning(240, JText::_('Cannot create Image'.$file['tmp_name'].$file['type']));
    }

    $mini  = imagecreatetruecolor($width, $height);
    $white = imagecolorallocate  ($mini,255,255,255);

    imagefilledrectangle($mini,0,0,$width,$height,$white);
    imagecopyresampled($mini,$img,0,0,0,0,$width,$height,$size[0],$size[1]);

    if(($type == 'thumbnail') && JC_PROD_BORDER)
    {
      $bf = JPATH_SITE.DS.'administrator'.DS.
      'components'.DS.'com_commerce'.DS.
      'images'.DS.'thumb_borders'.DS.JC_PROD_BORDER;
      if(file_exists($bf))
      {
        $brd = imagecreatefrompng($bf);
        imagecopyresampled($mini,$brd,0,0,0,0,$width,$height,imagesx($brd),imagesx($brd));
        imagedestroy($brd);
      }
    }
    /*
    if(($type == 'images') && jcConfigHelper::get('general.watermark'))
    {
    $bf = $mainframe->getCfg('absolute_path').DS.'administrator'.DS.
    'components'.DS.'com_jcommerce'.DS.
    'images'.DS.'watermarks'.DS.jcConfigHelper::get('general.watermark');
    $brd = imagecreatefrompng($bf);
    //$white = imagecolorallocate($brd,255,255,255);
    imagecopyresampled($mini,$brd,0,0,-10,-10,$width,$height,imagesx($brd),imagesx($brd));
    imagedestroy($brd);
    }
    */
    imagejpeg($mini, $image, $quality);

    imagedestroy($mini);
    imagedestroy($img);
  }
}
















class jcHtml1 {
  function orderUpIcon($i, $condition = true, $task = 'orderup', $alt = 'Move Up', $enabled = true, $limitstart)
  {
    global $ICONS;

    $alt = JText::_($alt);
    $path =  'components/com_commerce/'.$ICONS;
    $html = '&nbsp;';
    if (($i > 0 || ($i + $limitstart > 0)) && $condition)
    {
      if($enabled) {
        $html  = '<a href="#reorder" onclick="return listItemTask(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
        $html  .= '   <img src="'.$path.'/uparrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
        $html  .= '</a>';
      } else {
        $html  = '<img src="'.$path.'/uparrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
      }
    }
    else
    {
      $html  = '<img src="components/com_commerce/images/blank.png" width="16" height="16" border="0" alt="'.$alt.'" />';
    }

    return $html;
  }
  function orderDownIcon($i, $n, $condition = true, $task = 'orderdown', $alt = 'Move Down', $enabled = true, $limitstart, $total)
  {
    global $ICONS;
    $alt = JText::_($alt);
    $path =  'components/com_commerce/'.$ICONS;
    $html = '&nbsp;';
    if (($i < $n -1 || $i + $limitstart < $total - 1) && $condition)
    {
      if($enabled) {
        $html  = '<a href="#reorder" onclick="return listItemTask(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
        $html  .= '  <img src="'.$path.'/downarrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
        $html  .= '</a>';
      } else {
        $html  = '<img src="'.$path.'/downarrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
      }
    }
    else
    {
      $html  = '<img src="components/com_commerce/images/blank.png" width="16" height="16" border="0" alt="'.$alt.'" />';
    }

    return $html;
  }


  function quickiconButton( $link, $image, $text ) {
  ?>
    <div style="float:left;margin:2px">
      <div class="icon">
      <a href="<?php echo $link; ?>">
        <img src="<?php echo str_replace(JPATH_BASE, '', JC_LAY_ICONS_DIR) ?>/cpanel/<?php echo $image?>" border="0">
        <span><?php echo $text; ?></span>
      </a>
      </div>
    </div>
  <?php
  }
  function jcLoadEffects()
  {
    Global $mainframe;
    $document =& JFactory::getDocument();
    $document->addScript('components/com_commerce/js/scriptaculous/prototype.js');
    $document->addScript('components/com_commerce/js/scriptaculous/scriptaculous.js');
    $document->addScript('components/com_commerce/js/scriptaculous/effects.js');
  }
  function jcProdImage($row, $dir='commerce_thumbnail')
  {
    global $mainframe;
    if ($dir=='commerce_images')
    {
      $image = $row->image;
      $type = "Image";
    }
    else
    {
      $image = $row->thumbnail;
      $type = "Thumbnail";
    }
    // TODO: This Icon should show(load) thumbnail on mose over
    $img = sprintf('<span class="editlinktip hasTip" title="%s::image <img src=%s>"><img align="absmiddle" style="cursor:pointer" src="components/com_jcommerce/images/media.png"></span>',
    JText::_($type), $mainframe->getCfg('live_site').'images/'.$dir.'/'.$row->seller_id.'/'.$image
    );

    $dir2 = str_replace(JPATH_SITE, "", JC_PROD_IMAGES_DIR);
    //echo JPATH_BASE.'@@'.CNF_PRODUCTS_IMAGES;
    $dir2 = str_replace("\\", "/", $dir2);
    if ($type=="Thumbnail")
    {
      $img = sprintf('<img src="%s/%s/%s/%s">', $dir2, $dir, $row->seller_id, $image );
    }
    else
    {
      $img = sprintf('<img src="%s/%s/%s/%s" width="%s" heigth="%s">', $dir2, $dir, $row->seller_id, $image,JC_PROD_WIDTH, JC_PROD_HEIGHT );
    }
    return $img;
  }

  function jcRating($num)
  {
    $num = round($num);

    if($num >= 100)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <?php
    }
    elseif($num >= 90)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star05.png" align="middle" />
      <?php
    }
    elseif($num >= 80)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    elseif($num >= 70)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star05.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    elseif($num >= 60)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    elseif($num >= 50)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star05.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    elseif($num >= 40)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    elseif($num >= 30)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star05.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    elseif($num >= 20)
    {
      ?>
      <img src="components/com_commerce/images/star10.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    elseif($num >= 10)
    {
      ?>
      <img src="components/com_commerce/images/star05.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
    else
    {
      ?>
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <img src="components/com_commerce/images/star00.png" align="middle" />
      <?php
    }
  }




}

class jcomHelper
{

  /**
   * This function generates Ajax Access lable
   *
   * @param Object $row
   * @param string $prefix the task prefix
   * @param string $table Tabl? name
   * @return void
   */
  function AccessProcessingX( &$row, $table)
  {
    if ( !$row->access ) {
      $color_access = 'style="color: green;"';
    } else if ( $row->access == 1 ) {
      $color_access = 'style="color: red;"';
    } else {
      $color_access = 'style="color: black;"';
    }

    $href = "
    <span id=\"adiv_$row->id\">
      <a href=\"javascript:void(0);\"  id=\"access_$row->id\"
      $color_access onclick=\"document.getElementById('adiv_$row->id').innerHTML = '<img src=components/com_commerce/images/load.gif>';xajax_jcAccess('$row->id', '$table',
      '$row->access')\">".JText::_( $row->groupname )."</a></span>";

    return $href;
  }

  /**
   * Enter description here...
   *
   * @param Object $row curent row
   * @param string $table table name
   * @return xml
   */
  function PublishedProcessingX( &$row, $table, $i) {

    $img  = $row->published ? $imgY='tick.png' : $imgX='publish_x.png';
    $ipath  =  JURI::root().'components/com_commerce/images/templates/' . COMM_LAY_ICONS_DIR.'/'.$img;
    $ipath = str_replace("\\", "/", $ipath);
    $task   = $row->published ? 'unpublish' : 'publish';
    $alt  = $row->published ? JText::_( 'Published' ) : JText::_( 'Unpublished' );
    $action = $row->published ? JText::_( 'Unpublish Item' ) : JText::_( 'Publish item' );

    $href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task .'\')" title="'. $action .'"><img src="'. $ipath .'" border="0" alt="'. $alt .'" /></a>';
    $href = "<span id=\"pdiv_$row->id\"><a href=\"javascript:void(0);\"  id=\"publish_$row->id\" onclick=\"document.getElementById('pdiv_$row->id').innerHTML = '<img src=components/com_commerce/images/load.gif>';xajax_jcPublish('$row->id', '$table', '$row->published')\"><img src=\"$ipath\" border=\"0\" align=\"absmiddle\" alt=\"$alt\"/></a><span>";

    return $href;
  }
  
  /**
   * Enter description here...
   *
   * @param Object $row curent row
   * @param string $table table name
   * @return xml
   */
  function sharedProcessingX( &$row, $table, $i) {

    $img  = $row->share ? $imgY='tick.png' : $imgX='publish_x.png';
    $ipath  =  JURI::root().'components/com_commerce/images/templates/' . COMM_LAY_ICONS_DIR.'/'.$img;
    $ipath = str_replace("\\", "/", $ipath);
    $task   = $row->share ? 'unpublish' : 'publish';
    $alt  = $row->share ? JText::_( 'Shared' ) : JText::_( 'Not shared' );
    $action = $row->share ? JText::_( 'Close Item' ) : JText::_( 'Share item' );

    $href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task .'\')" title="'. $action .'"><img src="'. $ipath .'" border="0" alt="'. $alt .'" /></a>';
    $href = "<span id=\"pdiv_$row->id\"><a href=\"javascript:void(0);\"  id=\"publish_$row->id\" onclick=\"document.getElementById('pdiv_$row->id').innerHTML = '<img src=components/com_commerce/images/load.gif>';
    xajax_jcShare('$row->id', '$table', '$row->share')\"><img src=\"$ipath\" border=\"0\" align=\"absmiddle\" alt=\"$alt\"/></a><span>";

    return $href;
  }

  /**
   * Enter description here...
   *
   * @param unknown_type $var
   * @param unknown_type $row
   * @param unknown_type $i
   * @param unknown_type $file
   * @param unknown_type $add
   * @return unknown
   */
  function ElementName($var, $row, $i, $file, $add = 0)
  {
    $name = sprintf(
    '<a href="javascript:void(0);" onclick="editItem(\'cb%d\', \'%s\', \'%s\' );"><span id="row_%s_%d">%s</span></a>',
    $i, $file, ($add ? $add : 0), $var, $row->id, $row->{$var}
    );
    return $name;
  }
  function AccessProcessing( &$row, $i, $prefix)
  {
    if ( !$row->access ) {
      $color_access = 'style="color: green;"';
      $task_access  = $prefix.'accessregistered';
    } else if ( $row->access == 1 ) {
      $color_access = 'style="color: red;"';
      $task_access  = $prefix.'accessspecial';
    } else {
      $color_access = 'style="color: black;"';
      $task_access  = $prefix.'accesspublic';
    }

    if ($archived == -1) {
      $href = JText::_( $row->groupname );
    } else {
      $href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task_access .'\')" '. $color_access .'>'. JText::_( $row->groupname ) .'</a>';
    }

    return $href;
  }

  function PublishedProcessing( &$row, $i, $prefix, $imgY='tick.png', $imgX='publish_x.png' ) {

    $img  = $row->published ? $imgY : $imgX;
    $task   = $row->published ? $prefix.'unpublish' : $prefix.'publish';
    $alt  = $row->published ? JText::_( 'Published' ) : JText::_( 'Unpublished' );
    $action = $row->published ? JText::_( 'Unpublish Item' ) : JText::_( 'Publish item' );

    $href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task .'\')" title="'. $action .'"><img src="images/'. $img .'" border="0" alt="'. $alt .'" /></a>';

    return $href;
  }
}

class JSToolBar1 extends JToolBarHelper
{
  function close($contr, $string = 'Close')
  {
    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript:".
    "document.adminForm.filter_order.value=''; document.adminForm.controller.value='$contr'; ".
    "submitbutton('');\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-cancel\" type=\"Standard\">";
    $html .= "</span>";
    $html .= JText::_($string);
    $html .= "</a>";
    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'close' );
  }
  function edit($file)
  {
    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript:".
    "if(document.adminForm.boxchecked.value==0){alert('".
    "Please make a selection from the list to Delete');}".
    "else{ResEdit('$file')}\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-edit\" type=\"Standard\">";
    $html .= "</span>";
    $html .= JText::_('Edit');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'edit' );
  }
  function addnew($file, $add = 0)
  {
    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript: ".
    "pBar(); listAdminClose(); xajax_jcNew('$file', 0, '$add');\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-new\" type=\"Standard\">";
    $html .= "</span>";
    $html .= JText::_('New');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'addnew' );
  }
  function delete($table, $trash = 0)
  {
    $document =& JFactory::getDocument();

    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript:".
    "if(document.adminForm.boxchecked.value==0){alert('".
    "Please make a selection from the list to Delete');}".
    "else{if(confirm('".JText::_('Are you sure you want to delete this items?')."')){ResDelete('$table', '$trash');}}\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-delete\" type=\"Standard\" id=\"bar_delete\">";
    $html .= "</span>";
    $html .= JText::_('Delete');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'delete' );
  }

  function fields()
  {
    $document =& JFactory::getDocument();

    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript:".
    "if(document.adminForm.boxchecked.value==0){alert('".
    "Please make a selection from the list to Access Fields');}".
    "else{document.adminForm.controller.value='field'; document.adminForm.filter_order.value=''; submitbutton();}\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-field\" type=\"Standard\" id=\"bar_delete\">";
    $html .= "</span>";
    $html .= JText::_('Fields');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'field' );
  }

  function publish($table, $publish)
  {
    $document =& JFactory::getDocument();

    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript:".
    "if(document.adminForm.boxchecked.value==0){alert('".
    "Please make a selection from the list to (Un)publish');}".
    "else{ResPublish(".($publish ? 0 : 1).", '$table');}\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-".(!$publish ? 'un' : null)."publish\" type=\"Standard\" id=\"bar_publish$publish\">";
    $html .= "</span>";
    $html .= !$publish ? JText::_('Unpublish') : JText::_('Publish');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'publish' );
  }
  function types()
  {
    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript: ".
    "document.adminForm.controller.value='type'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-types\" type=\"Standard\">";
    $html .= "</span>";
    $html .= JText::_('Types');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'types' );
  }
  function category()
  {
    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript: ".
    "document.adminForm.controller.value='category'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-category\" type=\"Standard\">";
    $html .= "</span>";
    $html .= JText::_('Categories');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'category' );
  }
  function records()
  {
    $html = "<a href=\"javascript:void(0);\" onclick=\"javascript: ".
    "document.adminForm.controller.value='record'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
    $html .= "<span class=\"icon-32-record\" type=\"Standard\">";
    $html .= "</span>";
    $html .= JText::_('Content');
    $html .= "</a>";

    $bar = & JToolBar::getInstance();
    $bar->appendButton( 'Custom', $html, 'record' );
  }
}

class CommerceHelper
{

  /**
     * This function generates Ajax Access lable
     *
     * @param Object $row
     * @param string $prefix the task prefix
     * @param string $table Tabl? name
     * @return void
     */
  function AccessProcessingX( &$row, $table)
  {
    if ( !$row->access ) {
      $color_access = 'style="color: green;"';
    } else if ( $row->access == 1 ) {
      $color_access = 'style="color: red;"';
    } else {
      $color_access = 'style="color: black;"';
    }

    $href = "
        <span id=\"adiv_$row->id\">
          <a href=\"javascript:void(0);\"  id=\"access_$row->id\"
          $color_access onclick=\"document.getElementById('adiv_$row->id').innerHTML = '<img src=components/com_jcommerce/images/load.gif>';xajax_jcAccess('$row->id', '$table',
          '$row->access')\">".JText::_( $row->groupname )."</a></span>";

    return $href;
  }

  /**
     * Enter description here...
     *
     * @param Object $row curent row
     * @param string $table table name
     * @return xml
     */
  function PublishedProcessingX( &$row, $table) {
    $prefix='';
    $img    = $row->published ? $imgY='tick.png' : $imgX='publish_x.png';
    $task   = $row->published ? $prefix.'unpublish' : $prefix.'publish';
    $alt    = $row->published ? JText::_( 'Published' ) : JText::_( 'Unpublished' );
    $action = $row->published ? JText::_( 'Unpublish Item' ) : JText::_( 'Publish item' );

    $i = '';

    $href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task .'\')" title="'. $action .'"><img src="images/'. $img .'" border="0" alt="'. $alt .'" /></a>';
    $href = "<span id=\"pdiv_$row->id\"><a href=\"javascript:void(0);\"  id=\"publish_$row->id\" onclick=\"document.getElementById('pdiv_$row->id').innerHTML = '<img src=components/com_jcommerce/images/load.gif>';xajax_jcPublish('$row->id', '$table', '$row->published')\"><img src=\"images/$img\" border=\"0\" align=\"absmiddle\" alt=\"$alt\"/></a><span>";

    return $href;
  }
  function ElementName($var, $row, $i, $file, $add = 0)
  {
    $name = sprintf(
    '<a href="javascript:void(0);" onclick="editItem(\'cb%d\', \'%s\', \'%s\' );"><span id="row_%s_%d">%s</span></a>',
    $i, $file, ($add ? $add : 0), $var, $row->id, $row->{$var}
    );
    return $name;
  }
  function AccessProcessing( &$row, $i, $prefix)
  {
    if ( !$row->access ) {
      $color_access = 'style="color: green;"';
      $task_access  = $prefix.'accessregistered';
    } else if ( $row->access == 1 ) {
      $color_access = 'style="color: red;"';
      $task_access  = $prefix.'accessspecial';
    } else {
      $color_access = 'style="color: black;"';
      $task_access  = $prefix.'accesspublic';
    }

    if ($archived == -1) {
      $href = JText::_( $row->groupname );
    } else {
      $href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task_access .'\')" '. $color_access .'>'. JText::_( $row->groupname ) .'</a>';
    }

    return $href;
  }

  function PublishedProcessing( &$row, $i, $prefix, $imgY='tick.png', $imgX='publish_x.png' ) {

    $img    = $row->published ? $imgY : $imgX;
    $task   = $row->published ? $prefix.'unpublish' : $prefix.'publish';
    $alt    = $row->published ? JText::_( 'Published' ) : JText::_( 'Unpublished' );
    $action = $row->published ? JText::_( 'Unpublish Item' ) : JText::_( 'Publish item' );

    $href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task .'\')" title="'. $action .'"><img src="images/'. $img .'" border="0" alt="'. $alt .'" /></a>';

    return $href;
  }

}

?>
