<?php
/**
 * $Id: balance.php 7992 2012-03-29 05:04:29Z alfiya $
 * $LastChangedDate: 2012-03-29 11:04:29 +0600 (Thu, 29 Mar 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class CommerceModelBalance extends JModel
{

	function __construct()
	{
		parent::__construct();
	}

	function getCurrentBalance($seller_id)
	{
		$sql = "SELECT b.balance FROM #__jc_users u
		JOIN #__jc_users_balance b ON u.balance_id = b.id
		WHERE u.user_id = '$seller_id' AND u.section_id = '".COMM_SECTION_ID."' AND b.section_id = '".COMM_SECTION_ID."'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getHistory($seller_id, $with_limit = false)
	{
		global $mainframe;
		$option = JRequest::getVar('option', 'com_commerce');
		$context          = "$option.view_balance";

		$limit      = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		$sql = "SELECT b.*
		FROM #__jc_users_balance b
		WHERE b.user_id = '$seller_id'
		AND b.section_id = '".COMM_SECTION_ID."'
		ORDER BY id DESC";
		if($with_limit && $limit)
		{
			$sql .= " LIMIT $limitstart, $limit";
		}
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getOrdersDetails($id)
	{
		$sql = "SELECT (SUM(o.price * (If(o.amount!= 0, o.amount, 1))) + SUM(o.tax) - SUM(o.discount)) as sales
		FROM #__jc_orders_products as o WHERE o.order_id = '$id'"; // - SUM(o.refund)
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getOrderSellers($order_id, $section_id)
	{
		$sql = "SELECT r.user_id as seller_id, SUM((price * amount) + tax - discount - refund) as balance
		FROM #__jc_orders_products pr
		JOIN #__js_res_record r ON r.id = pr.product_id
		WHERE order_id = '$order_id' AND pr.section_id = '".$section_id."'
		GROUP BY r.user_id";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getOrderShipping($order_id)
	{
		/*$sql = "SELECT pr.price, pr.extra
		FROM #__jc_orders_products pr
		WHERE order_id = '$order_id' AND section_id = '".COMM_SECTION_ID."' AND extra LIKE 'shipping::%'";
		*/$sql = "SELECT pr.price, pr.extra
		FROM #__jc_orders_products pr
		WHERE order_id = '$order_id' AND product_id = 0 AND section_id = '".COMM_SECTION_ID."'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getCustomerBalance($uid)
	{
		$sql = "SELECT * FROM #__jc_customers_balance
		WHERE user_id = '$uid' AND section_id = '".COMM_SECTION_ID."'
		ORDER BY id DESC
		LIMIT 0, 1";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}


	function getCustomerBalanceHistory($uid, $with_limit = false)
	{
		global $mainframe;
		$option = JRequest::getVar('option', 'com_commerce');
		$context = "$option.view_balance";

		$limit = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		$sql = "SELECT * FROM #__jc_customers_balance
		WHERE user_id = '$uid' AND section_id = '".COMM_SECTION_ID."'
		ORDER BY id DESC";
		if($with_limit && $limit)
		{
			$sql .= " LIMIT $limitstart, $limit";
		}
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}


	function sendNegativeBalanceAlert($user_id)
	{
		$config = JFactory::getConfig();
		jimport('joomla.mail.mail');
		jimport('joomla.mail.helper');
		$user =& JFactory::getUser($user_id);
		
		$subject = JText::_("NEGATIVE_BALANCE_ALERT_SBJ");
		$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);
		
		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');

		$mail = JFactory::getMailer();
		$body = JText::_('NEGATIVE_BALANCE_ALERT');
		$body = str_replace('[USER]', $user->get('name'), $body);
		$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename')." ".JURI::root(), $body);
		$body = str_replace('[SITE_URL]', JURI::root(), $body);
		$mail->setSender($sender);
		
		$mail->AddAddress($user->get('email'));
		if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
		$mail->IsHTML(true);
		$mail->setBody(JMailHelper::cleanBody($body));
		$mail->setSubject(JMailHelper::cleanSubject($subject));
		if( !$mail->Send() ) {
			JError::raiseWarning(200, 'Error to send negative balance alert');
			// return;
		}
	}


}
?>