<?php
/**
 * $Id: cart.php 8018 2012-04-09 04:08:33Z alfiya $
 * $LastChangedDate: 2012-04-09 10:08:33 +0600 (Mon, 09 Apr 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class CommerceModelCart extends JModel
{
	function __construct()
	{
		parent::__construct();
	}

	function getArticleInfo($id)
	{
		$sql = "SELECT * FROM #__js_res_record WHERE id='$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getFieldValue($id)
	{
		$sql = "SELECT v.field_value, v.field_id, f.params
			FROM #__js_res_record_values v
 		  	JOIN #__js_res_record r ON v.record_id = r.id 
 		  	JOIN #__js_res_fields f ON v.field_id = f.id
 		  	WHERE r.id = '".$id."' AND f.type='price' AND f.published = '1'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
			
	}

	function getCurrencyInfo($id)
	{
		$query = "SELECT  cur.*, IF(cur.mark != '', cur.mark, cur.code) as mark, uc.rate, uc.format
		FROM #__jc_currency cur
		JOIN #__jc_users_currencies uc ON cur.id = uc.currency_id
		WHERE cur.id = '$id' AND uc.section_id = '".COMM_SECTION_ID."'";
		$this->_db->setQuery( $query);
		return $this->_db->loadObject();
	}

	function getTaxInfo($id)
	{
		$query = "SELECT t.rate, t.name, t.country
		FROM #__jc_taxes t
		WHERE t.id = '$id' AND t.published = '1'";
		$this->_db->setQuery( $query);
		return $this->_db->loadObject();
	}
	function getPriceExtra($id, $rid)
	{
		$query = "SELECT value
		FROM #__js_res_field_extra
		WHERE ref_id = 'price_ext' AND field_id = '$id' AND record_id = '$rid'";
		$this->_db->setQuery( $query);
		$value = new stdClass();
		if($extra = $this->_db->loadResult())
		{
			$val = unserialize($extra);

			if($val['currency_id'] != COMM_CORE_CURRENCY )
			{
				$sql = "SELECT uc.rate, IF(cur.mark != '', cur.mark, cur.code) as mark, uc.format
				FROM #__jc_users_currencies uc
				JOIN #__jc_currency cur ON uc.currency_id = cur.id
				WHERE uc.currency_id = '{$val['currency_id']}'
				AND uc.section_id = ".COMM_SECTION_ID;
				$this->_db->setQuery($sql);

				$value->currency = $this->_db->loadObject();
			}
			if($val['tax_id'])
			{
				$sql = "SELECT rate, name, country FROM #__jc_taxes WHERE id = '{$val['tax_id']}'";
				$this->_db->setQuery($sql);
				$value->tax = $this->_db->loadObject();
			}
			if(isset($val['extra']))
			{
				$value->extra = $val['extra'];
			}
		}
		return $value;
	}

	function getSellerInfo($rid, $field)
	{
		if(is_array($rid)) $rid = implode(", ", $rid);
		$query = "SELECT ".$field."
			FROM #__users
			WHERE id IN ( ".$rid." )";
		$this->_db->setQuery( $query);
		return $this->_db->loadResultArray();
	}

	function getCouponDiscount($val = array())
	{
		$query = "SELECT id, discount, discount_type as type
			FROM #__jc_coupons
			WHERE value='".addslashes($val['value'])."' AND seller_id = '".$val['seller_id']."' AND section_id = '".COMM_SECTION_ID."'";
		$this->_db->setQuery( $query);
		return $this->_db->loadObject();
	}

	function isTangible($rid)
	{
		if(is_array($rid)) {
			$query = "SELECT ex.value, f.params FROM #__js_res_field_extra ex
		JOIN #__js_res_fields f ON ex.field_id = f.id
		WHERE ex.record_id IN (".implode(",", $rid).") AND ex.ref_id = 'tangible' AND f.published = '1'";
		} else {
			$query = "SELECT ex.value, f.params FROM #__js_res_field_extra ex
			JOIN #__js_res_fields f ON ex.field_id = f.id
			WHERE ex.record_id = '$rid' AND ex.ref_id = 'tangible' AND f.published = '1'";

		}
		$this->_db->setQuery( $query);
		$res = $this->_db->loadObjectList();
		$return = false;
		foreach($res as $row)
		{
			$val = new JParameter($row->value);
			if($val->get('weight') > 0)
			{
				$return = $res;
				break;
			}
		}
		return $return;
	}


	function getShippingMethods($seller_id = false, $default, $weight)
	{
//		if($seller_id){
		if(COMM_MULTI_SELLER){
			$query = "(SELECT sh.name, sh.id
			FROM #__jc_ship_forwarder sh
			WHERE seller_id = '$seller_id' AND published = '1' AND section_id = '".COMM_SECTION_ID."')
			UNION
			( SELECT sh.name, sh.id FROM #__jc_ship_forwarder sh
			JOIN #__jc_users_shipping us on sh.id = us.ship_id
			WHERE us.user_id='$seller_id' AND sh.is_core='1' AND us.published = '1'
			AND us.ship_type = 'shipping' AND us.section_id = '".COMM_SECTION_ID."')";
		} else{
			$query = "SELECT * FROM #__jc_ship_forwarder sh	WHERE published = '1' AND section_id = '".COMM_SECTION_ID."'";
		}
		$query .= " ORDER BY name";

		$this->_db->setQuery( $query);//echo $this->_db->_sql."<br>";
		if($list = $this->_db->loadObjectList())
		{
			$opt = array();
			$out = '';
			foreach($list as $item)
			{
				$out .= '<ol id="sh_methods'.$seller_id.'"><b>'.$item->name.'</b> '.JText::_('schemes').' :';
					
				$scheme = $this->getShippingScheme($item->id, $seller_id, $weight);
				if(!$scheme || !count($scheme)) {
					$out .= ' '.JText::_('not found').' <span class="small"> <b>( '.JText::_('Price is N/A').' )</b></span><br>';
					/*$out .= '<input type="radio" name="shipping" value="'.$item->id.'::n/a"'.($item->id.'::n/a' == $default ? 'checked' : '').'
								onclick="this.form.submit();">
								'.JText::_('enter sum manually').'<br>';*/
					$checked = ($item->id.'::n/a' == $default ? 1 : 0);
					$ship_info = $item->name.'::'.JText::_('Manually entered');
					$ship_id = $item->id.'::n/a';
					$def = '';
					if($checked)
					{
						$session = & JFactory::getSession();
						$shipping = $session->get('shipping' . '-' . COMM_SECTION_ID);
						$def = '<input type="text" onkeyup="formatFloat(this.id)" id="shipsum'.$seller_id.'" size="5" value="'.$shipping[$seller_id]['sum'].'">
						<input type="button" value="'.JText::_('Ok').'" 
						onclick="xajax_jcSetShip('.$seller_id.', document.getElementById(\'shipsum'.$seller_id.'\').value, \''.$weight.'\', \''.$ship_info.'\', \''.$ship_id.'\', 0)">';
					}
					$out .= '<div style="height: 30px;">
							<input type="radio" name="shipping['.$seller_id.']" value="'.$item->id.'::n/a" '.($checked ? 'checked': '').'
								onclick="xajax_jcEnterShipSum('.$seller_id.', \''.$weight.'\', \''.$ship_info.'\', \''.$ship_id.'\');" 
								id="manual'.$seller_id.'">
								<label for="manual'.$seller_id.'">'.JText::_('enter sum manually').'</label> <span id="inputshipsum'.$seller_id.'">'.$def.'</span></div>';
				}
				else
				{
					$core = getCore();
					foreach ($scheme as $val)
					{
						if($val->currency_id != COMM_CORE_CURRENCY)
						{
							$sh_cur = $this->getCurrencyInfo($val->currency_id);
							$val->price = $val->price / $sh_cur->rate;
						}
						$val->price = round($val->price, 2);
						$sumtopay = $val->pricetype ? round($val->price * $weight, 2) : $val->price;

						if(is_float($val->price))
						$val->price = str_replace(array("00", "Sign"), array($val->price, $core->mark), COMM_LAYOUT_PRICE);

						/*$out .= '<li>
							<input type="radio" name="shipping" value="'.$item->id .'::'.$val->id.'"'.($item->id.'::'.$val->id == $default ? 'checked' : '').'
								onclick="this.form.submit();">
							'.$val->name.' 
							<span class="small"> <b>( '.$val->price.' '.($val->pricetype ? JText::_('per Kg') : JText::_('fixed') ).' )</b><br>
							'.$val->descr.'</span>
							</li>';	*/	
						$out .= '<li>
							<input type="radio" name="shipping['.$seller_id.']" value="'.$item->id .'::'.$val->id.'"'.($item->id.'::'.$val->id == $default ? 'checked' : '').'
								onclick="xajax_jcSetShip('.$seller_id.', \''.$sumtopay.'\', \''.$weight.'\', \''.$item->name.'::'.$val->name.'\', \''.$item->id .'::'.$val->id.'\', '.$val->pricetype.')">
							'.$val->name.' 
							<span class="small"> <b>( '.$val->price.' '.($val->pricetype ? JText::_('per Kg') : JText::_('fixed') ).' )</b><br>
							'.$val->descr.'</span>
							</li>';					
					}
				}
				$out .= '
						</ol>	';/*					
					<script type="text/javascript">					
					var ShipMethods' . $seller_id . ' = new Fx.Slide("sh_methods' . $seller_id . '", {
						 mode: "vertical",
						 duration: 1000,
						 resetHeight: true,
					  	 transition: Fx.Transitions.Back.easeInOut
						}).hide();
					function toogleShipMethods' . $seller_id . '()
					{
						ShipMethods' . $seller_id . '.toggle();
					}
					
					</script>
			';*/
			}
			return $out;
		}
		else {
			return false;
		}
	}

	function getShippingMethodsForItem($id, $seller_id = false, $default, $weight)
	{
		if($seller_id){
			$query = "(SELECT sh.name, sh.id
			FROM #__jc_ship_forwarder sh
			WHERE seller_id = '$seller_id' AND published = '1' AND section_id = '".COMM_SECTION_ID."')
			UNION
			( SELECT sh.name, sh.id FROM #__jc_ship_forwarder sh
			JOIN #__jc_users_shipping us on sh.id = us.ship_id
			WHERE us.user_id='$seller_id' AND sh.is_core='1' AND us.published = '1'
			AND us.ship_type = 'shipping' AND us.section_id = '".COMM_SECTION_ID."')";
		} else{
			$query = "SELECT * FROM #__jc_ship_forwarder sh	WHERE published = '1' AND section_id = '".COMM_SECTION_ID."'";
		}
		$query .= " ORDER BY name";

		$this->_db->setQuery( $query);
		if($list = $this->_db->loadObjectList())
		{
			$opt = array();
			$out = '';

			foreach($list as $item)
			{
				$out .= '<ol><b>'.$item->name.'</b> '.JText::_('schemes').' :';
					
				$scheme = $this->getShippingScheme($item->id, $seller_id, $weight);
				var_dump($scheme);
				if(!$scheme || !count($scheme)) 
				{
					$out .= ' '.JText::_('not found').' <span class="small"> <b>( '.JText::_('Price is N/A').' )</b></span><br>';
					$out .= '<input type="radio" name="shipping['.$id.']" value="'.$item->id.'::n/a"'.($item->id.'::n/a' == $default ? 'checked' : '').'
								onclick="xajax_jcEnterShipSum('.$id.', '.$weight.', \''.$item->name.'::'.JText::_('Manually entered').'\', \''.$item->id.'::n/a\')">
								'.JText::_('enter sum manually').'<br>';
					$out .= '<span id="inputshipsum'.$id.'"></span>';
				}
				else
				{
					$core = getCore();
					foreach ($scheme as $val)
					{
						if($val->currency_id != COMM_CORE_CURRENCY)
						{
							$sh_cur = $this->getCurrencyInfo($val->currency_id);
							$val->price = $val->price / $sh_cur->rate;
						}
						$val->price = round($val->price, 2);
						$sumtopay = $val->pricetype ? round($val->price * $weight, 2) : $val->price;

						if(is_float($val->price))
						$val->price = str_replace(array("00", "Sign"), array($val->price, $core->mark), COMM_LAYOUT_PRICE);

						$out .= '<li>
							<input type="radio" name="shipping['.$id.']" value="'.$item->id .'::'.$val->id.'"'.($item->id.'::'.$val->id == $default ? 'checked' : '').'
								onclick="xajax_jcSetShip('.$id.', '.$sumtopay.', '.$weight.', \''.$item->name.'::'.$val->name.'\', \''.$item->id .'::'.$val->id.'\', '.$val->pricetype.')">
							'.$val->name.' 
							<span class="small"> <b>( '.$val->price.' '.($val->pricetype ? JText::_('per Kg') : JText::_('fixed') ).' )</b><br>
							'.$val->descr.'</span>
							</li>';						
					}
				}
				$out .= '
						</ol>';
			}
			return $out;
		}
		else {
			return false;
		}
	}

	function getShipMethodName($id)
	{
		$query = "SELECT name FROM #__jc_ship_forwarder sh	WHERE id = '$id'";
		$this->_db->setQuery( $query);
		return $this->_db->loadResult();
	}

	function getShipSchemeName($id)
	{
		$query = "SELECT name FROM #__jc_ship_forwarder_shema sh	WHERE id = '$id'";
		$this->_db->setQuery( $query);
		return $this->_db->loadResult();
	}

	function getShippingScheme($frwrd_id, $seller_id, $weight, $id = false)
	{
		$session =& JFactory::getSession();
		$address = $session->get('address');
		$user =& JFactory::getUser();

		if(!$seller_id){
			$cart = $session->get('my_cart'.'-'.COMM_SECTION_ID);
			$artinfo = $this->getArticleInfo($cart[0]->article);
			$seller_id = $artinfo->user_id;
		}
		$query = "SELECT params FROM #__jc_users WHERE user_id = '$seller_id' AND section_id = '".COMM_SECTION_ID."'";
		$this->_db->setQuery($query);
		if($userconf = $this->_db->loadResult()) {
			$params = new JParameter($userconf);
			$country = $params->get('usr_shop_country');
		}

		$charge = 0;
		if($user->id)
		$uaddr = $this->getAddresses('ship', (isset($address['ship']) ? $address['ship']: false ) );
		else
		{
			$uaddr = $session->get('unreg_address');
			if(isset($uaddr['ship'])) $uaddr = $uaddr['ship'];
			else $uaddr = false;
		}
		if($uaddr)
		{
			if(!is_object($uaddr)) settype($uaddr, 'object');
			if($id == 'n/a') return false;
			
			$cond = '';
			if($uaddr->city != '')
			$cond .= " OR sh.tolocation LIKE '%{$uaddr->country}::{$uaddr->city}%'";
			if($uaddr->state != '')
			$cond .= " OR sh.tolocation LIKE '%{$uaddr->country}::{$uaddr->city}::{$uaddr->state}%'";

			$query = "SELECT sh.id, sh.name, sh.price, sh.pricetype, sh.currency_id, sh.description as descr
			FROM #__jc_ship_forwarder_shema sh
			WHERE ".
			(COMM_MULTI_SELLER ? "sh.user_id = '$seller_id' AND" : '')
			." sh.published = '1' AND sh.frwrd_id='$frwrd_id'
			AND sh.fromlocation LIKE '%$country%'
			AND (sh.tolocation LIKE '%{$uaddr->country}%' $cond )
			AND $weight BETWEEN sh.weightfrom AND sh.weightto
			AND sh.section_id = '".COMM_SECTION_ID."'
			".($id ? " AND sh.id = '$id' " : "" )."
			GROUP BY sh.id
			";
			$this->_db->setQuery( $query); //echo $this->_db->_sql."<br><br>";
			$result = $this->_db->loadObjectList();

			if($id)
			{
				if(!$result) return false;
				$res = $result[0];
				$price = $res->price;
				if($res->currency_id != COMM_CORE_CURRENCY)
				{
					$curr = $this->getCurrencyInfo($res->currency_id);
					$price /= $curr->rate;
				}
				$price = round(($res->pricetype) ? $price * $weight : $price, 2);
				return $price;
			}
			$query = " 	SELECT sh.id, sh.name, sh.price, sh.pricetype, sh.currency_id, sh.description as descr
			FROM #__jc_users_shipping us
			JOIN #__jc_ship_forwarder_shema sh  on us.ship_id = sh.id
			WHERE us.ship_type = 'shippingitem'
			AND us.published = '1' AND ".
			(COMM_MULTI_SELLER ? "us.user_id = '$seller_id' AND" : '')
			." sh.published = '1' AND sh.is_core = '1'
			AND sh.fromlocation LIKE '%$country%'
			AND (sh.tolocation LIKE '%{$uaddr->country}%' $cond)
			AND $weight BETWEEN sh.weightfrom AND sh.weightto
			AND sh.frwrd_id='$frwrd_id'
			AND sh.section_id = '".COMM_SECTION_ID."'
			";
			$this->_db->setQuery( $query); //echo '123 '.$this->_db->_sql."<br><br>";
			$result2 = $this->_db->loadObjectList();
			$result = array_merge($result, $result2);
			return $result;

		}
		return $charge;
	}

	function getCommerceCountries()
	{
		$sql = "SELECT * FROM #__jc_countries ORDER BY name";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getAddresses($type, $id = false)
	{
		$user =& JFactory::getUser();
		if($id){
			$sql = "SELECT * FROM #__jc_users_addresses
			WHERE type='$type' AND user_id='{$user->id}' AND id='$id'";
			$this->_db->setQuery($sql);
			$row = $this->_db->loadObject();
			if(intval($row->country)) $row->country = $this->getLocationData('country', $row->country);
			if(intval($row->city)) $row->city = $this->getLocationData('city', $row->city);
			if(intval($row->state)) $row->state = $this->getLocationData('district', $row->state);

			return $row;
		} else {
			$sql = "SELECT * FROM #__jc_users_addresses
			WHERE type='$type' AND user_id='{$user->id}' AND section_id = '".COMM_SECTION_ID."'
			ORDER BY id DESC";
			$this->_db->setQuery($sql);
			$rows = $this->_db->loadObjectList();
			foreach ($rows as $k=>$row)
			{
				if(intval($row->country)) $rows[$k]->country = $this->getLocationData('country', $row->country);
				if(intval($row->city)) $rows[$k]->city = $this->getLocationData('city', $row->city);
				if(intval($row->state)) $rows[$k]->state = $this->getLocationData('district', $row->state);
			}
			return $rows;
		}
	}

	function getLocationData($type, $id)
	{
		
		switch($type)
		{
			case 'country' :
				$query = "SELECT name FROM #__jc_countries WHERE id = '$id'";
				break;
			case 'city' :
				$query = "SELECT name FROM #__jc_location WHERE id = '$id'";
				break;
			case 'district' :
				$query = "SELECT name FROM #__jc_location WHERE id = '$id'";
				break;
		}
		$this->_db->setQuery( $query); //echo $this->_db->_sql;
		return $this->_db->loadResult();
	}

	function getAssocValue($fid)
	{
		$user =& JFactory::getUser();
		$sql = "SELECT fvalue FROM #__juser_extended_data WHERE user_id = '{$user->id}'
		AND field_id = '$fid'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function saveAddresses($type, $info)
	{
		$user =& JFactory::getUser();
		$session =& JFactory::getSession();
		$save = $session->get('address');
		$sql = "SELECT id FROM #__jc_users_addresses
		WHERE type='$type' AND user_type='buyer' AND user_id='{$user->id}'
		AND name='{$info['name']}' AND address='{$info['address']}' AND zip='{$info['zip']}'
		AND state='{$info['state']}' AND country='{$info['country']}' AND city='{$info['city']}'
		AND tel='{$info['tel']}'
		AND section_id = ".COMM_SECTION_ID;
		$this->_db->setQuery($sql);
		if(!$this->_db->loadResult())
		{
			$sql = "INSERT INTO #__jc_users_addresses VALUES
			('', '{$info['name']}', '$type', 'buyer', '1', '{$user->id}', '{$info['address']}',
			'{$info['zip']}', '{$info['state']}', '{$info['country']}', '{$info['city']}',
			'', '{$info['tel']}', '', '', '', '', '', '', '', '', '', '".COMM_SECTION_ID."')";
			$this->_db->setQuery($sql);
			$this->_db->query();
			$save[$type] = $this->_db->insertid();
		}
		else $save[$type] = $this->_db->loadResult();
		$session->set('address', $save);
	}

	function getShipCurrency($id)
	{
		$sql = "
		SELECT uc.rate
		FROM #__jc_currency AS cur
		JOIN #__jc_users_currencies uc ON cur.id = uc.currency_id
		WHERE cur.id = '$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getProductProperty($rid)
	{
		$sql = "SELECT f.*, v.field_value, v.field_id as fid, r.id as rid
			FROM #__js_res_record_values v
 		  	JOIN #__js_res_record r ON v.record_id = r.id 
 		  	JOIN #__js_res_fields f ON v.field_id = f.id
 		  	WHERE r.id = '".$rid."' AND f.type LIKE 'product_property%' 
 		  	AND f.published = '1'
 		  	ORDER BY f.ordering";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getFieldsToShow($id)
	{
		$sql = "SELECT f.type, v.field_value, f.id as fid, f.params, f.title, v.id, v.record_id
		FROM #__js_res_fields f
		JOIN #__js_res_record_values v ON v.field_id = f.id
		WHERE f.show_cart = '1' AND v.record_id = '$id' AND f.published = '1'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getSellerGroups($sellers = false)
	{
		$sql = "SELECT title, id FROM #__community_communities WHERE published = '1'";
		if( $sellers )
		{
			$sql .= " AND user_id IN (" .( is_array($sellers) ? implode(",", $sellers): $sellers) .")" ;
		}
		$this->_db->setQuery($sql);
		$return = '';
		if($list = $this->_db->loadObjectList())
		{
			$return = '<div align="left">'.JText::_('Join groups')."<ul>";
			foreach($list as $group)
			{
				$return .= '<li><a href="index.php?option=com_community&view=groups&layout=group&id='.$group->id.'&Itemid='.JRequest::getInt('Itemid').'" target="_blank">'.$group->title.'</a></li>';
			}
			$return .= "</ul></div>";
		}
		return $return;
	}

	function getPropertyType($id)
	{
		$sql = "SELECT type FROM #__js_res_fields WHERE id = '$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getCoreDiscount($sum)
	{
		$sql = "SELECT *, IF(use_num > 0, use_num - used_num, 1) as used, IF(extime != '0000-00-00 00:00:00', IF( extime > NOW() , 0, 1), 0 ) as expired
		FROM #__jc_coupons 
		WHERE core = '1' AND published = '1' AND section_id = '".COMM_SECTION_ID."' AND invisible = '0'
		AND ctime < NOW()
		HAVING used > 0 AND expired = 0 
		ORDER BY order_sum";
		$this->_db->setQuery($sql);
		$out = '';
		if($res = $this->_db->loadObjectList())
		{
			$list = array();
			foreach ($res as $i => $val)
			{
				$discount = ($val->discount_type == 'sum') ? $val->discount : round($sum * $val->discount / 100, 2);
				$val->discount_sum = $discount;
				$list[] = $val;
			}
			$print = array();
			$core = getCore();
			$i = 0;
			foreach ($list as $val)
			{
				$amount = ($val->discount_type == 'sum' ? str_replace(array('00', 'Sign'), array($val->discount, $core->mark), COMM_LAYOUT_PRICE) : $val->discount.'%');
				$out .= '<li><b>"'.$val->value.'"</b> (discount is '.$amount.') ';
				$out .= JText::_('and').' <b>'.JText::_('SAVE').' ';
				$out .= str_replace(array('00', 'Sign'), array($val->discount_sum, $core->mark), COMM_LAYOUT_PRICE). '</b> ';
				$out .= JText::_('if your order amount is more than').' '.str_replace(array('00', 'Sign'), array($val->order_sum, $core->mark), COMM_LAYOUT_PRICE);
				$out .= '</li>';
				$i ++ ;
			}
		}
		return $out;
	}

}
?>