<?php
/**
 * $Id: orders.php 7992 2012-03-29 05:04:29Z alfiya $
 * $LastChangedDate: 2012-03-29 11:04:29 +0600 (Thu, 29 Mar 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class CommerceModelOrders extends JModel
{

	function __construct()
	{
		parent::__construct();
	}

	function getSellerOrders($seller_id, $order_id = false, $with_limit = false, $orderby = false)
	{
		global $mainframe;
		$option = JRequest::getVar('option', 'com_commerce');
		$context = "$option.view_orders";
		$filter_order = $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', (($order_id) ? 'pr.id' : 'ord.id'));
		$filter_order_Dir = $mainframe->getUserStateFromRequest("$context.filter_order_Dir", 'filter_order_Dir', 'DESC');
		$filter_section = $mainframe->getUserStateFromRequest($context . '_default_filter_section', 'filter_section', COMM_SECTION_ID);
		$filter_status = $mainframe->getUserStateFromRequest($context . '_default_filter_status', 'status', 0);
		
		$limit = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		
		if ($order_id)
		{
			$sql = "SELECT pr.*, st.name as status, st.description as descr, 
			IF(pr.product_id > 0, (SELECT title FROM #__js_res_record WHERE id = pr.product_id), '') as title,
			st.ordering, st.isfinal, ord.pay, ord.deducted
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON ord.id = pr.order_id
			JOIN #__jc_orders_statuses st ON pr.status_id = st.id			
			WHERE " . ((COMM_MULTI_SELLER) ? "pr.seller_id = '$seller_id' AND " : "") . "pr.order_id = '$order_id' AND ord.section_id = '" . COMM_SECTION_ID . "'"; //" GROUP BY pr.product_id";
		}
		else
		{
			$sql = "SELECT ord.*, st.name as status
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			JOIN #__jc_orders_statuses st ON ord.status_id = st.id
			WHERE " . ((COMM_MULTI_SELLER) ? "pr.seller_id = '$seller_id' AND " : "") . "ord.section_id = '" . $filter_section . "' 
			" . ($filter_status ? " AND ord.status_id = '$filter_status'" : '') . "
			GROUP BY ord.id ";
		}
		if ($orderby)
			$sql .= "\n ORDER BY $filter_order $filter_order_Dir";
		
		if ($with_limit && $limit)
			$sql .= " LIMIT $limitstart, $limit";
		$this->_db->setQuery($sql);   //echo $this->_db->_sql;
		return $this->_db->loadObjectList();
	}

	function getBuyerOrders($user_id, $with_limit = false, $orderby = false)
	{
		global $mainframe;
		$option = JRequest::getVar('option', 'com_commerce');
		$context = "$option.view_orders";
		$filter_order = $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', 'ord.id');
		$filter_order_Dir = $mainframe->getUserStateFromRequest("$context.filter_order_Dir", 'filter_order_Dir', 'DESC');
		$filter_section = $mainframe->getUserStateFromRequest($context . '_purchase_filter_section', 'filter_section', COMM_SECTION_ID);
		$filter_status = $mainframe->getUserStateFromRequest($context . '_default_filter_status', 'status', 0);
		
		$limit = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		
		$sql = "SELECT ord.*, st.name as status FROM #__jc_orders ord
		JOIN #__jc_orders_statuses st ON st.id = ord.status_id
		WHERE ord.user_id = '$user_id' AND ord.canceled = '0' AND ord.section_id = '" . $filter_section . "'
		" . ($filter_status ? " AND ord.status_id = '$filter_status'" : '');
		
		if ($orderby)
			$sql .= "\n ORDER BY $filter_order $filter_order_Dir";
		else
			$sql .= " ORDER BY ord.ctime";
		
		if ($with_limit && $limit)
			$sql .= " LIMIT $limitstart, $limit";
		
		$this->_db->setQuery($sql);//echo $this->_db->_sql;
		return $this->_db->loadObjectList();
	}

	function getBuyerProducts($user_id, $order_id, $index = false)
	{
		if ($index)
		{
			$sql = "SELECT rec.title, pr.product_link, pr.status_id
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			JOIN #__js_res_record rec ON pr.product_id=rec.id
			WHERE pr.order_id = '$order_id' AND ord.user_id = '$user_id'";
		}
		else
		{
			$sql = "SELECT pr.*, st.name as status, ord.pay, ord.deducted,
			st.description as descr, IF(pr.product_id > 0, (SELECT title FROM #__js_res_record WHERE id = pr.product_id), '') as title
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id			
			JOIN #__jc_orders_statuses st ON pr.status_id = st.id
			WHERE pr.order_id = '$order_id' AND ord.user_id = '$user_id'";
		}
		$sql .= " ORDER BY seller_id, product_id DESC";
		/*
		 * if($index){
			$sql = "SELECT rec.title, pr.product_link, pr.status_id
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			JOIN #__js_res_record rec ON pr.product_id=rec.id
			WHERE pr.order_id = '$order_id' AND ord.user_id = '$user_id'";
		}
		else
		{
			$sql = "SELECT pr.*, rec.title, st.name as status, ord.pay, ord.deducted,
			st.description as descr
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			JOIN #__js_res_record rec ON pr.product_id=rec.id
			JOIN #__jc_orders_statuses st ON pr.status_id = st.id
			WHERE pr.order_id = '$order_id' AND ord.user_id = '$user_id'";
		}
		 */
		$this->_db->setQuery($sql); //echo $this->_db->_sql;
		return $this->_db->loadObjectList();
	}

	function getCouponDiscount($id)
	{
		$sql = "SELECT discount, discount_type FROM #__jc_coupons WHERE id = '$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getProductPrice($id)
	{
		$sql = "SELECT v.field_value
			 FROM #__js_res_record_values v
 		  	JOIN #__js_res_record r ON v.record_id = r.id 
 		  	JOIN #__js_res_fields f ON v.field_id = f.id
 		  	WHERE r.id = '" . $id . "' AND f.type='price'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getStatusList()
	{
		$sql = "SELECT id, name, ordering, isfinal FROM #__jc_orders_statuses WHERE published = '1' AND type = 'product' ORDER BY ordering ";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getProductTypes($rid)
	{
		$sql = "SELECT value, ref_id, field_id, record_id
		FROM #__js_res_field_extra
		WHERE field_id = '{$field->fid}' AND record_id = '$rid'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getOrderProductProperty($id)
	{
		$sql = "SELECT pp.property as value, pp.price_affect as price, rf.type, pp.prop_id, pr.product_id
		FROM #__jc_orders_products_property pp
		JOIN #__js_res_fields rf ON pp.prop_id = rf.id
		JOIN #__jc_orders_products pr ON pp.order_product_id = pr.id
		WHERE pp.order_product_id = '$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getShipping($order_id, $seller_id = false)
	{
		$sql = "SELECT pr.id, pr.price, pr.extra
		FROM #__jc_orders_products pr
		WHERE pr.order_id = '$order_id' AND pr.product_id = '0' AND pr.extra != ''";
		if ($seller_id)
			$sql .= " AND pr.seller_id = '$seller_id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getBalance($user_id)
	{
		$sql = "SELECT SUM(global) as global, SUM(personal) as personal
		FROM #__jc_users_balance WHERE user_id = '$user_id'";
		$sql = "SELECT SUM(" . COMM_PAYMENT_METHOD . ") as sum
		FROM #__jc_users_balance WHERE user_id = '$user_id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getStatusIdByName($name, $type)
	{
		$sql = "SELECT id FROM #__jc_orders_statuses WHERE name REGEXP '" . $name . "' AND type = '$type'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function updateOrderProductStatus($order, $product, $status)
	{
		$sql = "UPDATE #__jc_orders_products SET status_id = '$status'
		WHERE order_id = '$order' AND product_id = '$product'";
		$this->_db->setQuery($sql);
		$this->_db->query($sql);
		$sql = "SELECT COUNT(*) FROM #__jc_orders_products WHERE order_id = '$order' AND product_id > 0 AND status_id < 7";
		$this->_db->setQuery($sql);
		if ($this->_db->loadResult())
		{
			$final = $this->getStatusFinal();
			$sql = "UPDATE #__jc_orders_products SET status_id = '{$final->id}'
			WHERE order_id = '$order' AND product_id = '0' AND extra LIKE 'shipping%'";
			$this->_db->setQuery($sql);
			$this->_db->query($sql);
		}
	}

	function onSuccessOrder($user_id, $product, $status_id, $amount)
	{
		$sql = "SELECT ex.value, pr.status_id, f.params, ex.ref_id as plugin, ex.field_id, rec.user_id,
		pr.order_id
		FROM #__jc_orders_products pr
		JOIN #__jc_orders ord ON pr.order_id = ord.id
		JOIN #__js_res_field_extra ex ON pr.product_id=ex.record_id
		JOIN #__js_res_fields f ON ex.field_id = f.id
		JOIN #__js_res_record rec ON ex.record_id = rec.id
		WHERE f.type='product_type'
		AND ex.record_id = '$product'
		AND ord.user_id = '$user_id' AND f.published = '1'
		GROUP BY  ex.ref_id";
		$this->_db->setQuery($sql); //echo $this->_db->_sql;
		if ($res = $this->_db->loadObjectList())
		{
			$dispatcher = & JDispatcher::getInstance();
			foreach($res as $type)
			{
				JPluginHelper::importPlugin('joomsuite_product_type', $type->plugin);
				$prodvalue = explode("=", $type->value);
				if (isset($prodvalue[1]))
				{
					$dispatcher->trigger('onAfterSuccessOrder', array($type->plugin, $type->order_id, $product, $type->field_id, $type->value, $user_id, $amount));
				}
			}
		}
	}

	function getStatusFinal()
	{
		$sql = "Select id, name FROM #__jc_orders_statuses WHERE isfinal = '1' AND type= 'product'";
		$this->_db->setQuery($sql);
		$res = $this->_db->loadObject();
		if (!$res)
		{
			$sql = "Select id, name FROM #__jc_orders_statuses WHERE type= 'product' ORDER by ordering DESC";
			$this->_db->setQuery($sql);
			$res = $this->_db->loadObject();
		}
		return $res;
	}

	function getInboxHistory($oid, $layout)
	{
		$sql = "SELECT m.*, u.username
		FROM #__js_inbox_messages m
		LEFT JOIN #__users u ON m.user_id = u.id
		LEFT JOIN #__js_inbox i ON m.id = i.message_id
		WHERE m.body LIKE '%order_id=$oid&%'";
		$this->_db->setQuery($sql);
		$history = '';
		if ($msg = $this->_db->loadObject())
		{
			require_once JPATH_ROOT . DS . 'components' . DS . 'com_jsinbox' . DS . 'api.php';
			$user_id = null;
			if (COMM_MULTI_SELLER && $layout == '')
			{
				$user = JFactory::getUser();
				$user_id = $user->id;
			}
			$history = JSInboxApi::renderMessageTree($msg->id, $user_id);
		}
		return $history;
	
	}

	function checkCustomerOrder($order_id, $email)
	{
		$sql = "SELECT id FROM #__jc_orders	WHERE id = '$order_id' and email = '$email'";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadResult();
		return $result;
	}

	function sendOrderDetails($user_id, $order_id, $result_pay)
	{
		if ($result = $this->getBuyerProducts($user_id, $order_id))
		{
			$session = &JFactory::getSession();
			
			if ($user_id)
				$sql = "SELECT email FROM #__users WHERE id = '$user_id'";
			else
				$sql = "SELECT email FROM #__jc_orders WHERE id='$order_id'";
			$this->_db->setQuery($sql);
			$email = $this->_db->loadResult();
			
			$core = getCore();
			
			$products = '<table width="100%" border="1" cellpadding="2" cellspacing="0">';
			$products .= '<tr>
				<td><b>' . JText::_('Item') . ' (' . JText::_('Amount') . ')</b></td>
				<td><b>' . JText::_('Paid') . '</b></td>';
			if (COMM_SHOW_MISC)
				$products .= '<td><b>' . JText::_('Misc info') . '</b></td>';
			$products .= '</tr>';
			foreach($result as $res)
			{
				if ($res->product_id)
				{
					$record = $this->getArticleInfo($res->product_id);
					$price = $res->price * $res->amount + $res->tax - $res->discount;
					$price = str_replace(array('00', 'Sign'), array($price, $core->mark), COMM_LAYOUT_PRICE);
					$extra = $this->getProductEmailAlert($res->product_id);
					$products .= '<tr><td>' . $record->title . ' (' . $res->amount . ')</td><td>' . $price . '</td>';
					if (COMM_SHOW_MISC)
						$products .= '<td>' . $extra . '&nbsp;</td>';
					$products .= '</tr>';
				}
				else
				{
					$item_ship = new JParameter($res->extra);
					if ($item_ship = $item_ship->get('shipping'))
					{
						$item_ship = unserialize($item_ship);
						$seller = JFactory::getUser($res->seller_id);
						$ship = explode('::', $item_ship['info']);
						$price = str_replace(array('00', 'Sign'), array($item_ship['sum'], $core->mark), COMM_LAYOUT_PRICE);
						$title = JText::_('Products delivery from vendor') . ' ' . $seller->name . ' (' . $ship[0] . ', ' . $ship[1] . '; ' . JText::_('weight') . ': ' . $item_ship['weight'] . ' ' . JText::_('kg') . ')';
						$products .= '<tr><td>' . $title . '</td><td>' . $price . '</td>';
						if (COMM_SHOW_MISC)
							$products .= '<td>&nbsp;</td>';
						$products .= '</tr>';
					}
				}
			}
			
			$products .= '</table>';
			
			$config = JFactory::getConfig();
			jimport('joomla.mail.mail');
			jimport('joomla.mail.helper');
			
			$body = JText::_('CUSTOMER_ALERT');
			
			if ($user_id)
			{
				$client = JFactory::getUser($user_id);
				$body = str_replace('[USER]', $client->name, $body);
			}
			else
				$body = str_replace('[USER]', '', $body);
			
			$body = str_replace('[ORDER_ID]', $order_id, $body);
			$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
			$body = str_replace('[SITE_URL]', JHTML::link(JURI::root(), JURI::root()), $body);
			$body = str_replace('[PRODUCTS]', $products, $body);
			$order_link = JURI::root() . 'index.php?option=com_commerce&view=orders&layout=details&id=' . $order_id . '&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PURCHASEHIST_ITEMID != '') ? COMM_PURCHASEHIST_ITEMID : JRequest::getInt('Itemid'));
			$body = str_replace('[ORDER_LINK]', JHTML::link($order_link, $order_link), $body);
			
			$history_link = JURI::root() . 'index.php?option=com_commerce&view=orders&layout=purchase&order_id=' . $order_id . '&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid'));
			$history =  JHTML::link($history_link, $history_link);
			if($result_pay == 'offline')
			{
				$off_link = JURI::root() . 'index.php?option=com_commerce&view=orders&layout=alert&order_id=' . $order_id . '&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid'));
				$offline_alert = str_replace('[LINK]', $off_link, JText::_('OFFLINE_ALERT'));
				$history .= "\n\n".$offline_alert;
			}
			$body = str_replace('[HISTORY_LINK]',$history, $body);
			
			
			$to = '';
			
			if ($shipping = $session->get('shipping' . COMM_SECTION_ID))
			{
				$ship_price = str_replace(array('00', 'Sign'), array(($shipping->sum ? $shipping->sum : $shipping->entered_sum), $core->mark), COMM_LAYOUT_PRICE);
				if ($shipping->weight)
				{
					$to .= JText::_('Order weight') . ': ' . $shipping->weight . ' ' . JText::_('kg') . ".\n\n";
				}
				$to .= JText::_('Selected shipping method') . ': ' . $shipping->name . " ($ship_price).\n\n";
			}
			if ($user_id && $address = $session->get('address'))
			{
				$sql = "SELECT name, address, city, state, country, zip, tel FROM #__jc_users_addresses WHERE id = '{$address['bill']}'";
				$this->_db->setQuery($sql);
				$bill = $this->_db->loadObject();
				
				if (intval($bill->country))
					$bill->country = $this->getLocationData('country', $bill->country);
				if (intval($bill->city))
					$bill->city = $this->getLocationData('city', $bill->city);
				if (intval($bill->state))
					$bill->state = $this->getLocationData('district', $bill->state);
				
				$to .= JText::_('Bill To information') . ": \n ";
				$to .= JText::_('Name') . ': ' . $bill->name . " \n ";
				$to .= JText::_('Email') . ': ' . $email . " \n ";
				$to .= JText::_('Address') . ': ' . $bill->address . " \n ";
				$to .= JText::_('Country') . ': ' . $bill->country . " \n ";
				$to .= JText::_('City') . ': ' . $bill->city . " \n ";
				$to .= JText::_('Discrict') . ': ' . $bill->state . " \n ";
				$to .= JText::_('Zip') . ': ' . $bill->zip . " \n ";
				$to .= JText::_('Tel') . ': ' . $bill->tel . " \n";
				
				if (isset($address['ship']) && $address['ship'] != '')
				{
					$sql = "SELECT name, address, city, state, country, zip, tel FROM #__jc_users_addresses WHERE id = '{$address['ship']}'";
					$this->_db->setQuery($sql);
					$ship = $this->_db->loadObject();
					
					if (intval($ship->country))
						$ship->country = $this->getLocationData('country', $ship->country);
					if (intval($ship->city))
						$ship->city = $this->getLocationData('city', $ship->city);
					if (intval($ship->state))
						$ship->state = $this->getLocationData('district', $ship->state);
					
					$to .= " \n" . JText::_('Ship To information') . ": \n ";
					$to .= JText::_('Name') . ': ' . $ship->name . " \n ";
					$to .= JText::_('Address') . ': ' . $ship->address . " \n ";
					$to .= JText::_('Country') . ': ' . $ship->country . " \n ";
					$to .= JText::_('City') . ': ' . $ship->city . " \n ";
					$to .= JText::_('Discrict') . ': ' . $ship->state . " \n ";
					$to .= JText::_('Zip') . ': ' . $ship->zip . " \n ";
					$to .= JText::_('Tel') . ': ' . $ship->tel . " \n";
				}
			}
			if (!$user_id && $unreg_bill = $session->get('unreg_address[bill]'))
			{
				
				if (intval($unreg_bill['country']))
					$unreg_bill['country'] = $this->getLocationData('country', $unreg_bill['country']);
				if (intval($unreg_bill['city']))
					$unreg_bill['city'] = $this->getLocationData('city', $unreg_bill['city']);
				if (intval($unreg_bill['state']))
					$unreg_bill['state'] = $this->getLocationData('district', $unreg_bill['state']);
				
				$to .= JText::_('Bill To information') . ": \n ";
				$to .= JText::_('Name') . ': ' . $unreg_bill['name'] . " \n ";
				$to .= JText::_('Email') . ': ' . $email . " \n ";
				$to .= JText::_('Address') . ': ' . $unreg_bill['address'] . " \n ";
				$to .= JText::_('Country') . ': ' . $unreg_bill['country'] . " \n ";
				$to .= JText::_('City') . ': ' . $unreg_bill['city'] . " \n ";
				$to .= JText::_('Discrict') . ': ' . $unreg_bill['state'] . " \n ";
				$to .= JText::_('Zip') . ': ' . $unreg_bill['zip'] . " \n ";
				$to .= JText::_('Tel') . ': ' . $unreg_bill['tel'] . " \n";
				if ($unreg_ship = $session->get('unreg_address[ship]'))
				{
					if (intval($unreg_ship['country']))
						$unreg_ship['country'] = $this->getLocationData('country', $unreg_ship['country']);
					if (intval($unreg_ship['city']))
						$unreg_ship['city'] = $this->getLocationData('city', $unreg_ship['city']);
					if (intval($unreg_ship['state']))
						$unreg_ship['state'] = $this->getLocationData('district', $unreg_ship['state']);
					
					$to .= " \n" . JText::_('Ship To information') . ": \n ";
					$to .= JText::_('Name') . ': ' . $unreg_ship['name'] . " \n ";
					$to .= JText::_('Address') . ': ' . $unreg_ship['address'] . " \n ";
					$to .= JText::_('Country') . ': ' . $unreg_ship['country'] . " \n ";
					$to .= JText::_('City') . ': ' . $unreg_ship['city'] . " \n ";
					$to .= JText::_('Discrict') . ': ' . $unreg_ship['state'] . " \n ";
					$to .= JText::_('Zip') . ': ' . $unreg_ship['zip'] . " \n ";
					$to .= JText::_('Tel') . ': ' . $unreg_ship['tel'] . " \n";
				}
			}
			$body = str_replace('[ADDRESS]', $to, $body);
			
			
			$subject = JText::_("CUSTOMER_ALERT_SUBJECT");
			$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);
			
			$sender[0] = $config->getValue('config.mailfrom');
			$sender[1] = $config->getValue('config.fromname');
			
			$mail = JFactory::getMailer();
			
			$mail->setSender($sender);
			$mail->AddAddress($email);
			if (JString::strlen($body) != JString::strlen(strip_tags($body)))
			{
				$body = str_replace("\n", '<br>', $body);
				$mail->IsHTML(true);
			}
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));
			
			$mail->Send();
			
			// seller(s) alert
			if (COMM_MULTI_SELLER)
			{
				$sellers = $this->getOrderSellers($order_id, COMM_SECTION_ID);
			}
			
			$subject = JText::_("VENDOR_ALERT_SUBJECT");
			$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);
			
			$body = JText::_('VENDOR_ALERT');
			$body = str_replace('[ORDER_ID]', $order_id, $body);
			$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
			$body = str_replace('[SITE_URL]', JHTML::link(JURI::root(), JURI::root()), $body);
			$history_link = JURI::root() . 'index.php?option=com_commerce&view=orders&order_id=' . $order_id . '&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid'));
			$body = str_replace('[ORDER_LINK]', JHTML::link($history_link, $history_link), $body);
			
			$body = str_replace('[ADDRESS]', $to, $body);
			
			// send order email to vendor
			$mail->ClearAllRecipients();
			$mail->setSender($sender);
			
			$mail->IsHTML(false);
			
			if (JString::strlen($body) != JString::strlen(strip_tags($body)))
			{
				$body = nl2br($body);
				$mail->IsHTML(true);
			}
			
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));
			
			foreach($sellers as $seller)
			{
				$mail->ClearAllRecipients();
				$mail->addRecipient($seller);
				$mail->Send();
			}
			
			if (COMM_PAYMENT_METHOD == 'global')
			{
				$owner = JFactory::getUser(COMM_OWNER);
				if (!in_array($owner->email, $sellers))
				{
					$subject = JText::_("OWNER_ALERT_SUBJECT");
					$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);
					
					$body = JText::_('OWNER_ALERT');
					$body = str_replace('[ORDER_ID]', $order_id, $body);
					$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
					$body = str_replace('[SITE_URL]', JHTML::link(JURI::root(), JURI::root()), $body);
					$history_link = JURI::root() . 'administrator/com_commerce&controller=orders&layout=details&cid[]=' . $order_id . '&section_id=' . COMM_SECTION_ID;
					$body = str_replace('[ORDER_LINK]', JHTML::link($history_link, $history_link), $body);
					
					// send order email to vendor
					$mail->ClearAllRecipients();
					$mail->setSender($sender);
					
					$mail->IsHTML(false);
					
					if (JString::strlen($body) != JString::strlen(strip_tags($body)))
					{
						$body = nl2br($body);
						$mail->IsHTML(true);
					}
					
					$mail->setBody(JMailHelper::cleanBody($body));
					$mail->setSubject(JMailHelper::cleanSubject($subject));
					
					$mail->ClearAllRecipients();
					$mail->addRecipient($owner->email);
					$mail->Send();
				}
			}
		
		}
	}

	function getLocationData($type, $id)
	{
		switch ($type)
		{
			case 'country' :
				$query = "SELECT name FROM #__jc_countries WHERE id = '$id'";
				break;
			case 'city' :
				$query = "SELECT name FROM #__jc_location WHERE id = '$id'";
				break;
			case 'district' :
				$query = "SELECT name FROM #__jc_location WHERE id = '$id'";
				break;
		}
		$this->_db->setQuery($query); //echo $this->_db->_sql;
		return $this->_db->loadResult();
	}

	function getProductEmailAlert($rid)
	{
		$sql = "SELECT rv.field_value FROM #__js_res_record_values rv
		JOIN #__js_res_fields f ON f.id = rv.field_id
		WHERE rv.record_id = '$rid' AND f.type = 'email_alert'";
		$this->_db->setQuery($sql);
		$res = $this->_db->loadResultArray();
		return implode("<br>", $res);
	}

	function getOrderSellers($order_id)
	{
		$sql = "SELECT u.email FROM #__jc_orders_products op
		JOIN #__users u ON u.id = op.seller_id
		WHERE op.order_id = '$order_id'
		GROUP BY u.email";
		$this->_db->setQuery($sql);
		return $this->_db->loadResultArray();
	}

	function sendUserAlert($user_id, $status_id, $order_id)
	{
		$db = JFactory::getDBO();
		if ($user_id)
			$user = JFactory::getUser($user_id);
		else
			$user = JFactory::getUser();
		$sql = "SELECT name, user_alert as body, type FROM #__jc_orders_statuses WHERE id = '$status_id'";
		$db->setQuery($sql);
		$status = $db->loadObject();
		if ($status->body != '')
		{
			$config = JFactory::getConfig();
			jimport('joomla.mail.mail');
			jimport('joomla.mail.helper');
			if ($status->type == 'order')
				$subject = JText::_("Your order is [STATUS] on [SITE_NAME]");
			else
				$subject = JText::_("Product status was changed to [STATUS] on [SITE_NAME]");
			$subject = str_replace('[STATUS]', JText::_($status->name), $subject);
			$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);
			$sender[0] = $config->getValue('config.mailfrom');
			$sender[1] = $config->getValue('config.fromname');
			
			$mail = JFactory::getMailer();
			$body = $status->body;
			$body = str_replace('{NAME}', ($user_id ? $user->get('name') : JText::_('Customer')), $body);
			$body = str_replace('{ORDER_ID}', $order_id, $body);
			$body = str_replace('{ORDER_URL}', JURI::root() . 'index.php?option=com_commerce&view=orders&layout=purchase&order_id=' . $order_id . '&section_id=' . COMM_SECTION_ID . '&Itemid=' . (COMM_PRODUCTLIST_ITEMID ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid')), $body);
			$body = str_replace('{SITE}', $config->getValue('config.sitename') . " " . JURI::root(), $body);
			$body = str_replace('{SITE_URL}', JURI::root(), $body);
			$mail->setSender($sender);
			if ($user_id)
			{
				$email_send = $user->get('email');
			}
			else
			{
				$sql = "SELECT email FROM #__jc_orders WHERE id = '$order_id'";
				$db->setQuery($sql);
				$email_send = $db->loadResult();
			}
			$mail->AddAddress($email_send);
			if (JString::strlen($body) != JString::strlen(strip_tags($body)))
				$mail->IsHTML(true);
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));
			if (!$mail->Send())
			{
				JError::raiseWarning(200, 'Error to send user alert');
				return;
			}
		}
		return true;
	}

	function getCommercialSections($default)
	{
		$db = & JFactory::getDBO();
		require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helper.php');
		$sql = "SELECT id, name FROM #__js_res_category WHERE parent = '0' AND published = '1' ORDER BY ordering, id";
		$db->setQuery($sql);
		$res = $db->loadObjectList();
		$options = array();
		if (count($res) > 0)
		{
			foreach($res as $val)
			{
				$CP = ResHelper::getSectionParams($val->id);
				if ($CP->get('comm_enabled'))
					$options[] = JHTML::_('select.option', $val->id, $val->name);
			}
		}
		$html = JHTML::_('select.genericlist', $options, "filter_section", 'class="inputbox"
		onchange="this.form.section_id.value=this.value; this.form.task.value=\'change_section\'; this.form.submit();"', 'value', 'text', $default);
		
		return $html;
	}

	// Order INVOICES
	function getInvoiceNumber($client, $user_id, $order_id)
	{
		if ($client)
		{
			$sql = "SELECT COUNT(*) FROM #__jc_orders ord
		JOIN #__jc_orders_products pr ON pr.order_id = ord.id
		WHERE " . ((COMM_PAYMENT_METHOD == 'personal' && COMM_MULTI_SELLER) ? "pr.seller_id = '$user_id' AND" : '') . " ord.id <= $order_id";
		}
		else
			$sql = "SELECT COUNT(*) FROM #__jc_orders
		WHERE " . ((COMM_PAYMENT_METHOD == 'personal' && COMM_MULTI_SELLER) ? "user_id = '$user_id' AND" : '') . " id <= $order_id";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getBillInvoiceParams($id)
	{
		$sql = "SELECT params FROM #__bills_invoice WHERE id = '$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getOrderStatuses()
	{
		$sql = "SELECT id, name FROM #__jc_orders_statuses WHERE type = 'order' ORDER BY id";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getStatusInfo($id)
	{
		$sql = "SELECT id, name FROM #__jc_orders_statuses WHERE id = '$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getCommission($oid)
	{
		$sql = "SELECT commision as procent, transaction FROM #__jc_users_balance WHERE type = 'order' and order_id = '$oid'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getArticleInfo($id)
	{
		$sql = "SELECT * FROM #__js_res_record WHERE id='$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getOrderInfo($id)
	{
		$sql = "SELECT * FROM #__jc_orders WHERE id='$id'";
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function sendPositiveBalanceAlert($seller_id)
	{
		$config = JFactory::getConfig();
		jimport('joomla.mail.mail');
		jimport('joomla.mail.helper');
		
		$mail = JFactory::getMailer();
		$seller = JFactory::getUser($seller_id);
		$owner = JFactory::getUser(COMM_OWNER);
		
		$subject = JText::_("POSITIVE_BALANCE_ALERT_SUBJECT");
		$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);
		
		$body = JText::_("POSITIVE_BALANCE_ALERT");
		$body = str_replace('[SELLER]', $seller->name.' ['.$seller_id.']', $body);
		$link = JURI::root().'administrator/index.php?option=com_commerce&controller=usersbalance&section_id='.COMM_SECTION_ID.'&search_balance='.$seller->username;
		$body = str_replace('[LINK]', JHTML::link($link, $link), $body);
		
		$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
		$body = str_replace('[SITE_URL]', JHTML::link(JURI::root(), JURI::root()), $body);			
			
		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');
				
		$mail->setSender($sender);
		$mail->AddAddress($owner->email);
		
		if (JString::strlen($body) != JString::strlen(strip_tags($body)))
		{
			$body = str_replace("\n", '<br>', $body);
			$mail->IsHTML(true);
		}
		$mail->setBody(JMailHelper::cleanBody($body));
		$mail->setSubject(JMailHelper::cleanSubject($subject));
		
		$mail->Send();
	}

}

?>