<?php
/**
 * $Id: router.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

function CommerceBuildRoute( &$query )
{
	$segments = array();

	switch(@$query['view'])
	{
		case 'cart':
		case 'cpanel':
		case 'userconfig':
		case 'currency':
		case 'tax':
		case 'coupon':
		case 'shipping':
			$segments[0] = @$query['view'];
			if(isset($query['section_id']))
			$segments[1] = $query['section_id'].'-section';
			else
			{
				if(JRequest::getInt('section_id'))
				$segments[1] = JRequest::getInt('section_id').'-section';
			}
			unset( $query['view'] );
			unset( $query['section_id'] );

			if( isset( $query['task'] ) )
			{
				$segments[2] = $query['task'];
				unset( $query['task'] );
			}
			if( isset( $query['cid'] ) )
			{
				$segments[3] = $query['cid'][0];
				unset( $query['cid'] );
			}
			break;

		case 'balance':
			$segments[0] = @$query['view'];
			if(isset($query['section_id']))
			$segments[1] = $query['section_id'].'-section';
			else
			{
				if(JRequest::getInt('section_id'))
				$segments[1] = JRequest::getInt('section_id').'-section';
			}
			unset( $query['view'] );
			unset( $query['section_id'] );

			if( isset( $query['layout'] ) )
			{
				$segments[2] = $query['layout'];
				unset( $query['layout'] );
			}
			if( isset( $query['task'] ) )
			{
				$segments[3] = $query['task'];
				unset( $query['task'] );
			}
			break;

		case 'carttemplate':
			$segments[0] = @$query['view'];
			if(isset($query['section_id']))
			$segments[1] = $query['section_id'].'-section';
			else
			{
				if(JRequest::getInt('section_id'))
				$segments[1] = JRequest::getInt('section_id').'-section';
			}
			unset( $query['view'] );
			unset( $query['section_id'] );

			if( isset( $query['layout'] ) )
			{
				$segments[2] = $query['layout'];
				unset( $query['layout'] );
			}

			if( isset( $query['user_id'] ) )
			{
				$segments[2] = $query['user_id'];
				unset( $query['user_id'] );
			}

			if( isset( $query['cid'] ) )
			{
				$segments[3] = $query['cid'][0];
				unset( $query['cid'] );
			}

			if( isset( $query['id'] ) )
			{
				$segments[3] = $query['id'];
				unset( $query['id'] );
			}


			if( isset( $query['task'] ) )
			{
				$segments[4] = $query['task'];
				unset( $query['task'] );
			}
			break;

		case 'orders':
			$segments[0] = @$query['view'];
			$segments[1] = $query['section_id'].'-section';
			unset( $query['view'] );
			unset( $query['section_id'] );
			if(!isset($query['layout']))
			{
				$segments[2] = 'default';
			}
			else
			$segments[2] = $query['layout'];
			unset( $query['layout'] );

			if( isset($query['order_id']) )
			{
				$segments[3] = $query['order_id'].'-order';
				unset( $query['order_id'] );
			}
			break;

		case 'shippingitem':
			$segments[0] = @$query['view'];
			$segments[1] = $query['section_id'].'-section';
			unset( $query['view'] );
			unset( $query['section_id'] );

			if( isset( $query['task'] ) )
			{
				$segments[2] = $query['task'];
				unset( $query['task'] );
			}
			else
			{
				$segments[2] = $query['frwrd_id'].'-method';
			}

			if( isset( $query['cid'] ) )
			{
				$segments[3] = $query['cid'][0];
				unset( $query['cid'] );

				$segments[4] = $query['frwrd_id'].'-method';
			}
			unset( $query['frwrd_id'] );

			break;
	}
	return $segments;
}

/**
 * @param	array
 * @return	array
 */
function CommerceParseRoute( $segments )
{
	$vars = array();

	$vars['view'] = $segments[0];
	if(isset($segments[1]))
	{
		$vars['section_id'] = (int)$segments[1];
	}

	switch( $segments[0] )
	{
		case 'cart':
		case 'cpanel':
		case 'userconfig':
		case 'currency':
		case 'tax':
		case 'coupon':
		case 'shipping':
			if( isset( $segments[2] ) )
			{
				$vars['task'] = $segments[2];
			}
			if( isset( $segments[3] ) )
			{
				$vars['cid'][] = $segments[3];
			}
			break;

		case 'balance':
			if( isset( $segments[2] ) )
			{
				$vars['layout'] = $segments[2];
			}
			if( isset( $segments[3] ) )
			{
				$vars['task'] = $segments[3];
			}
			break;

		case 'orders':
			$vars['layout'] = $segments[2] ;
			if( isset($segments[3]) )
			{
				$vars['order_id'] = (int)$segments[3];
			}
			break;

		case 'shippingitem':
			if( isset( $segments[2] ) )
			{
				if(strstr($segments[2], 'method'))
				{
					$vars['frwrd_id'] = (int)$segments[2];
				}
				else
				$vars['task'] = $segments[2];
			}

			if( isset( $segments[3] ) )
			{
				$vars['cid'][] = $segments[3];

				if( isset($segments[4]) )
				{
					$vars['frwrd_id'] = (int)$segments[4];
				}
			}
			break;

		case 'carttemplate':
			if( isset( $segments[2] ) )
			{
				if( intval($segments[2]) )
				{
					$vars['user_id'] = $segments[2] ;
				}
				else
				$vars['layout'] = $segments[2] ;				
			}
			if( isset($vars['layout']) && isset( $segments[3] ) )
			{
				if($vars['layout'] == 'form')
				{
					$vars['cid'][] = $segments[3];
				}
				else
				$vars['id'] = $segments[3];
			}

			if( isset( $segments[4] )  )
			{
				$vars['task'] = $segments[3];
			}
			break;

	}

	return $vars;
}

?>