<?php
/**
 * $Id: view.html.php 8018 2012-04-09 04:08:33Z alfiya $
 * $LastChangedDate: 2012-04-09 10:08:33 +0600 (Mon, 09 Apr 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.view');
class CommerceViewCart extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $ICONS, $comm_params;
		
		$layout = $this->getLayout();
		$model = & $this->getModel('cart');
		$user = & JFactory::getUser();
		$db = & JFactory::getDBO();
		$Itemid = JRequest::getInt('Itemid');
		$option = JRequest::getWord('option', 'com_commerce');
		$uri = JFactory::getURI();
		$uri->delVar('cart_item_remove');
		$uri->delVar('clear');
		$model_order = JModel::getInstance('Orders', 'CommerceModel');
		
		$title = JText::_('My cart');
		$pathway = & $mainframe->getPathway();
		$pathway->addItem($title, '');
		
		$clear = JRequest::getInt('clear');
		
		$menus = &JSite::getMenu();
		$menu = $menus->getActive();
		$menu_params = new JParameter($menu->params);
		
		// because the application sets a default page title, we need to get it
		// right from the menu item itself
		$params = &$mainframe->getParams();
		$document = &JFactory::getDocument();
		$dispatcher = & JDispatcher::getInstance();
		
		$session = & JFactory::getSession();
		
		$context = "$option.view_cart";
		$filter_section = $mainframe->getUserStateFromRequest("$context.filter_section", 'filter_section', COMM_SECTION_ID);
		$filter['section'] = $model_order->getCommercialSections(COMM_SECTION_ID);
		
		$cart = $session->get('my_cart-' . COMM_SECTION_ID);
		$cart_coupon = $session->get('my_cart_coupon-' . COMM_SECTION_ID);
		$shipping = $session->get('shipping-' . COMM_SECTION_ID);
		$coupon = $model->getCouponDiscount($cart_coupon);
		
		$count = 0;
		
		$address = $session->get('address');
		if (!isset($address))
		{
			if ($user->id)
			{
				$bill_addresses = $model->getAddresses('bill');
				$ship_addresses = $model->getAddresses('ship');
				$address['bill'] = count($bill_addresses) ? $bill_addresses[0]->id : 0;
				$address['ship'] = count($ship_addresses) ? $ship_addresses[0]->id : 0;
			}
			else
				$address['bill'] = $address['ship'] = 0;
			$session->set('address', $address);
		}
		$unreg = $session->get('unreg_address');
		
		$bill_country = false;
		if ($address || $unreg)
		{
			$bill_info = $user->id ? $model->getAddresses('bill', $address['bill']) : $unreg['bill'];
			$bill_country = (is_object($bill_info)) ? $bill_info->country : $bill_info['country'];
		}
		
		// cart clear
		if ($clear)
		{
			$sql = "UPDATE #__jc_orders SET status_id = (SELECT id FROM jos_jc_orders_statuses WHERE name REGEXP 'pending' AND type='order'), pay = 'inquire', gateway = 'inquired' WHERE id = '" . JRequest::getInt('order_id') . "'";
			$db->setQuery($sql);
			$db->query();
			$sql = "UPDATE #__jc_orders_products SET
			status_id = (IF (price > 0, (SELECT id FROM jos_jc_orders_statuses WHERE name REGEXP 'inquired'), (SELECT id FROM jos_jc_orders_statuses WHERE isfinal = '1' AND type='product')))
			WHERE order_id = '" . JRequest::getInt('order_id') . "'";
			$db->setQuery($sql);
			$db->query();
			$session->clear('my_cart' . '-' . COMM_SECTION_ID);
			if ($cart_coupon)
				$session->clear('my_cart_coupon' . '-' . COMM_SECTION_ID);
			if ($address)
				$session->clear('address');
			$mainframe->redirect(JRoute::_("index.php?option=com_commerce&view=orders&layout=purchase&section_id=" . COMM_SECTION_ID . "&Itemid=" . (COMM_PRODUCTLIST_ITEMID != '' ? COMM_PRODUCTLIST_ITEMID : $Itemid), false));
		}
		
		// removing item from cart
		if ($remove_id = JRequest::getVar('cart_item_remove'))
		{
			$remove_id = explode('::', $remove_id);
			$seller_id = $remove_id[0];
			$item_id = $remove_id[1];
			unset($cart[$seller_id][$item_id]);
			if (!count($cart[$seller_id]))
				unset($cart[$seller_id]);
			foreach($cart[$seller_id] as $k => $item)
			{
				if (isset($item->suite_discount))
					unset($cart[$seller_id][$k]->suite_discount);
			}
			$session->set('my_cart' . '-' . COMM_SECTION_ID, $cart);
			$session->clear('my_cart_coupon' . '-' . COMM_SECTION_ID);
			$session->clear('cart_simple_discount' . '-' . COMM_SECTION_ID);
			$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . (COMM_CART_ITEMID ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
			$link = JRoute::_($link, false);
			if ($return = JRequest::getVar('return'))
				$link = base64_decode(JRoute::_($return, false));
			$link = str_replace('index2.php', 'index.php', $link);
			$mainframe->redirect($link, JText::_('Item is removed from your cart'));
		}
		
		$document->addScript(JURI::root() . 'components/com_commerce/js/felix_js/library.js');
		$document->addScript(JURI::root() . 'components/com_commerce/js/felix_js/pop_up.js');
		$document->addScriptDeclaration("var commerce_popUp = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );");
		
		$istangible = 0;
		$rids = array();
		$order = 0;
		$sum = array();
		$discount_sum = array();
		$total_sum = array();
		$list = array();
		$core = getCore();
		$mark_core = $core->mark;
		if (count($cart) > 0)
		{			
			foreach($cart as $seller_id => $items)
			{
				//$count += count($items);
				$sum[$seller_id] = 0;
				$discount_sum[$seller_id] = 0;
				$total_sum[$seller_id] = 0;
				$list[$seller_id]['weight'] = 0;
				
				foreach($items as $k => $item)
				{
					$count += $item->items_num;
					$field = $model->getFieldValue($item->article);
					if ($field)
					{
						$price = $field->field_value;
						$price_ext = $model->getPriceExtra($field->field_id, $item->article);
						$currency = $model->getCurrencyInfo($field->field_id, $item->article);
						
						JPluginHelper::importPlugin('joomsuite_content_fields', 'price');
						$dispatcher->trigger('onGetItemPrice', array(&$price, $item->article, $item->items_num, 'user', false));
					}
					else
						$price = 0;
					
					$currency = (isset($price_ext->currency)) ? $price_ext->currency : false;
					$tax = (isset($price_ext->tax)) ? $price_ext->tax : false;
					$price = round($price, 2);
					
					$art_info = $model->getArticleInfo($item->article);
					//	$seller_id = $art_info->user_id;
					$category = ResHelper::getArticleSection($item->article);
					
					$rids[] = $item->article;
					
					// checking if the product has property
					$props = $model->getProductProperty($item->article);
					
					//	$list[$seller_id]['items'][$k]->items_num = $item->items_num;
					//$list[$seller_id]['items'][$k]->properties = '';
					$cart[$seller_id][$k]->properties = '';
					if ($props)
					{
						$property = '';
						$i = 0;
						foreach($props as $n => $prop)
						{
							//$prop->fid = $prop->rid."][".$i;
							$pfvalue = unserialize($prop->field_value);
							if (!count($pfvalue) || (count($pfvalue) && isset($pfvalue['rent']) && $pfvalue['rent'] == ''))
							{
								continue;
							}
							$prop->fid = $seller_id . '][' . $k . "][" . $i;
							$prop->fid_num = $k;
							
							if (isset($item->property))
							{
								$default = array();
								if (isset($item->property[$i]) && $item->property[$i] != '')
								{
									if (count($item->property[$i]) > 1)
									{
										foreach($item->property[$i] as $p => $pr_prop)
										{
											$default[] = $pr_prop['value'] . "__PROD_PROP__" . $pr_prop['price'];
										}
									}
									else
										$default = $item->property[$i][0]['value'] . "__PROD_PROP__" . $item->property[$i][0]['price'];
								
								}
								$prop->default_values['property'] = $default; //$item->property[$i]['value']."__PROD_PROP__".$item->property[$i]['price'];
							}
							else
								$prop->default_values['property'] = '';
							
							$prop->record_id = $item->article;
							
							JPluginHelper::importPlugin('joomsuite_content_fields', $prop->type);
							$pluginParams = new JParameter($prop->params);
							$out = '';
							$property .= '<tr valign="top">';
							$dispatcher->trigger('onRenderFieldValue', array(&$out, &$prop, &$art_info, $category));
							if ($out != '')
							{
								$out .= '<input type="hidden" name="fields[' . $prop->fid . '][prop_id]" value="' . $prop->id . '">';
								if ($pluginParams->get('require_before_order'))
								{
									$property .= '<td width="1%" nowrap>* ' . JText::_("Required before order") . "</td>";
								}
								$property .= '<td colspan="' . ($pluginParams->get('require_before_order') ? 1 : 2) . '" valign="top">' . $out . '</td></tr>';
							}
							
							$i ++;
						}
						if ($property != '')
						{
							$cart[$seller_id][$k]->properties = "<table>" . $property . "</table>";
						
		//$list[$seller_id]['items'][$k]->properties = "<table>" . $property . "</table>";
						}
					}
					
					$cart[$seller_id][$k]->title = $art_info->title;
					//$list[$seller_id]['items'][$k]->title = $art_info->title;
					if ($field)
					{
						$field_params = new JParameter($field->params);
						if (!$field_params->get('use_tax'))
						{
							$tax = 0;
						}
						
						if (isset($item->property) && $item->property != '')
						{
							foreach($item->property as $property)
							{
								foreach($property as $prop)
								{
									if (isset($prop['price']))
									{
										$price += isset($prop['with_discount']) ? floatval($prop['with_discount']) : floatval($prop['price']);
									}
								}
							}
						}
					}
					
					$price_core = ($currency) ? round($price / $currency->rate, 2) : $price;
					
					if (!$currency)
						$currency = $core;
					
					$mark = ($currency->mark ? $currency->mark : $core->mark);
					
					$total = $price_core * $item->items_num;
					$cart[$seller_id][$k]->tax = 0;
					//$list[$seller_id]['items'][$k]->tax = 0;
					if ($tax)
					{
						if ($tax->country == '')
							$cart[$seller_id][$k]->tax = $tax->rate;
						
		//$list[$seller_id]['items'][$k]->tax = $tax->rate;
						else
						{
							$tax_countries = explode("|", $tax->country);
							if ($bill_country && in_array($bill_country, $tax_countries))
								$cart[$seller_id][$k]->tax = $tax->rate;
						
		//$list[$seller_id]['items'][$k]->tax = $tax->rate;
						}
					}
					
					//$total_tax = $total + round(($total * $list[$seller_id]['items'][$k]->tax / 100), 2);
					$total_tax = $total + round(($total * $cart[$seller_id][$k]->tax / 100), 2);
					
					$cart[$seller_id][$k]->discount = 0;
					//$list[$seller_id]['items'][$k]->discount = 0;
					if (isset($item->suite_discount))
					{
						$discount = round($total_tax * $item->suite_discount / 100, 2);
						$cart[$seller_id][$k]->discount += $discount;
						//$list[$seller_id]['items'][$k]->discount += $discount;
						$total_tax -= $discount;
						$discount_sum[$seller_id] += $discount;
					}
					
					if ($cart_coupon && (COMM_CART == 'cart' || COMM_CART == 'balance'))// && !$cart_coupon['core'])
					{
						if (COMM_MULTI_SELLER && COMM_MULTI_VENDOR)
						{
							if ($seller_id == $cart_coupon['seller_id'] || $cart_coupon['core'])
							{
								
								if ($coupon->type == 'procent')
								{
									$discount = round($total_tax * $coupon->discount / 100, 2);
								}
								else
								{
									if ($total_tax > $coupon->discount)
									{
										$discount = $coupon->discount;
									}
									else
									{
										$discount = $total_tax;
									}
									$coupon->discount -= $discount;
								
								}
								$total_tax -= $discount;
								if ($total_tax < 0)
								{
									$discount += $total_tax;
									$total_tax = 0;
								}
								$discount_sum[$seller_id] += $discount;
								$cart[$seller_id][$k]->discount += $discount;
							
							}
						}
						else
						{
							if ($coupon->type == 'procent')
							{
								$discount = round($total_tax * $coupon->discount / 100, 2);
							}
							else
							{
								if ($total_tax > $coupon->discount)
								{
									$discount = $coupon->discount;
								}
								else
								{
									$discount = $total_tax;
								}
								$coupon->discount -= $discount;
							}
							if ($total_tax < 0)
							{
								$discount += $total_tax;
								$total_tax = 0;
							}
							$discount_sum[$seller_id] += $discount;
							$cart[$seller_id][$k]->discount += $discount;
						
		//$list[$seller_id]['items'][$k]->discount += $discount;
						}
					}
					if ($cart[$seller_id][$k]->discount > 0)
					{
						$cart[$seller_id][$k]->discount = str_replace(array("00", "Sign"), array($cart[$seller_id][$k]->discount, $mark_core), COMM_LAYOUT_PRICE);
					}
					else
						$cart[$seller_id][$k]->discount = '';
						/*if ($list[$seller_id]['items'][$k]->discount > 0)
				{
					$list[$seller_id]['items'][$k]->discount = str_replace(array("00", "Sign"), array($list[$seller_id]['items'][$k]->discount, $mark_core), COMM_LAYOUT_PRICE);
				}
				else
					$list[$seller_id]['items'][$k]->discount = '';*/
					
					// MULTI TANGIBLE
					

					$list[$seller_id]['shipping_scheme'] = '';
					
					$cart[$seller_id][$k]->tangible = 0;
					//$list[$seller_id]['items'][$k]->tangible = 0;
					

					if (COMM_CART == 'cart' || COMM_CART == 'balance')
					{
						$tangible = $model->isTangible($item->article);
						if ($tangible && count($tangible))
						{
							$istangible = true;
							$tangible = $tangible[0];
							$cart[$seller_id][$k]->tangible = 1;
							//$list[$seller_id]['items'][$k]->tangible = 1;
							$tang = new JParameter($tangible->value);
							$fparams = new JParameter($tangible->params);
							
							if ($tang->get('weight_unit') && $tang->get('weight_unit') != 'kg')
							{
								$weight = $tang->get('weight');
								$weight_units = explode("\n", $fparams->get('weight_units'));
								foreach($weight_units as $unit)
								{
									$wu = $tang->get('weight_unit');
									if (strstr($unit, "$wu"))
									{
										$index = explode(":", $unit);
										$weight = $weight * $index[1];
									}
								}
							}
							else
							{
								$weight = $tang->get('weight');
							}
							$weight *= $item->items_num;
							$list[$seller_id]['weight'] += $weight;
							
						/*if ($address || isset($unreg['ship']))
						{
							//$list[$seller_id]['shipping_scheme'] = $model->getShippingMethodsForItem($k, (COMM_MULTI_SELLER ? $art_info->user_id : ''), (isset($item->shipping['id']) ? $item->shipping['id'] : ''), $weight);
							$list[$seller_id]['shipping_scheme'] = $model->getShippingMethodsFor((COMM_MULTI_SELLER ? $seller_id : ''), (isset($item->shipping['id']) ? $item->shipping['id'] : ''), $weight);
							
							if (!$list[$seller_id]['shipping_scheme'])
								$list[$seller_id]['shipping_scheme'] = JText::_("Shipping methods are not found. The order could not be delivered.") . "<br>";
						
						}
						
						if (isset($item->shipping['sum']))
							$total_tax += $item->shipping['sum'];*/
						
						}
					}
					// MULTI TANGIBLE ****************************
					

					$sum[$seller_id] += $total_tax;
					
					$cart[$seller_id][$k]->price = str_replace("00", ($price ? $price : 0), (isset($currency->format) ? $currency->format : COMM_LAYOUT_PRICE));
					$cart[$seller_id][$k]->price = str_replace("Sign", $mark, $cart[$seller_id][$k]->price);
					$cart[$seller_id][$k]->price_core = str_replace("00", ($price_core ? $price_core : 0), COMM_LAYOUT_PRICE);
					$cart[$seller_id][$k]->price_core = str_replace("Sign", $mark_core, $cart[$seller_id][$k]->price_core);
					$cart[$seller_id][$k]->total = str_replace("00", $total, COMM_LAYOUT_PRICE);
					$cart[$seller_id][$k]->total = str_replace("Sign", $mark_core, $cart[$seller_id][$k]->total);
					$cart[$seller_id][$k]->total_tax = str_replace("00", $total_tax, COMM_LAYOUT_PRICE);
					$cart[$seller_id][$k]->total_tax = str_replace("Sign", $mark_core, $cart[$seller_id][$k]->total_tax);
					//$cart[$seller_id][$k]->shipping['sum'] = str_replace(array("00", "Sign"), array($item->shipping['sum'], $core->mark), COMM_LAYOUT_PRICE);
					

					/*$list[$seller_id]['items'][$k]->price = str_replace("00", ($price ? $price : 0), (isset($currency->format) ? $currency->format : COMM_LAYOUT_PRICE));
				$list[$seller_id]['items'][$k]->price = str_replace("Sign", $mark, $list[$seller_id]['items'][$k]->price);
				$list[$seller_id]['items'][$k]->price_core = str_replace("00", ($price_core ? $price_core : 0), COMM_LAYOUT_PRICE);
				$list[$seller_id]['items'][$k]->price_core = str_replace("Sign", $mark_core, $list[$seller_id]['items'][$k]->price_core);
				$list[$seller_id]['items'][$k]->total = str_replace("00", $total, COMM_LAYOUT_PRICE);
				$list[$seller_id]['items'][$k]->total = str_replace("Sign", $mark_core, $list[$seller_id]['items'][$k]->total);
				$list[$seller_id]['items'][$k]->total_tax = str_replace("00", $total_tax, COMM_LAYOUT_PRICE);
				$list[$seller_id]['items'][$k]->total_tax = str_replace("Sign", $mark_core, $list[$seller_id]['items'][$k]->total_tax);
				//$list[$seller_id]['items'][$k]->shipping['sum'] = str_replace(array("00", "Sign"), array($item->shipping['sum'], $core->mark), COMM_LAYOUT_PRICE);
				*/
					
					//	$list[$seller_id]['items'][$k]->fields = '';
					$cart[$seller_id][$k]->fields = '';
					$fields_to_show = $model->getFieldsToShow($item->article);
					if ($fields_to_show)
					{
						foreach($fields_to_show as $field)
						{
							JPluginHelper::importPlugin('joomsuite_content_fields', $field->type);
							$pluginParams = new JParameter($field->params);
							$out = '';
							$dispatcher->trigger('onRenderFieldValue', array(&$out, &$field, &$art_info, $category));
							if ($out != '')
							{
								//$list[$seller_id]['items'][$k]->fields .= '<tr valign="top"><td width="20%"><b>' . $field->title . '</b></td><td>' . $out . "</td></tr>";
								$cart[$seller_id][$k]->fields .= '<tr valign="top"><td width="20%"><b>' . $field->title . '</b></td><td>' . $out . "</td></tr>";
							}
						}
					}
					/*if ($list[$seller_id]['items'][$k]->fields != '')
				{
					$list[$seller_id]['items'][$k]->fields = '<table width="100%">' . $list[$seller_id]['items'][$k]->fields . '</table>';
				}*/
					if ($cart[$seller_id][$k]->fields != '')
					{
						$cart[$seller_id][$k]->fields = '<table width="100%">' . $cart[$seller_id][$k]->fields . '</table>';
					}
					
					//$uri->setVar('cart_item_remove', $k + 1);
					$return = base64_encode(JRoute::_($uri->toString()));
					
					$cart[$seller_id][$k]->remove = '<a class="removeLink" href="javascript: void(0);"
					onClick=\'if(confirm("' . JText::_('Remove item?') . '")) { document.location = "'.JRoute::_('index.php?option=com_commerce&view=cart&section_id='.COMM_SECTION_ID. '&return=' . $return . '&cart_item_remove=' . $seller_id . '::' . $k, false).'" } \'>
					<img src="' . JURI::root() . 'components/com_commerce/images/remove.png" alt="' . JText::_('Remove') . '"></a>';
					/*$list[$seller_id]['items'][$k]->remove = '<a class="removeLink"
					onClick=\' if(confirm("' . JText::_('Remove item?') . '")) document.location.replace("' . JRoute::_($uri->toString(), false) . '");\'>
					<img src="' . JURI::root() . 'components/com_commerce/images/remove.png" alt="' . JText::_('Remove') . '"></a>';*/
				//$uri->delVar('cart_item_remove');
				}
			}
		}
		
		foreach($list as $seller => $item)
		{
			$total_sum[$seller] = $sum[$seller];
			/*if ($cart_coupon && (COMM_CART == 'cart' || COMM_CART == 'balance'))
			{
				if (!COMM_MULTI_SELLER || !COMM_MULTI_VENDOR || $cart_coupon['core'])
				{
					
					$discount_sum[$seller] += round(($coupon->type == 'sum') ? $coupon->discount : $sum[$seller] * $coupon->discount / 100, 2);
				}
			}*/
			
			if ($discount_sum[$seller] > 0)
			{
				if (!COMM_MULTI_SELLER || !COMM_MULTI_VENDOR || $cart_coupon['core'])
				{
					$total_sum[$seller] -= $discount_sum[$seller];
					if ($total_sum[$seller] < 0)
					{
						$discount_sum[$seller] += $total_sum[$seller];
						$total_sum[$seller] = 0;
					}
				}
				$discount_sum[$seller] = str_replace(array("00", "Sign"), array($discount_sum[$seller], $mark_core), COMM_LAYOUT_PRICE);
			}
			
			if ($item['weight'])
			{
				if ($address || isset($unreg['ship']))
				{
					//$list[$seller_id]['shipping_scheme'] = $model->getShippingMethodsForItem($k, (COMM_MULTI_SELLER ? $art_info->user_id : ''), (isset($item->shipping['id']) ? $item->shipping['id'] : ''), $weight);
					$list[$seller]['shipping_scheme'] = $model->getShippingMethods($seller, (isset($shipping[$seller]['id']) ? $shipping[$seller]['id'] : ''), $item['weight']);
					
					if (!$list[$seller]['shipping_scheme'])
						$list[$seller]['shipping_scheme'] = JText::_("Shipping methods are not found. The order could not be delivered.") . "<br>";
				
				}
				
				if (isset($shipping[$seller]))
				{
					$total_sum[$seller] += $shipping[$seller]['sum'];
					$shipping[$seller]['sum'] = str_replace(array("00", "Sign"), array($shipping[$seller]['sum'], $mark_core), COMM_LAYOUT_PRICE);
				}
			}
			$order += $total_sum[$seller];
			$sum[$seller] = str_replace(array("00", "Sign"), array($sum[$seller], $mark_core), COMM_LAYOUT_PRICE);
			$total_sum[$seller] = str_replace(array("00", "Sign"), array($total_sum[$seller], $mark_core), COMM_LAYOUT_PRICE);
		}
		if (count($sum))
			$core_discount = $model->getCoreDiscount(min($sum));
		
		$session->set('order_sum', $order);
		$order = str_replace(array("00", "Sign"), array($order, $mark_core), COMM_LAYOUT_PRICE);
		
		//if(!$session->get('cart_by_vendor' . '-' . COMM_SECTION_ID))
		//$session->set('cart_by_vendor' . '-' . COMM_SECTION_ID, $list);
		

		$this->assignRef('title', $title);
		$this->assignRef('count', $count);
		$this->assignRef('user', $user);
		$this->assignRef('items', $cart);
		$this->assignRef('order', $list);
		$this->assignRef('order_total', $order);
		$this->assignRef('uri', $uri->toString());
		$this->assignRef('sum', $sum);
		$this->assignRef('core_discount', $core_discount);
		$this->assignRef('shipping', $shipping);
		$this->assignRef('total_sum', $total_sum);
		$this->assignRef('discount_sum', $discount_sum);
		//$this->assignRef('cart_detail', $cart_detail);
		$this->assignRef('mark_core', $mark_core);
		
		$this->assign('tangible', $istangible);
		$this->assignRef('filter', $filter);
		
		$document->setTitle($params->get('page_title'));
		
		parent::display();
	}

	function _formAddress($tpl, $tangible)
	{
		$user = & JFactory::getUser();
		$model = & $this->getModel('cart');
		$session = & JFactory::getSession();
		$cart = $session->get('my_cart' . '-' . COMM_SECTION_ID);
		$address = $session->get('address');
		$countries = $model->getCommerceCountries();
		$opt = array();
		$opt[] = JHTML::_('select.option', 0, '- ' . JText::_("Change address") . ' -');
		
		$bill = array();
		$ship = array();
		$bill_addresses = array();
		$ship_addresses = array();
		$show_unr_bill = false;
		$show_unr_ship = false;
		$cur_bAdd = new stdClass();
		$cur_sAdd = new stdClass();
		
		$user->name = str_replace("\n",' ',$user->name);
		$user->name = str_replace("\r",' ',$user->name);
		$ship['name'] = $bill['name'] = ($user->id ? $user->name : '');
		$ship['address'] = $bill['address'] = (COMM_CUS_ADDRESS != -1 && $user->id) ? $model->getAssocValue(COMM_CUS_ADDRESS) : '';
		$ship['city'] = $bill['city'] = (COMM_CUS_CITY != -1 && $user->id) ? $model->getAssocValue(COMM_CUS_CITY) : '';
		$ship['state'] = $bill['state'] = (COMM_CUS_STATE != -1 && $user->id) ? $model->getAssocValue(COMM_CUS_STATE) : '';
		$ship['zip'] = $bill['zip'] = (COMM_CUS_ZIP != -1 && $user->id) ? $model->getAssocValue(COMM_CUS_ZIP) : '';
		$ship['country'] = $bill['country'] = (COMM_CUS_COUNTRY != -1 && $user->id) ? $model->getAssocValue(COMM_CUS_COUNTRY) : '';
		$ship['tel'] = $bill['tel'] = (COMM_CUS_TEL != -1 && $user->id) ? $model->getAssocValue(COMM_CUS_TEL) : '';
		
		if ($user->id)
		{
			$bill_addresses = $model->getAddresses('bill');
			$ship_addresses = $model->getAddresses('ship');
		}
		else
		{
			$unreg = $session->get("unreg_address");
			if (isset($unreg['bill']))
			{
				$show_unr_bill = true;
				$bill_addresses[] = $unreg['bill'];
				$bill_addresses[0]['id'] = 0;
				settype($bill_addresses[0], 'object');
			}
			if (isset($unreg['ship']))
			{
				$show_unr_ship = true;
				$ship_addresses[] = $unreg['ship'];
				$ship_addresses[0]['id'] = 0;
				settype($ship_addresses[0], 'object');
			}
		}
		$save = array();
		
		if (count($bill_addresses) > 0)
		{
			foreach($bill_addresses as $row)
			{
				settype($row, 'object');
				$val = array();
				
				/*if(intval($row->country)) $row->country = $model->getLocationData('country', $row->country);
				 if(intval($row->city)) $row->city = $model->getLocationData('city', $row->city);
				 if(intval($row->state)) $row->state = $model->getLocationData('district', $row->state);
				 */				if ($row->name)
					$val[] = $row->name;
				if ($row->country)
					$val[] = $row->country;
				if ($row->city)
					$val[] = $row->city;
				if ($row->state)
					$val[] = $row->state;
				if ($row->address)
					$val[] = $row->address;
				if ($row->zip)
					$val[] = $row->zip;
				if ($row->tel)
					$val[] = $row->tel;
				$opt[] = JHTML::_('select.option', $row->id, implode(", ", $val));
			}
			$cur_bAdd = (isset($address['bill']) && $address['bill'] != '') ? $model->getAddresses('bill', $address['bill']) : $bill_addresses[0];
			
			if (intval($cur_bAdd->country))
				$cur_bAdd->country = $model->getLocationData('country', $cur_bAdd->country);
			if (intval($cur_bAdd->city))
				$cur_bAdd->city = $model->getLocationData('city', $cur_bAdd->city);
			if (intval($cur_bAdd->state))
				$cur_bAdd->state = $model->getLocationData('district', $cur_bAdd->state);
			
			$save['bill'] = $cur_bAdd->id;
		}
		else
		{
			$cur_bAdd->id = 0;
		}
		$opt[] = JHTML::_('select.option', 'new', '- ' . JText::_("Add new") . ' -');
		$bAdd = JHTML::_('select.genericlist', $opt, 'changeBillAddr', 'class="inputbox" style="width: 100%;"
					onchange="changeAddr(this.value, \'Bill\', \'' . $cur_bAdd->id . '\', \'' . ($ship_addresses ? $ship_addresses[0]->id : 0) . '\')"', 'value', 'text', (isset($address['bill']) ? $address['bill'] : $cur_bAdd->id));
		$opt = array();
		$opt[] = JHTML::_('select.option', 0, '- ' . JText::_("Change address") . ' -');
		
		if (count($ship_addresses) > 0 && $tangible)
		{
			foreach($ship_addresses as $row)
			{
				settype($row, 'object');
				$val = array();
				
				if (intval($row->country))
					$row->country = $model->getLocationData('country', $row->country);
				if (intval($row->city))
					$row->city = $model->getLocationData('city', $row->city);
				if (intval($row->state))
					$row->state = $model->getLocationData('district', $row->state);
				
				if ($row->name)
					$val[] = $row->name;
				if ($row->country)
					$val[] = $row->country;
				if ($row->city)
					$val[] = $row->city;
				if ($row->state)
					$val[] = $row->state;
				if ($row->address)
					$val[] = $row->address;
				if ($row->zip)
					$val[] = $row->zip;
				if ($row->tel)
					$val[] = $row->tel;
				
				$opt[] = JHTML::_('select.option', $row->id, implode(", ", $val));
			}
			$cur_sAdd = (isset($address['ship'])) ? $model->getAddresses('ship', $address['ship']) : $ship_addresses[0];
			/*if(intval($cur_sAdd->country)) $cur_sAdd->country = $model->getLocationData('country', $cur_sAdd->country);
			 if(intval($cur_sAdd->city)) $cur_sAdd->city = $model->getLocationData('city', $cur_sAdd->city);
			 if(intval($cur_sAdd->state)) $cur_sAdd->state = $model->getLocationData('district', $cur_sAdd->state);
			 */			$save['ship'] = $cur_sAdd->id;
		}
		else
		{
			$cur_sAdd->id = 0;
		}
		$opt[] = JHTML::_('select.option', 'new', '- ' . JText::_("Add new") . ' -');
		$sAdd = JHTML::_('select.genericlist', $opt, 'changeShipAddr', 'class="inputbox" style="width: 100%;"
					onchange="changeAddr(this.value, \'Ship\', \'' . $cur_bAdd->id . '\', \'' . $cur_sAdd->id . '\')"', 'value', 'text', (isset($address['ship']) ? $address['ship'] : $cur_sAdd->id));
		
		if ($user->id)
			$session->set('address', $save);
		
		// checking if the product is tangible (or order has it's weight) and requires shipping
		

		$show_ship = false;
		if ($tangible)
			$show_ship = true;
		
		$default = $out = '';
		$out = '<option value="0">' . JText::_("Select Country") . '</option>';
		foreach($countries as $country)
		{
			$selected = ($default == $country->id) ? 'selected' : '';
			$out .= '<option value="' . $country->id . '" ' . $selected . '>' . addslashes($country->name) . '</option>';
		}
		$country_list = '<select class="inputbox" name="country"
		onchange="xajax_jcSelectShipLocation(\'\', \'city\', this.value, \'\')" id="country">' . $out . '</select>';
		/*JHTML::_('select.genericlist', $opt, 'country',
		 'class="inputbox" style="width: 100%;"  onchange="xajax_jcSelectShipLocation(\'billto\', \'city\', this.value, \'\')', 'value', 'text', $bill['country'], 'country');
		 */
		$country_list_ship = '<select class="inputbox" name="ship_country"
		onchange="xajax_jcSelectShipLocation(\'ship_\', \'city\', this.value, \'\')" id="ship_country">' . $out . '</select>';
		
		$this->assign('country', $country_list);
		$this->assign('countryShip', $country_list_ship);
		$this->assign('show_ship', $show_ship);
		$this->assign('cur_bAdd', $cur_bAdd);
		$this->assign('cur_sAdd', $cur_sAdd);
		$this->assign('bAdd', $bAdd);
		$this->assign('sAdd', $sAdd);
		$this->assign('show_unr_bill', $show_unr_bill);
		$this->assign('show_unr_ship', $show_unr_ship);
		$this->assign('bill', $bill);
		$this->assign('ship', $ship);
		
		parent::display($tpl);
	}

	function _tableAddresses($tpl)
	{
		parent::display($tpl);
	}

	function _formLogin($tpl)
	{
		$menu = & JSite::getMenu();
		$item = $menu->getActive();
		$sess = & JFactory::getSession();
		$Itemid = JRequest::getInt('Itemid');
		$url = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
		$url = base64_encode(JRoute::_($url, false));
		$document = &JFactory::getDocument();
		$document->addScript(JURI::root() . "components/com_commerce/js/email_validation.js");
		
		$this->assignRef('url', $url);
		parent::display($tpl);
	
	}

}

?>