<?php
/**
 * $Id: view.html.php 7817 2012-02-16 05:39:36Z alfiya $
 * $LastChangedDate: 2012-02-16 11:39:36 +0600 (Thu, 16 Feb 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');
class CommerceViewCartTemplate extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $ICONS, $TB, $Itemid;

		$model  = & $this->getModel('carttemplate');
		$user   = & JFactory::getUser();
		$db   	= & JFactory::getDBO();
		$option = JRequest::getWord('option', 'com_commerce');
		$uri  = JFactory::getURI();
		$document	= &JFactory::getDocument();
		$dispatcher =& JDispatcher::getInstance();
		$pathway	     = & $mainframe->getPathway();
		$session = & JFactory::getSession();
		$layout = JRequest::getVar('layout');
		$user_id = JRequest::getInt('user_id');
		
		if(!$user->id)
		{
			$document->addScript("/includes/js/joomla.javascript.js");
		}

		if($layout == 'form')
		{
			$this->displayForm($tpl);
			return;
		}
		if($layout == 'details')
		{
			$this->displayDetails($tpl);
			return;
		}

		$model_order  = JModel::getInstance('Orders', 'CommerceModel');

		if($user_id && $user->id == $user_id)
		{
			// create toolbar
			$TB->cpanel('cpanel', JText::_('CPanel'));
			$TB->editList('edit_carttemplate', JText::_('Edit'));
			$TB->delete('jc_cart_templates', 1);
		}
		if($user->id)
		$TB->custom('show_my', 'carttemplate', 'carttemplate', JText::_('My templates'), false);
		$TB->help('carttemplate', 'com_commerce');


		$title = JText::_('Cart templates list');

		$pathway->addItem( $title, '' );

		$context          = "$option.view_carttemplate";
		$filter_order     = $mainframe->getUserStateFromRequest( "$context.filter_order", 	'filter_order', 	't.ctime' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "$context.filter_order_Dir",	'filter_order_Dir',	'DESC' );
		$filter_section     = $mainframe->getUserStateFromRequest( "$context.filter_section", 	'filter_section',  COMM_SECTION_ID );
		$filter_search		= $mainframe->getUserStateFromRequest( "$context.filter_search", 	'filter_search', '', 'string' );
		$filter_search		= JString::strtolower( $filter_search );

		$limit      = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		$cart = $session->get('my_cart'.'-'.COMM_SECTION_ID);

		$rows = $model->getTemplateList($user_id, true);
		$total = count($model->getTemplateList($user_id));

		$API = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
		if(file_exists($API))
		{
			require_once $API;
		}
		$juser = JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'juser.php';
		$CB = JPATH_ROOT.DS.'components'.DS.'com_comprofiler'.DS.'comprofiler.php';

		foreach ($rows as $k => $item)
		{
			$products = unserialize($item->details);
			if(count($products))
			{
				foreach ($products as $seller => $row)
				{
					foreach ($row as $i => $val)
					{
						$art = $model->getArticleInfo($val->article);
						$rows[$k]->products[] = JHTML::link($val->link, $art->title, 'target="_blank" class="small"');
					}
				}
			}
			else
			$rows[$k]->products = array();

			$rows[$k]->uname = $item->uname;
			switch(COMM_GENERAL_PROFILE)
			{
				case 'com_juser':
					if(file_exists($juser))
					{
						$ulink = 'index.php?option=com_juser&view=userlist&layout=profile&id='.$item->user_id .'&Itemid='.$Itemid;
						$rows[$k]->uname = JHTML::link(JRoute::_($ulink, false), $item->uname);
					}
					break;
				case 'com_community':
					if(class_exists('JSCommunityApi')) {
						$rows[$k]->uname = JSCommunityApi::getUserSlideMenu($item->user_id, $item->uname);
					}
					break;
				case 'com_comprofiler':
					if(file_exists($CB))
					{
						$ulink = 'index.php?option=com_comprofiler&task=userProfile&user=' . $item->user_id .'&Itemid='.$Itemid;
						$rows[$k]->uname = JHTML::link(JRoute::_($ulink, false), $item->uname);
					}
					break;
			}


		}

		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		$filter['search'] = $filter_search;
		$filter['section'] = $model_order->getCommercialSections(COMM_SECTION_ID);
		$filter['enable'] = true;

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );


		$this->assignRef('title', $title);
		$this->assignRef('user', $user);
		$this->assignRef('rows', $rows);
		$this->assignRef('uri', $uri->toString());
		$this->assignRef('lists',	$lists);
		$this->assignRef('filter',	$filter);
		$this->assignRef('bar',	$TB);
		$this->assignRef('pageNav', $pageNav);

		parent::display();
	}

	function displayForm($tpl)
	{
		global $mainframe, $TB;
		$session = & JFactory::getSession();
		$user   =& JFactory::getUser();
		$uri  = JFactory::getURI();
		
		if(!$user->id)
		{
			$return = JRoute::_($uri->toString(), false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($return), false), 
				JText::_('Please log in to continue'), 'Error');
		}
		
		$model  = JModel::getInstance('Cart', 'CommerceModel');
		$option = JRequest::getWord('option', 'com_commerce');
		$pathway    = & $mainframe->getPathway();
		$pathway->addItem( JText::_("Cart template"), '' );
		$dispatcher =& JDispatcher::getInstance();


		if($id = JRequest::getVar("cid"))
		{
			$id = $id[0];
			$row =& JTable::getInstance('carttemplate', 'commerce');
			$row->load( $id );
			if($user->id != $row->user_id)
			{
				$link = 'index.php?option=com_commerce&view=carttemplate&section_id='.COMM_SECTION_ID.'&Itemid='.((COMM_CARTTEMPLATE_ITEMID != "") ? COMM_TAX_ITEMID : JRequest::getInt('Itemid'));
				$mainframe->redirect(JRoute::_($link, false), JText::_('You have no access to edit the template'), 'Error');
			}
			$cart = unserialize($row->details);
		}
		else
		{
			$cart = $session->get('my_cart'.'-'.COMM_SECTION_ID);
			$row->name = '';
			$row->description = '';
		}

		if($id)
		$TB->custom('save_as_cart', 'cart', 'cart', JText::_('As my cart'), false);
		$TB->save('save_template', JText::_('Save'));
		$TB->apply('apply_template', JText::_("Apply"));
		$TB->_cancel('cancel', JText::_('Cancel'));

		$model_order  = JModel::getInstance('Orders', 'CommerceModel');

		$context          = "$option.view_carttemplate";
		$filter_section     = $mainframe->getUserStateFromRequest( "$context.filter_section", 	'filter_section',  COMM_SECTION_ID );
		$filter['section'] = $model_order->getCommercialSections(COMM_SECTION_ID);

		$core = getCore();

		$sum = array();
		if($cart)
		{
			foreach ( $cart as $seller_id => $items )
			{
				$sum[$seller_id] = 0;
				foreach ( $items as $k => $item )
				{
					$field = $model->getFieldValue($item->article);
					$price = $field->field_value;
					$price_ext = $model->getPriceExtra($field->field_id, $item->article);
	
					JPluginHelper::importPlugin('joomsuite_content_fields', 'price');
					$dispatcher->trigger('onGetItemPrice', array (&$price, $item->article, $item->items_num, 'user', false));
	
					$currency = (isset($price_ext->currency)) ? $price_ext->currency : false;
	
					$mark = ($currency ? $currency->mark : $core->mark );
	
					$tax = (isset($price_ext->tax)) ? $price_ext->tax : false;
	
					$price = round($price, 2);
					$price_core = ($currency ) ? round($price / $currency->rate, 2) : $price ;
	
					$art_info = $model->getArticleInfo($item->article);
	
					$cart[$seller_id][$k]->title = $art_info->title;
	
					$sum[$seller_id] += $cart[$seller_id][$k]->total = round($price_core * $item->items_num, 2);
					$cart[$seller_id][$k]->total = str_replace(array("00", "Sign"), array($cart[$seller_id][$k]->total, $core->mark), COMM_LAYOUT_PRICE);
	
					$cart[$seller_id][$k]->price = str_replace(array("00", "Sign"), array(($price ? $price : 0), $mark), (isset($currency->format) ? $currency->format : COMM_LAYOUT_PRICE));
					$cart[$seller_id][$k]->price_core = str_replace(array("00", "Sign"), array($price_core, $core->mark), COMM_LAYOUT_PRICE);
	
					/*$return = base64_encode($uri->toString());
					
					$cart[$seller_id][$k]->remove = '<a class="removeLink" href="' . JRoute::_($uri->toString() . '&return=' . $return . '&cart_item_remove=' . $seller_id . '::' . $k) . '"
					onClick=\'if(!confirm("' . JText::_('Remove item?') . '")) return;\'>
					<img src="' . JURI::root() . 'components/com_commerce/images/remove.png" alt="' . JText::_('Remove') . '"></a>';
					*/
					
					
					$cart[$seller_id][$k]->remove = '<a class="removeLink"
							onClick=\' if(confirm("'.JText::_('Remove item?').'")) removeItem("'.$seller_id.'::'.$k.'");\'>
							<img src="'.JURI::root().'components/com_commerce/images/remove.png" alt="'.JText::_('Remove').'"></a>';
					
					/*
					 * $uri->setVar( 'cart_item_remove', $k+1 );
					 $cart[$k]->remove = '<a class="removeLink"
					 onClick=\' if(confirm("'.JText::_('Remove item?').'")) document.location.replace("'.JRoute::_( $uri->toString(), false ).'");\'>
					 <img src="'.JURI::root().'components/com_commerce/images/remove.png" alt="'.JText::_('Remove').'"></a>';
					 $uri->delVar('cart_item_remove');
					 */
				}
				$sum[$seller_id] = str_replace(array("00", "Sign"), array($sum[$seller_id], $core->mark), COMM_LAYOUT_PRICE);
			}
			
			$row->total = str_replace(array("00", "Sign"), array(array_sum($sum), $core->mark), COMM_LAYOUT_PRICE);
		}
		$lists['share'] = JHTML::_('select.booleanlist', 'share', 'class="inputbox"', (isset($row->share) ? $row->share : 0) );

		$this->assignRef('title', JText::_('Cart template'));
		$this->assignRef('url', $uri);
		$this->assignRef('items', $cart);
		$this->assignRef('lists', $lists);
		$this->assignRef('sum', $sum);
		$this->assignRef('id', $id);
		$this->assignRef('row', $row);
		$this->assignRef('user', $user);
		$this->assignRef('filter',	$filter);
		$this->assignRef('bar',	$TB);

		parent::display($tpl);
	}

	function displayDetails($tpl)
	{
		global $mainframe, $TB;
		$session = & JFactory::getSession();
		$user   =& JFactory::getUser();
		$model  = JModel::getInstance('Cart', 'CommerceModel');
		$option = JRequest::getWord('option', 'com_commerce');
		$uri  = JFactory::getURI();
		$pathway    = & $mainframe->getPathway();
		$pathway->addItem( JText::_("Cart template details"), '' );
		$user_id = JRequest::getInt('user_id');
		$link = 'index.php?option=com_commerce&view=carttemplate&section_id='.COMM_SECTION_ID;
		if($user_id)
		$link .= '&user_id='.$user_id;
		$link .='&Itemid='.((COMM_CARTTEMPLATE_ITEMID != "") ? COMM_TAX_ITEMID : JRequest::getInt('Itemid'));
			
		$id = JRequest::getInt("id");
		if(!$id)
		{
			$mainframe->redirect(JRoute::_($link, false), JText::_('Cart template id is not set') , 'Notice');
		}

		$row =& JTable::getInstance('carttemplate', 'commerce');
		$row->load( $id );
		if($row->name == '')
		$mainframe->redirect(JRoute::_($link, false), JText::_('Template does not exist'), 'Notice');

		if(!$row->share)
		{
			$uri->delVar('layout');
			$uri->delVar('id');
			$mainframe->redirect(JRoute::_($uri->toString(), false), JText::_('You have no access to the template'), 'Error');
		}

		$cart = unserialize($row->details);
		$name = $row->name;

		$model_order  = JModel::getInstance('Orders', 'CommerceModel');

		$core = getCore();

		$sum = array();
		if($cart)
		{
			foreach ( $cart as $seller_id => $items )
			{
				$sum[$seller_id] = 0;
				foreach ( $items as $k => $item )
				{
					$field = $model->getFieldValue($item->article);
					$price = $field->field_value;
					$price_ext = $model->getPriceExtra($field->field_id, $item->article);
	
					$currency = (isset($price_ext->currency)) ? $price_ext->currency : false;
	
					$mark = ($currency ? $currency->mark : $core->mark );
	
					$tax = (isset($price_ext->tax)) ? $price_ext->tax : false;
					if($currency)
					{
						$price *= $currency->rate;
					}
					$price = round($price, 2);
					$price_core = ($currency ) ? round($price / $currency->rate, 2) : $price ;
	
					$art_info = $model->getArticleInfo($item->article);
	
					$cart[$seller_id][$k]->title = $art_info->title;
	
					$sum[$seller_id] += $cart[$seller_id][$k]->total = round($price_core * $item->items_num, 2);
					$cart[$seller_id][$k]->total = str_replace(array("00", "Sign"), array($cart[$seller_id][$k]->total, $core->mark), COMM_LAYOUT_PRICE);
	
					$cart[$seller_id][$k]->price = str_replace(array("00", "Sign"), array(($price ? $price : 0), $mark), (isset($currency->format) ? $currency->format : COMM_LAYOUT_PRICE));
					$cart[$seller_id][$k]->price_core = str_replace(array("00", "Sign"), array($price_core, $core->mark), COMM_LAYOUT_PRICE);
	
				}
				$sum[$seller_id] = str_replace(array("00", "Sign"), array($sum[$seller_id], $core->mark), COMM_LAYOUT_PRICE);
			}
			
			$row->total = str_replace(array("00", "Sign"), array(array_sum($sum), $core->mark), COMM_LAYOUT_PRICE);
		}
		else
		$mainframe->redirect(JRoute::_($link), JText::_('Cart template does not contain any products') );

		$this->assignRef('title', JText::_('Cart template details'));
		$this->assignRef('url', $uri);
		$this->assignRef('items', $cart);
		$this->assignRef('sum', $sum);
		$this->assignRef('row', $row);

		parent::display($tpl);
	}


}

?>