<?php
/**
 * $Id: view.html.php 7988 2012-03-27 06:14:52Z alfiya $
 * $LastChangedDate: 2012-03-27 12:14:52 +0600 (Tue, 27 Mar 2012) $
 * $LastChangedBy: alfiya $
 * MightyCommerce by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.view');

class CommerceViewOrders extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $TB, $Itemid, $ICONS;
		$layout = $this->getLayout();
		$user = & JFactory::getUser();
		$uri = JFactory::getURI();
		$document = &JFactory::getDocument();
		$model = & $this->getModel('orders');
		$db = & JFactory::getDBO();
		$option = JRequest::getVar('option', 'com_commerce');
		$user_type = JRequest::getString('user_type');
		$layout = JRequest::getVar('layout');
		$order_id = JRequest::getInt('order_id');
		
		$TB->custom('export', 'export', null, 'Export', false, false);
		
		if (!$user->id && $layout == '')
		{
			$cpanel = JRoute::_('index.php?option=com_commerce&view=cpanel&Itemid=' . JRequest::getInt('Itemid'), false);
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&return=' . base64_encode(JRoute::_($uri->toString(), false)), false), JText::_('You are not authorized to see that page'), 'Error');
		}
		
		if (!$user->id && $layout != 'details' && $layout != 'alert' && !JRequest::getString('result_pay') && $layout != 'invoice' && $layout != 'invoicebill')
		{
			$mainframe->redirect(JRoute::_('index.php?option=com_commerce&view=orders&layout=details&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PURCHASEHIST_ITEMID != '') ? COMM_PURCHASEHIST_ITEMID : JRequest::getInt("Itemid")), false));
		}
		
		if ($layout == 'purchase')
		{
			$this->_displayPurchase($tpl);
			return;
		}
		if ($layout == 'alert')
		{
			$this->_displayAlert($tpl);
			return;
		}
		if ($layout == 'details')
		{
			$this->_displayDetails($tpl);
			return;
		}
		
		if ($layout == 'invoice')
		{
			$this->_displayInvoice($tpl);
			return;
		}
		
		if ($layout == 'invoicebill')
		{
			$this->_displayInvoiceBill($tpl);
			return;
		}
		
		$title = JText::_("Sales history");
		$pathway = & $mainframe->getPathway();
		$pathway->addItem($title, '');
		
		$API = JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'api.php';
		if (file_exists($API))
		{
			require_once $API;
		}
		$document->addScript(JURI::root() . "components/com_commerce/helpers/shadowbox/build/adapter/shadowbox-base.js");
		$document->addScript(JURI::root() . "components/com_commerce/helpers/shadowbox/build/shadowbox.js");
		$document->addScript(JURI::root() . 'media/mightyextensions/js/felix_js/library.js');
		$document->addScript(JURI::root() . 'media/mightyextensions/js/felix_js/pop_up.js');
		$document->addScriptDeclaration("var commerce_popUp = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );");
		
		$context = "$option.view_orders";
		$filter_order = $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', (($order_id) ? 'pr.id' : 'ord.id'));
		$filter_order_Dir = $mainframe->getUserStateFromRequest("$context.filter_order_Dir", 'filter_order_Dir', 'DESC');
		$filter_section = $mainframe->getUserStateFromRequest("$context._default_filter_section", 'filter_section', COMM_SECTION_ID);
		$filter_status = $mainframe->getUserStateFromRequest($context . '_default_filter_status', 'status', 0);
		
		$limit = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		$total = 0;
		$final = $model->getStatusFinal();
		
		$statuses = $model->getStatusList();
		$core = getCore();
		
		/*
		 * SALES history layout ****************************************************
		 */
		
		if ($layout == '' || $layout == 'default')
		{
			$dispatcher = & JDispatcher::getInstance();
			
			$products = $model->getBuyerOrders($user->id);
			if ($products)
			{
				$menu = JRoute::_('index.php?option=com_commerce&view=orders&layout=purchase&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PURCHASEHIST_ITEMID != '') ? COMM_PURCHASEHIST_ITEMID : JRequest::getInt("Itemid")), false);
				$menu = JHTML::link($menu, JText::_("Purchases history"));
			}
			
			$history = '';
			
			if ($order_id)
			{
				$title = JText::_('Products of') . " " . JText::_('Order Num.') . " $order_id";
				
				$history = $model->getInboxHistory($order_id, $layout); /* with inbox api */
				
				$lists = $model->getSellerOrders($user->id, $order_id);
				
				foreach($lists as $k => $item)
				{
					if (!$item->product_id)
					{
						unset($lists[$k]);
						continue;
					}
					$lists[$k]->total = ($item->price * $item->amount);
					$lists[$k]->total += $item->tax;
					$lists[$k]->total -= $item->discount;
					$lists[$k]->shipping_sum = 0;
					$lists[$k]->shipping = '';
					$item_ship = new JParameter($item->extra);
					/*if($item_ship = $item_ship->get('shipping'))
					{
						$item_ship = unserialize($item_ship);
						$ship = explode('::', $item_ship['info']);
						$lists[$k]->shipping = JText::_('Shipping').' ('.$ship[0].', '.$ship[1].'; '.JText::_('weight').': '.$item_ship['weight'].' '.JText::_('kg').')';
						$lists[$k]->shipping_sum = $item_ship['sum'];
						$lists[$k]->total += $item_ship['sum'];
					}*/
					$props = $model->getOrderProductProperty($item->id);
					if ($props)
					{
						$property = array();
						foreach($props as $prop)
						{
							JPluginHelper::importPlugin('joomsuite_content_fields', $prop->type);
							$dispatcher->trigger('onRenderPropertyValue', array(&$prop->type, &$prop->value));
							if (floatval($prop->price) > 0)
							{
								if (!strstr($prop->price, '+'))
									$prop->price = '+' . $prop->price;
							}
							$property[] = '<br>' . $prop->value . ' (' . $prop->price . ')';
						}
						$lists[$k]->property = implode(", ", $property);
					
					}
				
				}
				$shipping = $model->getShipping($order_id, $user->id);
				if ($shipping)
				{
					$item_ship = new JParameter($shipping->extra);
					if ($item_ship = $item_ship->get('shipping'))
					{
						$item_ship = unserialize($item_ship);
						$ship = explode('::', $item_ship['info']);
						$shipping = null;
						$shipping->info = JText::_('Products delivery from vendor') . ' ' . $user->name . ' (' . $ship[0] . ', ' . $ship[1] . '; ' . JText::_('weight') . ': ' . $item_ship['weight'] . ' ' . JText::_('kg') . ')';
						$shipping->sum = $item_ship['sum'];
					}
				}
				$tpl = 'productlist';
			}
			else
			{
				$orders = $model->getSellerOrders($user->get('id'), false, true, true);
				$total = count($model->getSellerOrders($user->get('id')));
				$juser = JPATH_ROOT . DS . 'components' . DS . 'com_juser' . DS . 'juser.php';
				$CB = JPATH_ROOT . DS . 'components' . DS . 'com_comprofiler' . DS . 'comprofiler.php';
				foreach($orders as $i => $order)
				{
					$orders[$i]->unshipped = 0;
					$items = $model->getSellerOrders($user->get('id'), $order->id);
					$products = array();
					foreach($items as $item)
					{
						if ($item->product_id)
						{
							$article = $model->getArticleInfo($item->product_id);
							$products[] = JHTML::link($item->product_link, $article->title);
						}
						if ($item->status_id != $final->id)
							$orders[$i]->unshipped ++;
					}
					$orders[$i]->items = implode(", ", $products);
					if ($order->user_id)
					{
						$buyer = & JFactory::getUser($order->user_id);
						$orders[$i]->user = $buyer->name;
						
						switch (COMM_GENERAL_PROFILE)
						{
							case 'com_juser' :
								if (file_exists($juser))
								{
									$ulink = 'index.php?option=com_juser&view=userlist&layout=profile&id=' . $order->user_id . '&Itemid=' . $Itemid;
									$orders[$i]->user = JHTML::link(JRoute::_($ulink, false), $buyer->name);
								}
								break;
							case 'com_community' :
								if (class_exists('JSCommunityApi'))
								{
									$orders[$i]->user = JSCommunityApi::getUserSlideMenu($order->user_id, $buyer->name);
								}
								break;
							case 'com_comprofiler' :
								if (file_exists($CB))
								{
									$ulink = 'index.php?option=com_comprofiler&task=userProfile&user=' . $order->user_id . '&Itemid=' . $Itemid;
									$orders[$i]->user = JHTML::link(JRoute::_($ulink, false), $buyer->name);
								}
								break;
						}
					}
					else
					{
						$orders[$i]->user = $order->email;
					}
				
				}
				$statuses = $model->getOrderStatuses();
				$model_balance = &JModel::getInstance('balance', 'CommerceModel');
				$balance = $model_balance->getCurrentBalance($user->id);
				$this->assign('balance', $balance);
			}
		}
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		// table ordering
		$filter['order'] = $filter_order;
		$filter['order_Dir'] = $filter_order_Dir;
		$filter['section'] = $model->getCommercialSections(COMM_SECTION_ID);
		$stat_list = $model->getOrderStatuses();
		$opt = array();
		$opt[] = JHTML::_('select.option', 0, '- ' . JText::_("Select from list") . ' -');
		foreach($stat_list as $stat)
		{
			$opt[] = JHTML::_('select.option', $stat->id, JText::_($stat->name));
		}
		$filter['status'] = JHTML::_('select.genericlist', $opt, "filter_status", 'class="inputbox"
		onchange="this.form.status.value=this.value; this.form.submit();"', 'value', 'text', $filter_status);
		
		$this->assignRef('pageNav', $pageNav);
		$this->assignRef('lists', $lists);
		$this->assignRef('filter', $filter);
		$this->assignRef('orders', $orders);
		$this->assignRef('shipping', $shipping);
		$this->assign('core', $core);
		$this->assign('uri', $uri);
		$this->assign('user', $user);
		$this->assign('history', $history);
		$this->assign('final', $final);
		$this->assign('statuses', $statuses);
		$this->assignRef('menu', $menu);
		$this->assignRef('bar', $TB);
		$this->assign('title', $title);
		parent::display($tpl);
	}

	function _displayPurchase($tpl)
	{
		global $mainframe, $TB, $Itemid, $ICONS;
		$layout = $this->getLayout();
		$user = & JFactory::getUser();
		$uri = JFactory::getURI();
		$model = & $this->getModel('orders');
		$model_cart = &JModel::getInstance('cart', 'CommerceModel');
		$db = & JFactory::getDBO();
		$option = JRequest::getVar('option', 'com_commerce');
		$order_id = JRequest::getInt('order_id');
		$session = &JFactory::getSession();
		
		$document = &JFactory::getDocument();
		$document->addScript(JURI::root() . "components/com_commerce/helpers/shadowbox/build/adapter/shadowbox-base.js");
		$document->addScript(JURI::root() . "components/com_commerce/helpers/shadowbox/build/shadowbox.js");
		$title = JText::_("Purchases history");
		$pathway = & $mainframe->getPathway();
		$pathway->addItem($title, '');
		
		$history = '';
		$context = "$option.view_orders";
		$filter_section = $mainframe->getUserStateFromRequest($context . '_purchase_filter_section', 'section_id', COMM_SECTION_ID);
		$filter_status = $mainframe->getUserStateFromRequest($context . '_purchase_filter_status', 'status', 0);
		$filter_order = $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', (($order_id) ? 'pr.id' : 'ord.id'));
		$filter_order_Dir = $mainframe->getUserStateFromRequest("$context.filter_order_Dir", 'filter_order_Dir', 'DESC');
		$limit = $mainframe->getUserStateFromRequest("$context.limit", 'limit', $mainframe->getCfg('list_limit'), 0);
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		$total = 0;
		$final = $model->getStatusFinal();
		
		$result_pay = JRequest::getString('result_pay');
		
		if (JRequest::getInt('inquired'))
		{
			$sql = "UPDATE #__jc_orders SET failed = '0' WHERE id = '$order_id'";
			$db->setQuery($sql);
			$db->query();
			$uri->delVar('inquired');
			$mainframe->redirect(JRoute::_($uri->toString(), false));
		}
		
		if ($result_pay)
		{
			if ($invoice_id = JRequest::getInt('result_sid'))
			{
				$sql = "UPDATE #__jc_orders SET invoice_id = '$invoice_id' WHERE id = '$order_id'";
				$db->setQuery($sql);
				$db->query();
			
			}
			$status_id = ($result_pay == 'success') ? $final->id : 1;
			
			switch ($result_pay)
			{
				case 'success' :
					$order_status = 11;
					$status_id = 5;
					break;
				case 'fail' :
					$order_status = 13;
					$status_id = 3;
					break;
				case 'offline' :
					$order_status = 10;
					$status_id = 1;
					break;
			}
			
			$sql = "UPDATE #__jc_orders SET status_id = '$order_status' WHERE id = '$order_id'";
			$db->setQuery($sql);
			$db->query();
			
			$cart = $session->get('my_cart' . '-' . COMM_SECTION_ID);
			
			$model->sendOrderDetails($user->id, $order_id, $result_pay);
			
			/*
			 * CHANGING the order products statuses and triggering the product types plugins
			 */
			
			if ($result_pay == 'offline')
			{
				$sql = "SELECT id FROM #__jc_orders_statuses WHERE name REGEXP 'offline'";
				$db->setQuery($sql);
				if ($status_id = $db->loadResult())
				{
					$sql = "UPDATE #__jc_orders_products SET status_id = '$status_id' WHERE order_id = '$order_id'";
					$db->setQuery($sql);
					$db->query();
				}
			}
			
			$model->sendUserAlert(JRequest::getString('result_user_id'), $status_id, $order_id);
			
			$lists = $model->getBuyerProducts(JRequest::getString('result_user_id'), $order_id);
			
			foreach($lists as $k => $item)
			{
				$tangible = $model_cart->isTangible($item->product_id);
				if (!$tangible)
					$model->updateOrderProductStatus($order_id, $item->product_id, ($item->price <= 0 ? $final->id : $status_id));
				else
				{
					if ($result_pay == 'success')
					{
						$model->updateOrderProductStatus($order_id, $item->product_id, 2);
						
						// update shipping status
						$model->updateOrderProductStatus($order_id, '0', $status_id);
					}
				}
				if ($result_pay == 'success' || $item->price <= 0)
				{
					if (!$tangible)
					{
						$sql = "SELECT ex.value, pr.status_id, f.params, ex.ref_id as plugin, ex.field_id, rec.user_id
						FROM #__jc_orders_products pr
						JOIN #__jc_orders ord ON pr.order_id = ord.id
						JOIN #__js_res_field_extra ex ON pr.product_id=ex.record_id
						JOIN #__js_res_fields f ON ex.field_id = f.id
						JOIN #__js_res_record rec ON ex.record_id = rec.id
						WHERE f.type='product_type'
						AND ex.record_id = '{$item->product_id}'
						AND ord.user_id = '" . $user->id . "' AND f.published = '1'
						AND ord.section_id = '" . COMM_SECTION_ID . "'
						GROUP BY  ex.ref_id";
						$db->setQuery($sql);
						if ($res = $db->loadObjectList())
						{
							$dispatcher = & JDispatcher::getInstance();
							foreach($res as $type)
							{
								JPluginHelper::importPlugin('joomsuite_product_type', $type->plugin);
								$prodvalue = explode("=", $type->value);
								if (isset($prodvalue[1]))
								{
									$dispatcher->trigger('onAfterSuccessOrder', array($type->plugin, $order_id, $item->product_id, $type->field_id, $type->value, JRequest::getString('result_user_id'), $item->amount));
								}
							}
						}
					}
				}
			}
			
			/*
			 * SAVING sellers' balance *****************************************
			 */
			
			$model_balance = &JModel::getInstance('balance', 'CommerceModel');
			switch ($result_pay)
			{
				case 'success' :
					$failed = 0;
					$shipping = $session->get('shipping-' . COMM_SECTION_ID);
								
					if (COMM_MULTI_SELLER)
					{
						$seller_id = JRequest::getInt('seller_id');
						
						if (!$seller_id)
						{
							$items = $model_balance->getOrderSellers($order_id, COMM_SECTION_ID);
							foreach($items as $item)
							{
								$credit = 0;
								$debit = 0;
								$current_balance = 0;
								$current_balance = $model_balance->getCurrentBalance($item->seller_id);
								$iseller = jcUser::getSeller($item->seller_id);
								
								$balance = round($item->balance, 2);
								
								$procent = COMM_PERCENTAGE;
								$transact = COMM_TRANSACTION;
								$com_min = COMM_COMM_MIN;
								$allow_negative = COMM_ALLOW_NEGATIVE;
								$neg_limit = COMM_NEGATIVE_LIMIT;
								if ($iseller->is_silver)
								{
									$procent = COMM_PERCENTAGE_SILVER;
									$transact = COMM_TRANSACTION_SILVER;
									$com_min = COMM_COMM_MIN_SILVER;
									$allow_negative = COMM_ALLOW_NEGATIVE_SILVER;
									$neg_limit = COMM_NEGATIVE_LIMIT_SILVER;
								}
								if ($iseller->is_gold)
								{
									$procent = COMM_PERCENTAGE_GOLD;
									$transact = COMM_TRANSACTION_GOLD;
									$com_min = COMM_COMM_MIN_GOLD;
									$allow_negative = COMM_ALLOW_NEGATIVE_GOLD;
									$neg_limit = COMM_NEGATIVE_LIMIT_GOLD;
								}
								if (COMM_PAYMENT_METHOD == 'personal')
								{
									$balance = round($balance * $procent / 100, 2) + $transact;
									if ($balance < $com_min)
									{
										$balance = $com_min;
										$procent = 0;
										$transact = $com_min;
									}
									$debit = $balance;
									$balance = $current_balance - $balance;
								}
								else
								{
									$commission = round($balance * $procent / 100, 2) + $transact;
									if ($commission < $com_min)
									{
										$commission = $com_min;
										$procent = 0;
										$transact = $com_min;
									}
									$balance = $balance - $commission;
									if(isset($shipping[$item->seller_id]))
									{
										$balance += $shipping[$item->seller_id]['sum'];
									}
									$credit = $balance;
									$balance = $current_balance + $balance;
								}
								$sql = "INSERT INTO #__jc_users_balance VALUES
								('', '{$item->seller_id}', NOW(), 'order', '$order_id', '$debit', '$credit', '$balance', '$procent', '$transact', '" . COMM_SECTION_ID . "')";
								$db->setQuery($sql);
								$db->query();
								$sql = "UPDATE #__jc_users SET balance_id='" . $db->insertid() . "' WHERE user_id = '{$item->seller_id}' AND section_id = '" . COMM_SECTION_ID . "'";
								$db->setQuery($sql);
								$db->query();
								$sql = "UPDATE #__jc_orders SET deducted='1' WHERE id = '$order_id'";
								$db->setQuery($sql);
								$db->query();
								
								if (($allow_negative && $balance <= $neg_limit) || (!$allow_negative && $balance <= 0))
								{
									$model_balance->sendNegativeBalanceAlert($item->seller_id);
								}
								
								if (COMM_PAYMENT_METHOD == 'global' && $balance >= COMM_POSITIVE_LIMIT)
								{
									$model->sendPositiveBalanceAlert($item->seller_id);
								}
							}
						}
						else
						{
							$if_seller = jcUser::getSeller($seller_id);
							$balance = JRequest::getFloat('balance');
							
							
							$procent = COMM_PERCENTAGE;
							$transact = COMM_TRANSACTION;
							$com_min = COMM_COMM_MIN;
							$allow_negative = COMM_ALLOW_NEGATIVE;
							$neg_limit = COMM_NEGATIVE_LIMIT;
							if ($if_seller->is_silver)
							{
								$procent = COMM_PERCENTAGE_SILVER;
								$transact = COMM_TRANSACTION_SILVER;
								$com_min = COMM_COMM_MIN_SILVER;
								$allow_negative = COMM_ALLOW_NEGATIVE_SILVER;
								$neg_limit = COMM_NEGATIVE_LIMIT_SILVER;
							}
							if ($if_seller->is_gold)
							{
								$procent = COMM_PERCENTAGE_GOLD;
								$transact = COMM_TRANSACTION_GOLD;
								$com_min = COMM_COMM_MIN_GOLD;
								$allow_negative = COMM_ALLOW_NEGATIVE_GOLD;
								$neg_limit = COMM_NEGATIVE_LIMIT_GOLD;
							}
							if ($balance < $com_min)
							{
								$balance = $com_min;
								$procent = 0;
								$transact = $com_min;
							}
							$sql = "SELECT SUM( ( price * amount) + tax - discount - refund) as balance
							FROM #__jc_orders_products WHERE order_id = '$order_id'";
							$db->setQuery($sql);
							$balance = $db->loadResult();
							$balance = (COMM_PAYMENT_METHOD == 'personal') ? round($balance * $procent / 100, 2) + $transact : $balance - round($balance * $procent / 100, 2) - $transact;
							
							if(COMM_PAYMENT_METHOD == 'global' && isset($shipping[$seller_id]) )
							{
								$balance += $shipping[$seller_id]['sum'];
							}
							
							$credit = 0;
							$debit = 0;
							$current_balance = 0;
							$current_balance = $model_balance->getCurrentBalance($seller_id, COMM_SECTION_ID);
							if (COMM_PAYMENT_METHOD == 'personal')
							{
								$debit = $balance;
								$balance = $current_balance - $balance;
							}
							else
							{
								$credit = $balance;
								$balance = $current_balance + $balance;
							}
							$sql = "INSERT INTO #__jc_users_balance VALUES
							('', '$seller_id', NOW(), 'order', '$order_id', '$debit', '$credit', '$balance', '$procent', '$transact', '" . COMM_SECTION_ID . "')";
							$db->setQuery($sql);
							$db->query();
							$sql = "UPDATE #__jc_users SET balance_id='" . $db->insertid() . "' WHERE user_id = '$seller_id' AND section_id = '" . COMM_SECTION_ID . "'";
							$db->setQuery($sql);
							$db->query();
							$sql = "UPDATE #__jc_orders SET deducted='1' WHERE id = '$order_id'";
							$db->setQuery($sql);
							$db->query();
							
							if (($allow_negative && $balance <= $neg_limit) || (!$allow_negative && $balance <= 0))
							{
								$model_balance->sendNegativeBalanceAlert($seller_id);
							}
							if (COMM_PAYMENT_METHOD == 'global' && $balance >= COMM_POSITIVE_LIMIT)
							{
								$model->sendPositiveBalanceAlert($seller_id);
							}
						}
					}
					
					$session->clear('my_cart-' . COMM_SECTION_ID);
					if ($session->get('my_cart_coupon-' . COMM_SECTION_ID))
						$session->clear('my_cart_coupon-' . COMM_SECTION_ID);
					if ($session->get('address'))
						$session->clear('address');
					if ($session->get('unreg_address'))
						$session->clear('unreg_address');
					if ($session->get('shipping-' . COMM_SECTION_ID))
						$session->clear('shipping-' . COMM_SECTION_ID);
					
					$msg = JText::_("Your order was successfully paid");
					$notice = '';
					if ($user->id)
						$lay = 'purchase';
					else
					{
						$lay = 'details';
						$sql = "SELECT email FROM #__jc_orders WHERE id='$order_id'";
						$db->setQuery($sql);
						$email = $db->loadResult();
						$session->set('customer', array('order_id' => $order_id, 'cemail' => $email));
					}
					$redirect = "index.php?option=com_commerce&view=orders&layout=$lay&order_id=" . $order_id . "&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : $Itemid);
					if (defined('COMM_REDIRECT_SUCCESS') && COMM_REDIRECT_SUCCESS != '')
						$redirect = COMM_REDIRECT_SUCCESS;
					
					break;
				
				case 'fail' :
					$failed = '1';
					$msg = JText::_("Your order payment was fail");
					$notice = 'Error';
					$lay = 'purchase';
					$redirect = "index.php?option=com_commerce&view=orders&layout=$lay&order_id=" . $order_id . "&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : $Itemid);
					if (defined('COMM_REDIRECT_FAIL') && COMM_REDIRECT_FAIL != '')
						$redirect = COMM_REDIRECT_FAIL;
					break;
				
				case 'offline' :
					$failed = 0;
					$msg = JText::_('Your offline request of order was made successfully');
					$link = JURI::root() . 'index.php?option=com_commerce&view=orders&layout=alert&order_id=' . $order_id . '&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : JRequest::getInt('Itemid'));
					JError::raiseNotice(100, JText::_('Please send Seller alert when you make money transfer, from order details page or following the link') . ' ' . JHTML::link($link, JText::_('here')));
					$notice = '';
					$lay = ($user->id) ? 'purchase' : 'details';
					$sql = "SELECT email FROM #__jc_orders WHERE id='$order_id'";
					$db->setQuery($sql);
					$email = $db->loadResult();
					$session->set('customer', array('order_id' => $order_id, 'cemail' => $email));
					$sql = "SELECT id FROM #__jc_orders_statuses WHERE name REGEXP 'offline'";
					$db->setQuery($sql);
					if ($status_id = $db->loadResult())
					{
						$sql = "UPDATE #__jc_orders_products SET status_id = '$status_id' WHERE order_id = '$order_id' and price + affect_sum > 0";
						$db->setQuery($sql);
						$db->query();
					}
					$session->clear('my_cart' . '-' . COMM_SECTION_ID);
					if ($session->get('my_cart_coupon' . '-' . COMM_SECTION_ID))
						$session->clear('my_cart_coupon' . '-' . COMM_SECTION_ID);
					if ($session->get('address'))
						$session->clear('address');
					if ($session->get('unreg_address'))
						$session->clear('unreg_address');
					if ($session->get('shipping-' . COMM_SECTION_ID))
						$session->clear('shipping-' . COMM_SECTION_ID);
					
					$redirect = "index.php?option=com_commerce&view=orders&layout=$lay&order_id=" . $order_id . "&section_id=" . COMM_SECTION_ID . "&Itemid=" . ((COMM_PRODUCTLIST_ITEMID != '') ? COMM_PRODUCTLIST_ITEMID : $Itemid);
					if (defined('COMM_REDIRECT_OFFLINE') && COMM_REDIRECT_OFFLINE != '')
						$redirect = COMM_REDIRECT_OFFLINE;
					break;
			}
			if ($gateway = JRequest::getString('result_gateway'))
			{
				$sql = "UPDATE #__jc_orders
				SET gateway='" . $gateway . "', gateway_id = '" . JRequest::getString('result_gateway_id') . "', pay = '{$result_pay}'
				WHERE id = '$order_id'";
				$db->setQuery($sql);
				$db->query();
			}
			if (COMM_CART == 'balance' && !$failed)
			{
				$customer = $model_balance->getCustomerBalance($user->id);
				$row = & JTable::getInstance("CustomersBalance", 'Commerce');
				
				$vals = array();
				$vals['user_id'] = $user->id;
				$vals['type'] = 'order';
				$vals['order_id'] = $order_id;
				$vals['balance'] = $customer->balance - JRequest::getFloat('result_price');
				$vals['section_id'] = COMM_SECTION_ID;
				
				if (!$row->bind($vals))
				{
					JError::raiseWarning(500, $row->getError());
				}
				if (!$row->check())
				{
					JError::raiseWarning(500, $row->getError());
				}
				
				if (!$row->store())
				{
					JError::raiseWarning(500, $row->getError());
				}
			}
			
			$mainframe->redirect($redirect, $msg, $notice);
		}
		
		/*
		 * PURCHASES history layout
		 */
		
		$products = $model->getSellerOrders($user->id);
		
		if ($order_id)
		{
			$dispatcher = & JDispatcher::getInstance();
			$title = JText::_('Products of') . " " . JText::_('Order Num.') . " $order_id";
			
			$lists = $model->getBuyerProducts($user->id, $order_id);
			
			$history = $model->getInboxHistory($order_id, $layout); /* with inbox api */
			
			$shipping = array();
			$items = array();
			$p = 0;
			foreach($lists as $k => $item)
			{
				if ($item->product_id)
				{
					//$record = $model->getArticleInfo($item->product_id);
					//$item->title = $record->title;
					$item->total = ($item->price * $item->amount);
					$item->total += $item->tax;
					$item->total -= $item->discount;
					/*$lists[$k]->shipping_sum = 0;
					$lists[$k]->shipping = '';
					$item_ship = new JParameter($item->extra);
					if($item_ship = $item_ship->get('shipping'))
					{
						$item_ship = unserialize($item_ship);
						$ship = explode('::', $item_ship['info']);
						$lists[$k]->shipping = JText::_('Shipping').' ('.$ship[0].', '.$ship[1].'; '.JText::_('weight').': '.$item_ship['weight'].' '.JText::_('kg').')';
						$lists[$k]->shipping_sum = $item_ship['sum'];
						$lists[$k]->total += $item_ship['sum'];
					}*/
					$item->types = '';
					
					$sql = "SELECT ex.value, ex.field_value_id as fvid, ex.ip, pr.status_id, f.params, ex.ref_id as plugin, rec.user_id, st.isfinal, f.id as field_id
					FROM #__jc_orders_products pr
					JOIN #__jc_orders ord ON pr.order_id = ord.id
					JOIN #__js_res_field_extra ex ON pr.product_id=ex.record_id
					JOIN #__js_res_fields f ON ex.field_id = f.id
					JOIN #__js_res_record rec ON ex.record_id = rec.id
					JOIN #__jc_orders_statuses st ON st.id = pr.status_id
					WHERE f.type='product_type'
					AND ex.record_id = '" . (JRequest::getInt('record_id') ? JRequest::getInt('record_id') : $item->product_id) . "'
					AND ord.user_id = '" . $user->id . "' AND f.published = '1'
						AND st.isfinal = '1'
						GROUP BY  ex.ref_id ";
					$db->setQuery($sql);
					if ($res = $db->loadObjectList())
					{
						$types = array();
						
						foreach($res as $type)
						{
							JPluginHelper::importPlugin('joomsuite_product_type', $type->plugin);
							
							$type->params .= "\nfvid=" . $type->fvid . "\nip=" . $type->ip . "\nfield_id=" . $type->field_id;
							
							$out = $dispatcher->trigger('onOrderHistoryPrint', array($type->plugin, $order_id, $item->product_id, $type->value, $type->isfinal, $type->user_id, $type->params));
							
							foreach($out as $i => $val)
							{
								if ($val == '')
									unset($out[$i]);
							}
							if (count($out) > 0)
								$types[] = implode($out);
						}
						
						$item->types = implode("<br>", $types);
					}
					
					$props = $model->getOrderProductProperty($item->id);
					if ($props)
					{
						$property = array();
						foreach($props as $prop)
						{
							JPluginHelper::importPlugin('joomsuite_content_fields', $prop->type);
							$dispatcher->trigger('onRenderPropertyValue', array(&$prop->type, &$prop->value));
							if (floatval($prop->price) > 0)
							{
								if (!strstr($prop->price, '+'))
									$prop->price = '+' . $prop->price;
							}
							$property[] = '<br>' . $prop->value . ' (' . $prop->price . ')';
						}
						$item->property = implode(", ", $property);
					}
					$items[$item->seller_id][$p] = $item;
					$p ++;
				}
				else
				{
					if ($item->extra != '')
					{
						$item_ship = new JParameter($item->extra);
						if ($item_ship = $item_ship->get('shipping'))
						{
							$item_ship = unserialize($item_ship);
							$seller = JFactory::getUser($item->seller_id);
							$ship = explode('::', $item_ship['info']);
							$shipping[$item->seller_id]->info = JText::_('Products delivery from vendor') . ' ' . $seller->name . ' (' . $ship[0] . ', ' . $ship[1] . '; ' . JText::_('weight') . ': ' . $item_ship['weight'] . ' ' . JText::_('kg') . ')';
							$shipping[$item->seller_id]->sum = $item_ship['sum'];
						}
					}
				}
			}
			$orders = $model->getOrderInfo($order_id);
			$lists = $items;
			//$shipping = $model->getShipping($order_id);
			$tpl = 'productlist';
		}
		
		else
		{
			$orders = $model->getBuyerOrders($user->get('id'), true, true);
			
			$sales = $model->getSellerOrders($user->id);
			if ($sales)
			{
				$menu = 'index.php?option=com_commerce&view=orders&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_SALEHIST_ITEMID != '') ? COMM_SALEHIST_ITEMID : JRequest::getInt("Itemid"));
				$menu = JHTML::link($menu, JText::_("Sales history"));
			}
			$total = count($model->getBuyerOrders($user->get('id')));
			foreach($orders as $i => $order)
			{
				$orders[$i]->unshipped = 0;
				if ($order->invoice_id)
				{
					$sql = "SELECT id FROM #__bills_invoice WHERE id = '{$order->invoice_id}' AND published = '1'";
					$db->setQuery($sql);
					$orders[$i]->invoice_id = $db->loadResult();
				}
				$items = $model->getBuyerProducts($user->id, $order->id, 'title');
				
				$products = array();
				foreach($items as $item)
				{
					$products[] = JHTML::link($item->product_link, $item->title);
					if ($item->status_id != $final->id)
						$orders[$i]->unshipped ++;
				}
				//$shipping = $model->getShipping($order->id);
				

				$orders[$i]->items = implode(", ", $products);
			}
		}
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		$statuses = $model->getStatusList();
		$core = getCore();
		
		// table ordering
		$filter['order'] = $filter_order;
		$filter['order_Dir'] = $filter_order_Dir;
		$filter['section'] = $model->getCommercialSections(COMM_SECTION_ID);
		$stat_list = $model->getOrderStatuses();
		$opt = array();
		$opt[] = JHTML::_('select.option', 0, '- ' . JText::_("Select from list") . ' -');
		foreach($stat_list as $stat)
		{
			$opt[] = JHTML::_('select.option', $stat->id, JText::_($stat->name));
		}
		$filter['status'] = JHTML::_('select.genericlist', $opt, "filter_status", 'class="inputbox"
		onchange="this.form.status.value=this.value; this.form.submit();"', 'value', 'text', $filter_status);
		
		$this->assignRef('pageNav', $pageNav);
		$this->assignRef('lists', $lists);
		$this->assignRef('filter', $filter);
		$this->assignRef('orders', $orders);
		$this->assignRef('shipping', $shipping);
		$this->assign('history', $history);
		$this->assign('core', $core);
		$this->assign('uri', $uri);
		$this->assign('user', $user);
		$this->assign('final', $final);
		$this->assign('statuses', $statuses);
		$this->assignRef('menu', $menu);
		$this->assignRef('bar', $TB);
		$this->assign('title', $title);
		parent::display($tpl);
	}

	function _displayDetails($tpl)
	{
		global $mainframe, $TB, $Itemid, $ICONS;
		$uri = JFactory::getURI();
		$document = &JFactory::getDocument();
		$model = & $this->getModel('orders');
		$db = & JFactory::getDBO();
		$user = & JFactory::getUser();
		$document->addScript(JURI::root() . "components/com_commerce/js/email_validation.js");
		
		$title = JText::_("Order details");
		$pathway = & $mainframe->getPathway();
		$pathway->addItem($title, '');
		
		if ($user->id)
		{
			$mainframe->redirect(JRoute::_('index.php?option=com_commerce&view=orders&layout=purchase&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_PURCHASEHIST_ITEMID != '') ? COMM_PURCHASEHIST_ITEMID : JRequest::getInt('Itemid')), false));
		}
		$info = false;
		
		$error = '';
		$session = &JFactory::getSession();
		if ($customer = $session->get('customer'))
		{
			if ($model->checkCustomerOrder($customer['order_id'], $customer['cemail']))
			{
				$info = true;
			}
			else
			{
				$error = JText::_('Order ID / Email is not valid');
				$session->clear('customer');
			}
		}
		$this->assignRef('info', $info);
		$this->assign('title', $title);
		$this->assign('uri', $uri);
		$this->assign('error', $error);
		$this->assign('customer', $customer);
		parent::display($tpl);
	}

	function _displayAlert($tpl)
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$user = JFactory::getUser();
		$title = JText::_("Seller alert of money transfer is made");
		$pathway = & $mainframe->getPathway();
		$pathway->addItem(JText::_("Seller alert"), '');
		$order_id = JRequest::getInt('order_id');
		$this->assign('title', $title);
		$this->assign('uri', $uri);
		$this->assign('user', $user);
		$this->assign('order_id', $order_id);
		parent::display($tpl);
	}

	function _displayInvoice($tpl)
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$user = JFactory::getUser();
		$model = & $this->getModel('orders');
		$db = & JFactory::getDBO();
		$order_id = JRequest::getInt('order_id');
		$client = JRequest::getInt('client');
		$dispatcher = & JDispatcher::getInstance();
		$model_cart = &JModel::getInstance('cart', 'CommerceModel');
		$pathway = & $mainframe->getPathway();
		$pathway->addItem(JText::_("Invoice"), '');
		$commission = false;
		
		$sql = "SELECT ord.*, st.name as status FROM #__jc_orders ord
		JOIN #__jc_orders_statuses st ON st.id = ord.status_id
		WHERE ord.id = '$order_id' ";
		$db->setQuery($sql);
		$order = $db->loadObject();
		
		$customer = true;
		if ( !$order->user_id && !$client)
		{
			$session = &JFactory::getSession();
			if (!$session->get('customer'))
			{
				$link = 'index.php?option=com_commerce&view=orders&layout=details&section_id=' . COMM_SECTION_ID . '&Itemid=' . COMM_PURCHASEHIST_ITEMID;
				$mainframe->redirect(JRoute::_($link, false), JText::_('You cannot access the invoice'), 'Error');
			}
		}
		if(!$user->id && $order->user_id)
		{		
			$link = 'index.php?option=com_commerce&view=orders&layout=details&section_id=' . COMM_SECTION_ID . '&Itemid=' . COMM_PURCHASEHIST_ITEMID;
				$mainframe->redirect(JRoute::_($link, false), JText::_('You cannot access the invoice'), 'Error');	
		}
		
		if ($client)
		{
			$list = $model->getSellerOrders($user->id, $order_id);
		}
		else
			$list = $model->getBuyerProducts($user->id, $order_id);
		
		$invoice = $model->getInvoiceNumber($client, $user->id, $order_id);
		
		$params = '';
		if ($order->invoice_id)
		{
			$params = $model->getBillInvoiceParams($order->invoice_id);
		}
		
		$core = getCore();
		foreach($list as $i => $item)
		{
			if ($item->product_id)
			{
				$info = $model->getArticleInfo($item->product_id);
				$list[$i]->title = $info->title;
				$field = $model_cart->getFieldValue($item->product_id);
				$price = $field->field_value;
				$price_ext = $model_cart->getPriceExtra($field->field_id, $item->product_id);
				
				$props = $model->getOrderProductProperty($item->id);
				
				if ($props)
				{
					$property = array();
					foreach($props as $prop)
					{
						$prop->price = str_replace('+', '', $prop->price);
						JPluginHelper::importPlugin('joomsuite_content_fields', $prop->type);
						$dispatcher->trigger('onRenderPropertyValue', array(&$prop->type, &$prop->value));
						if ($price_ext && isset($price_ext->currency))
							$prop->price = round($prop->price / $price_ext->currency->rate, 2);
						$property[] = '<br>' . $prop->value . ' (' . str_replace(array('00', 'Sign'), array($prop->price, $core->mark), COMM_LAYOUT_PRICE) . ')';
					}
					$list[$i]->property = implode(", ", $property);
				}
			}
			else
			{
				$item_ship = new JParameter($item->extra);
				if ($item_ship = $item_ship->get('shipping'))
				{
					$item_ship = unserialize($item_ship);
					$seller = JFactory::getUser($item->seller_id);
					$ship = explode('::', $item_ship['info']);
					$list[$i]->title = JText::_('Products delivery from vendor') . ' ' . $seller->name . ' (' . $ship[0] . ', ' . $ship[1] . '; ' . JText::_('weight') . ': ' . $item_ship['weight'] . ' ' . JText::_('kg') . ')';
					$list[$i]->price = $item_ship['sum'];
					$list[$i]->amount = 1;
				}
			}
		}
		require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_jsbill' . DS . 'controllers' . DS . 'cnf.php');
		BillControllerCnf::initialyze();
		
		if ($client)
			$commission = $model->getCommission($order->id);
		
		$this->assignRef('uri', $uri);
		$this->assignRef('user', $user);
		$this->assignRef('list', $list);
		$this->assignRef('invoice', $invoice);
		$this->assignRef('order_id', $order_id);
		$this->assignRef('order', $order);
		$this->assignRef('params', $params);
		$this->assignRef('customer', $customer);
		$this->assignRef('commission', $commission);
		parent::display($tpl);
	}

	function _displayInvoiceBill($tpl)
	{
		global $mainframe;
		$id = JRequest::getInt('bill');
		$db = JFactory::getDBO();
		$pathway = & $mainframe->getPathway();
		$pathway->addItem(JText::_("Invoice"), '');
		
		$sql = "SELECT b.* , bi.*
		FROM #__bills b
		JOIN #__bills_invoice bi ON b.id = bi.bill_id
		WHERE bi.id = '{$id}'";
		$db->setQuery($sql);
		$row = $db->loadObject();
		
		$sql = "SELECT COUNT(*) FROM #__jc_users_balance WHERE section_id = '" . COMM_SECTION_ID . "' AND type='bill'";
		$db->setQuery($sql);
		$invoice = $db->loadResult();
		require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_jsbill' . DS . 'controllers' . DS . 'cnf.php');
		BillControllerCnf::initialyze();
		
		$uri = JFactory::getURI();
		$this->assignRef('uri', $uri);
		$this->assignRef('row', $row);
		$this->assignRef('invoice', $invoice);
		parent::display($tpl);
	}

}
?>
